#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.6 $
#
#   last change: $Author: khendricks $ $Date: 2001/07/19 19:21:39 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=.

PRJNAME=aspell
TARGET=aspell


.IF "$(GUI)"=="UNX"
MKDIR=mkdir -p
ZIP=zip -j -q
.ENDIF			# "$(GUI)"=="UNX"

# --- Settings -----------------------------------------------------

.INCLUDE :	settings.mk

.IF "$(BUILD_SOSL)"==""
all_target: ALLTAR MYTAR
.ELSE
all_target: ALLTAR MYTAR TG_DELIVER

TG_DELIVER: MYTAR
        $(DELIVER)
.ENDIF
# --- Files --------------------------------------------------------

TARFILE_NAME=aspell-.33.6.1

#patching
#PATCH_FILE_NAME=aspell_patch.diff
PATCH_FILE_NAME=aspell-.33.6.1.patch

.IF "$(GUI)"=="UNX"
CONFIGURE_DIR=.$/
#relative to CONFIGURE_DIR
CONFIGURE_ACTION=.$/configure
CONFIGURE_FLAGS=--libdir=$(SOLARVERSION)$/$(INPATH)/lib --includedir=$(SOLARVERSION)$/$(INPATH)/inc --enable-curses=-lncurses --enable-curses-include=/usr/local
BUILD_DIR=$(CONFIGURE_DIR)
BUILD_ACTION=make
.ENDIF			# "$(GUI)"=="UNX"

OUT2LIB= \
	$(BUILD_DIR)$/lib$/.libs$/libaspell.so \
	$(BUILD_DIR)$/pspell-module$/.libs$/libpspell_aspell.so
 
OUT2BIN= \
	$(BUILD_DIR)$/data$/en-american-aspell.pwli \
	$(BUILD_DIR)$/data$/en-american-med-aspell.pwli \
	$(BUILD_DIR)$/data$/en-aspell.pwli \
	$(BUILD_DIR)$/data$/en-british-aspell.pwli \
	$(BUILD_DIR)$/data$/en-british-med-aspell.pwli \
	$(BUILD_DIR)$/data$/en-canadian-aspell.pwli \
	$(BUILD_DIR)$/data$/en-canadian-med-aspell.pwli \
	$(BUILD_DIR)$/data$/american-med-only \
	$(BUILD_DIR)$/data$/american-med.multi \
	$(BUILD_DIR)$/data$/british-med-only \
	$(BUILD_DIR)$/data$/british-med.multi \
	$(BUILD_DIR)$/data$/canadian-med-only \
	$(BUILD_DIR)$/data$/canadian-med.multi \
	$(BUILD_DIR)$/data$/english-med-only \
	$(BUILD_DIR)$/data$/english-variant-0 \
	$(BUILD_DIR)$/data$/english-variant-1 \
	$(BUILD_DIR)$/data$/english-variant-2 \
        $(BUILD_DIR)$/data$/ASCII.dat \
        $(BUILD_DIR)$/data$/ASCII.map \
        $(BUILD_DIR)$/data$/SGML.map \
        $(BUILD_DIR)$/data$/english.dat \
        $(BUILD_DIR)$/data$/english_phonet.dat \
        $(BUILD_DIR)$/data$/iso8859-1.dat \
        $(BUILD_DIR)$/data$/iso8859-10.dat \
        $(BUILD_DIR)$/data$/iso8859-2.dat \
        $(BUILD_DIR)$/data$/iso8859-3.dat \
        $(BUILD_DIR)$/data$/iso8859-4.dat \
        $(BUILD_DIR)$/data$/iso8859-5.dat \
        $(BUILD_DIR)$/data$/iso8859-6.dat \
        $(BUILD_DIR)$/data$/iso8859-7.dat \
        $(BUILD_DIR)$/data$/iso8859-8.dat \
        $(BUILD_DIR)$/data$/iso8859-9.dat \
        $(BUILD_DIR)$/data$/koi8-f.dat \
        $(BUILD_DIR)$/data$/koi8-r.dat \
        $(BUILD_DIR)$/data$/standard.kbd \
        $(BUILD_DIR)$/data$/unicode.dat \
        $(BUILD_DIR)$/data$/viscii.dat

# OUT2INC= 

# --- perform some steps that would have been done during make install


MYTAR : build$/$(INPATH)$/so_predeliver
	+$(COPY) $(BIN)$/american-med.multi $(BIN)$/american.multi
	+$(COPY) $(BIN)$/british-med.multi $(BIN)$/british.multi
	+$(COPY) $(BIN)$/canadian-med.multi $(BIN)$/canadian.multi
	+$(ZIP) - $(BIN)$/* > $(MISC)$/aspell_dict.zip


# --- Targets ------------------------------------------------------

.INCLUDE : 	set_ext.mk
.INCLUDE :	target.mk
.INCLUDE :	tg_ext.mk




