rem #################################################################
rem OpenOffice 638 build environment file for: WINNT. 
rem This is a sample environment file for Windows NT.
rem Run this file to set up the build environment. 
rem Please enter the following:
rem
rem 	SRC_ROOT   - Absolute path of the OpenOffice source tree
rem 		     for example C:\OpenOffice
rem 	JAVA_HOME  - Absolute path of the JDK distribution directory 
rem		     for example C:\JDK1.3.1
rem     PERL_PATH  - Absolute path of the Perl binary directory
rem                  for example C:\Perl
rem	STLPORT4   - Absolute path to your STLport 4.0 installation 
rem                  directory, for example C:\STLport-4.0
rem     ASM_PATH   - Absolute path to your assembler compiler ml.exe
rem                  for example C:\ml
rem     UNZIP_PATH - Absolute path to your unzip.exe tool, 
rem                  for example C:\unzip
rem 	COMPATH    - Absolute path of the Visual C/C++ compiler distribution
rem                  for example C:\progra~1\micros~1\vc98
rem                  NOTE: The path must be in MS-DOS format.
rem	CYGWIN     - Absolute path of the installed Cygnus Toolkit bin 
rem                  directory 
rem                  for exmaple: C:\cygnus\CYGWIN~1\H-I586~1\bin
rem
rem	You may also need to amend the PATH variable below
rem #################################################################

rem you have to set these variables (see examples above)
rem 
set SRC_ROOT=
set JAVA_HOME=
set PERL_PATH=
set STLPORT4=
set ASM_PATH=
set UNZIP_PATH=
set COMPATH=
set CYGWIN=


set JDKLIB=%JAVA_HOME\lib 
set PERL=%PERL_PATH\perl.exe

set BUILD_SOSL=true 
set LOCAL_SOLENV=true 


rem 
rem you may change these to change the language
rem 
set RES_ARAB= 
set RES_CHINSIM= 
set RES_CHINTRAD= 
set RES_DAN= 
set RES_DTCH= 
set RES_ENUS=TRUE 
set RES_FREN= 
set RES_GREEK= 
set RES_ITAL= 
set RES_JAPN= 
set RES_KOREAN= 
set RES_POL= 
set RES_PORT= 
set RES_RUSS= 
set RES_SPAN= 
set RES_SWED= 
set RES_TURK= 

rem
rem Platform independent constant values.
rem
set COMMON_OUTDIR= 
set CALL_CDECL=TRUE
set common_build= 
set NO_SRS_PATCH=true 
set PROFULLSWITCH=product=full 
set BIG_GOODIES=TRUE 
set BMP_WRITES_FLAG=TRUE 
set MK_UNROLL=TRUE 
set MULTITHREAD_OBJ=TRUE 
set NO_REC_RES=TRUE 
set PROEXT=.pro 
set SO3=TRUE 
set SOLAR_PLUGIN=TRUE 
set TF_PACKAGES=TRUE 
set TF_FILEURL=TRUE
set TF_CFGDATA=TRUE
set TF_SVDATA=TRUE
set TF_SDBAPI=ist_da 
set TF_UCB=ist_da 
set UPDATER=YES 
set build_deliver=true 
set USE_NEWCHARSET=TRUE 
set USE_NEW_RSC=TRUE 
set VCL=TRUE 
set USE_NAMESPACE=TRUE 
set ENABLEUNICODE=TRUE 
set NEW_JAR_PACK=TRUE 
set NO_BSYMBOLIC=TRUE 
set TF_FILTER=TRUE
set PSPRINT=TRUE

rem 
rem Platform dependent constant values. 
rem 
set SOLAR_JAVA=TRUE 
set COM=MSC 
set CPU=I 
set CPUNAME=INTEL 
set CVER=MI200 
set DLLSUFFIX=mi 
set GUI=WNT 
set GUIBASE=WIN 
set GUIENV=WNT 
set GVER=NT351 
set OS=WNT 
set OUTPATH=wntmsci7 
set INPATH=wntmsci7.pro 
set GVERDIR=wntmsci7.pro 
set PATH_SEPERATOR=; 
set COMEX= 7
set BOTH=TRUE 
set CDPATHx=;..;..\..;..\..\..;..\source;..\..\source 
set DEMO_ENV=FALSE 
set DYNAMIC_CRT=TRUE 
set SET_EXCEPTIONS=TRUE 
set emergency=FALSE 
set use_shl_versions=TRUE 

rem 
rem Variable values. 
rem 
set UPD=638 
set SOLARUPD=638 
set WORK_STAMP=SRC638 
set TF_ONE51=SRC638 
set URD_ONLY=SRC638 
set SOLARROOT=%SRC_ROOT 
set SOLARSRC=%SRC_ROOT 
set RSCRES=%SRC_ROOT 
set SOLARVER=%SRC_ROOT\solver 
set SOLARVERSION=%SOLARVER\638 
set SOLARENV=%SRC_ROOT\solenv 
set SOLARENVINC=%SOLARENV\inc 
set LOCALINI=%SOLARENV\config 
set STAR_INIROOT=%SOLARENV\config 
set STAR_INIROOTOLD=%SOLARENV\config 
set STAR_STANDLST=%SOLARENV\config\stand.lst 
set STAR_SSCOMMON=%SOLARENV\config\ssolar.cmn 
set STAR_SSCOMMON=%SOLARENV\config\ssolar.cmn 
set STAR_SSOLARINI=%SOLARENV\config\ssolar.ini 
set STAR_RESOURCEPATH=%SOLARVER\%UPD\%INPATH\bin 
set STAR_REGISTRY=%STAR_RESOURCEPATH\applicat.rdb 
set DMAKEROOT=%SOLARENVINC\startup 
set CLASSPATH=%JAVA_HOME\lib\classes.zip 
set XCLASSPATH=%JAVA_HOME\lib\classes.zip 
set SOLARINCLUDES= -I%SRC_ROOT\solver\inc -I%SRC_ROOT\solenv\wntmsci7.pro\inc -I%COMPATH\include -I%SRC_ROOT\solenv\inc 
set PATH=.;%SOLARVER\%UPD\%INPATH\bin;%SOLARENV\WNTI;%SOLARENV\%OUTPATH\bin;%PERL_PATH;%JAVA_HOME\bin;%ASM_PATH;%UNZIP_PATH;%CYGWIN;%SRC_ROOT\dmake;%PATH
set SOLARLIB= -L%SOLARVER\%UPD\%INPATH\lib -L..\lib -L%SOLARENV\%OUTPATH\lib 
set SOLARINC= -I. -I%SOLARVER\%UPD\%INPATH\inc\stl -I%SOLARVER\%UPD\%INPATH\inc -I%SOLARVER\%UPD\%INPATH\inc\external -I%SOLARENV\%OUTPATH\inc -I%SOLARENV\inc -I%SRC_ROOT\res -I%COMPATH\include -I%JAVA_HOME\include\win32 -I%JAVA_HOME\include 
set COMP_ENV=wntmsci7 
set IENV=;.;%SRC_ROOT\solver\638\wntmsci7.pro\inc\stl;%SRC_ROOT\solver\638\wntmsci7.pro\inc;%SRC_ROOT\solenv\wntmsci7\inc;%COMPATH\include;%SRC_ROOT\solenv\inc 
set ILIB=.;%SRC_ROOT\solver\638\lib;%SRC_ROOT\solver\638\wntmsci7.pro\lib;%SRC_ROOT\solenv\wntmsci7\lib;%COMPATH\lib 
set INCLUDE=;.;%SRC_ROOT\solver\638\wntmsci7.pro\inc\stl;%SRC_ROOT\solver\638\wntmsci7.pro\inc;%SRC_ROOT\solenv\wntmsci7\inc;%COMPATH\include;%SRC_ROOT\solenv\inc 
set JAVAHOME=%JAVA_HOME 
set COMMON_BUILD_TOOLS=%SRC_ROOT\external\common 
set LIB=.;%SRC_ROOT\solver\638\lib;%SRC_ROOT\solver\638\wntmsci7.pro\lib;%SRC_ROOT\solenv\wntmsci7\lib;%COMPATH\lib 
set GREP=%CYGWIN\grep.exe 
set FIND=%CYGWIN\find.exe 
set LS=%CYGWIN\ls.exe 
set GNUCOPY=%CYGWIN\cp.exe 
set TOUCH=%CYGWIN\touch.exe 
set DELIVER=%COMSPEC -c call perl %SOLARENV\bin\deliver.pl
set MKOUT=%COMSPEC -c call perl %SOLARENV\bin\mkout.pl
set home=    

rem 
rem Aliases. 
rem 
alias dmake=`*dmake product=full` 
alias mkout=`perl %SOLARENV\bin\mkout.pl`
alias deliver=`perl %SOLARENV\bin\deliver.pl`
alias build=`perl %SOLARENV\bin\build.pl product=full`

rem
rem build the dmake executable.
rem
if not exist %SRC_ROOT\dmake\dmake.exe (cd %SRC_ROOT\dmake ^ call make.bat win95-vpp40 ^ cd %SRC_ROOT)

unset SHELL >& NUL
unset FRAMEWORKSHOME >& NUL
unset BIG_SVX >& NUL
unset GLIBC >& NUL
unset XPVERSION >& NUL
unset PROSWITCH >& NUL
unset LD_LIBRARY_PATH >& NUL
unset DYLD_LIBRARY_PATH >& NUL
unset SOLARDEF >& NUL
unset SOLAREXTRAINC >& NUL
unset SOLAREXTRALIB >& NUL
unset PATHEXTRA >& NUL
unset BISON_HAIRY >& NUL
unset BISON_SIMPLE >& NUL
