/*************************************************************************
 *
 *  $RCSfile: userimpl.cxx,v $
 *
 *  $Revision: 1.35 $
 *
 *  last change: $Author: jb $ $Date: 2001/08/06 15:25:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "userimpl.hxx"

#ifndef CONFIGMGR_API_ADMINPROVIDERIMPL_HXX_
#include "adminproviderimpl.hxx"
#endif
#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XHIERARCHICALPROPERTYSET_HPP_
#include <com/sun/star/beans/XHierarchicalPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XHIERARCHICALNAMEACCESS_HPP_
#include <com/sun/star/container/XHierarchicalNameAccess.hpp>
#endif
#ifndef CONFIGMGR_API_ENCODENAME_HXX_
#include "encodename.hxx"
#endif
#ifndef _CPPUHELPER_TYPEPROVIDER_HXX_
#include <cppuhelper/typeprovider.hxx>
#endif
#ifndef _COMPHELPER_SEQUENCE_HXX_
#include <comphelper/sequence.hxx>
#endif
#ifndef CONFIGMGR_API_NODEACCESS_HXX_
#include "apinodeaccess.hxx"
#endif
#ifndef CONFIGMGR_ROOTTREE_HXX_
#include "roottree.hxx"
#endif
#ifndef _CONFIGMGR_XMLFORMATER_HXX
#include "xmlformater.hxx"
#endif
#ifndef CONFIGMGR_API_TREEACCESS_HXX_
#include "apitreeaccess.hxx"
#endif
#ifndef _CONFIGMGR_TREECACHE_HXX_
#include "treecache.hxx"
#endif
#ifndef CONFIGMGR_CREATEPROPERTYVALUE_HXX
#include "createpropertyvalue.hxx"
#endif

#ifndef CONFIGMGR_TREEBUILDERCALLBACK_HXX
#include "treebuildercallback.hxx"
#endif

#ifndef CONFIGMGR_CONFIGTEMPLATE_HXX_
#include "template.hxx"
#endif
#ifndef _CONFIGMGR_TRACER_HXX_
#include "tracer.hxx"
#endif
#ifndef CONFIGMGR_CONFIGSET_HXX_
#include "configset.hxx"
#endif
#ifndef CONFIGMGR_API_FACTORY_HXX_
#include "apifactory.hxx"
#endif
#ifndef _CONFIGMGR_TREEACTIONS_HXX_
#include "treeactions.hxx"
#endif

namespace configmgr
{
	namespace css  = ::com::sun::star;
	namespace uno  = css::uno;
	namespace lang = css::lang;	
	using ::rtl::OUString;
	using ::vos::ORef;
	using namespace osl;
	using namespace configuration;
	using namespace configapi;

	const AsciiServiceName aUserAccessServices[] = 
	{
		"com.sun.star.configuration.UserAccess", 
		NULL
	};

	const ServiceInfo aUserAccessSI =
	{ 
		"com.sun.star.comp.configuration.UserAccess", 
		aUserAccessServices
	};
	//-----------------------------------------------------------------------------

	static const rtl::OUString ssUserProfile(RTL_CONSTASCII_USTRINGPARAM("org.openoffice.UserProfile"));	
	static const rtl::OUString ssUserTemplateModule(RTL_CONSTASCII_USTRINGPARAM("org.openoffice.Webtop.Common"));
	static const rtl::OUString ssUserTemplateName(RTL_CONSTASCII_USTRINGPARAM("User"));
	static const rtl::OUString ssPathToUserGroup(RTL_CONSTASCII_USTRINGPARAM("Data"));
	static const rtl::OUString ssUserGroup(RTL_CONSTASCII_USTRINGPARAM("UserGroup"));			
	static const rtl::OUString ssDefaultUser(RTL_CONSTASCII_USTRINGPARAM("defaultGroup"));		

	// argument for creating a user
	static const rtl::OUString ssGroup(RTL_CONSTASCII_USTRINGPARAM("group"));	
	//-----------------------------------------------------------------------------

    static inline AbsolutePath getUserProfilePath()
    {
        return AbsolutePath::makeModulePath(ssUserProfile, AbsolutePath::NoValidate());
    }
	//-----------------------------------------------------------------------------

    static inline Path::Component makeFullUserName(rtl::OUString const& _sUser)
    {
        return Path::wrapSafeName(_sUser);
    }
	//-----------------------------------------------------------------------------

    static inline Name makeUserName(rtl::OUString const& _sUser)
    {
        return makeName(_sUser,Name::NoValidate());
    }
	//-----------------------------------------------------------------------------
	
	//=============================================================================
	//= OUserAccess
	//=============================================================================	
	//-----------------------------------------------------------------------------
	OUserAccess::OUserAccess(OAdminProviderImpl* _pProviderImpl)
			    :ServiceComponentImpl(&aUserAccessSI)
				,m_pProviderImpl(_pProviderImpl)	
	{
		m_pProviderImpl->acquire();
	}

	//-----------------------------------------------------------------------------
	void SAL_CALL OUserAccess::disposing()
	{		
		if (m_pProviderImpl)
		{
			MutexGuard aGuard(m_aMutex);
			if (m_pProviderImpl)
			{
				m_pProviderImpl->release();
				m_pProviderImpl = NULL;
			}
		}		
		ServiceComponentImpl::disposing();
	}

	//------------------------------------------------------------------------
	uno::Any SAL_CALL OUserAccess::queryInterface(uno::Type const& _rType) throw (uno::RuntimeException)
	{
		uno::Any aReturn = OUserAccess_Base::queryInterface(_rType);
		if (!aReturn.hasValue())
			aReturn = ServiceComponentImpl::queryInterface(_rType);
		return aReturn;
	}

	//------------------------------------------------------------------------
	uno::Sequence< uno::Type > SAL_CALL OUserAccess::getTypes() throw (uno::RuntimeException)
	{
		return ::comphelper::concatSequences(
			OUserAccess_Base::getTypes(),
			ServiceComponentImpl::getTypes()
		);
	}

	//------------------------------------------------------------------------
	uno::Sequence< sal_Int8 > SAL_CALL OUserAccess::getImplementationId() throw (uno::RuntimeException)
	{
		static cppu::OImplementationId aId;
		return aId.getImplementationId();
	}

	// XElementAccess		
	//-----------------------------------------------------------------------------
	uno::Type SAL_CALL OUserAccess::getElementType( ) throw(uno::RuntimeException)
	{
		return ::getCppuType( static_cast< uno::Reference< uno::XInterface > *>(0) );		
	}

	//-----------------------------------------------------------------------------
	sal_Bool SAL_CALL OUserAccess::hasElements(  ) throw(uno::RuntimeException)
	{
		return getElementNames().getLength() != 0;
	}

	// XNameAccess		
	//-----------------------------------------------------------------------------
	uno::Any SAL_CALL OUserAccess::getByName( const ::rtl::OUString& aName ) throw(container::NoSuchElementException, lang::WrappedTargetException, uno::RuntimeException)
	{
		// requesting a certain user node
		MutexGuard aGuard(m_aMutex);
		checkAlive();				

		// now lookup the user in cache
		uno::Any aReturn;
		uno::Sequence< uno::Any > aArgs(2);	// optional arg.
		aArgs[0] <<= configmgr::createPropertyValue(OProviderImpl::FactoryArguments::getNodePathArgumentName(), ssUserProfile);
		aArgs[1] <<= configmgr::createPropertyValue(OProviderImpl::FactoryArguments::getUserArgumentName(), aName);

		uno::Reference < uno::XInterface > xUser = m_pProviderImpl->createUpdateAccess(aArgs);
		aReturn <<= xUser;		
		return aReturn;
	}

	//-----------------------------------------------------------------------------
	uno::Sequence< ::rtl::OUString > SAL_CALL OUserAccess::getElementNames(  ) throw(uno::RuntimeException)
	{
		// requesting all nodes from the userprofile toplevel
        static AbsolutePath saUserProfiles = AbsolutePath::parse(::rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("org.openoffice.UserProfile/User")));
		static ::rtl::OUString sUserAll(RTL_CONSTASCII_USTRINGPARAM("TOPLEVEL"));
		MutexGuard aGuard(m_aMutex);
		checkAlive();

		CFG_TRACE_INFO("user access: reading all user names");
		::vos::ORef<OOptions> xOptions(new OOptions(m_pProviderImpl->getDefaultOptions()));
		xOptions->setUser(sUserAll);

		::vos::ORef< TreeBuilderCallback > xBuilder = 
			new TreeBuilderCallback(TreeBuilderCallback::NoModule(), xOptions);

		IConfigSession*	  pSession = m_pProviderImpl->getSession();
		pSession->asIUpdateProvider()->openNode(saUserProfiles, xOptions, 1, xBuilder.getBodyPtr());

		std::auto_ptr<ISubtree> pReturn = xBuilder->waitToResponse(pSession->getMasterTimeout());
		StatusInfo aStatus = xBuilder->getCallResult();

		if (0 == aStatus.nCode)
		{
			// Iterate over the childs of the tree
			CollectNames aCollect;
			pReturn->forEachChild(aCollect);
			return encodename::decode(configmgr::makeSequence( aCollect.list() ));			
		}
		else
		{
			return uno::Sequence< ::rtl::OUString >();
		}		
	}

	//-----------------------------------------------------------------------------
	sal_Bool SAL_CALL OUserAccess::hasByName( const ::rtl::OUString& aName ) throw(uno::RuntimeException)
	{
		sal_Bool bFound = sal_False;
		try
		{
			bFound = getByName(aName).hasValue();
		}
		catch (uno::Exception&)
		{
		}
		return bFound;
	}

	//-----------------------------------------------------------------------------
	// Helper class for managing a temporary transfer of ownership
	namespace
	{
		class TemporaryAddNode
		{
			SubtreeChange			m_aTemporaryChange;
			ElementTree& 			m_rOwningTree;
			AddNode*				m_pInsertOp;

		public:
			TemporaryAddNode(ElementTree& _rElementTree)
			: m_aTemporaryChange(OUString(), configuration::Attributes())
			, m_rOwningTree(_rElementTree)
			, m_pInsertOp(NULL)
			{}

			~TemporaryAddNode()
			{
				restoreOwnership();
			}

			SubtreeChange* makeAddNodeChange(OUString const& _sName)
			{
				restoreOwnership();
				
				std::auto_ptr<INode> aOwnedNode;
				ElementTree::releaseOwnedElement( aOwnedNode, m_rOwningTree);
				
				OSL_ENSURE(aOwnedNode.get(), "Unexpected: Trying to make temporary AddNode from non-owning ElementTree");
				if (!aOwnedNode.get())
					return NULL;

				aOwnedNode->setName(_sName);				

				m_pInsertOp = new AddNode( aOwnedNode, _sName );
				m_aTemporaryChange.addChange( std::auto_ptr<Change>(m_pInsertOp) );

				return &m_aTemporaryChange;
			}
			
			void restoreOwnership()
			{
				if (m_pInsertOp)
				{
					std::auto_ptr<INode> aOwnedNode = m_pInsertOp->releaseAddedNode();
					m_pInsertOp = NULL;

					OSL_ENSURE(aOwnedNode.get(), "Unexpected: Use of temporary AddNode grabbed ownership");
					if (aOwnedNode.get())
						ElementTree::takeElementOwnership(aOwnedNode,m_rOwningTree);
				}
			}
		};
	}
	//-----------------------------------------------------------------------------
	
	// XNameContainer
	//-----------------------------------------------------------------------------
	void SAL_CALL OUserAccess::insertByName( const ::rtl::OUString& _rName, const uno::Any& _rElement ) 
		throw(lang::IllegalArgumentException, container::ElementExistException, lang::WrappedTargetException, uno::RuntimeException)
	{
		::rtl::OUString sName(_rName.trim());

		CFG_TRACE_INFO("user access: inserting a new user (named %s)", OUSTRING2ASCII(sName));		

		// check the arguments
		if (!sName.getLength())
		{
			CFG_TRACE_WARNING_NI("user access: nserting user with no name");
			throw lang::IllegalArgumentException(rtl::OUString::createFromAscii("The name must not be empty."), static_cast< lang::XSingleServiceFactory* >(this), 1);
		}

		MutexGuard aGuard(m_aMutex);
		checkAlive();

		try
		{
			TemplateHolder aHolder = configuration::makeTreeTemplate(ssUserTemplateName,ssUserTemplateModule,m_pProviderImpl->getSpecialTemplateProvider());
			ElementTree aElementTree = configapi::extractElementTree(m_pProviderImpl->getWriterFactory(), _rElement, SetElementInfo(aHolder) );
			if (!aElementTree.isValid())
				throw lang::IllegalArgumentException(rtl::OUString::createFromAscii("illegal type inserted!."), static_cast< lang::XSingleServiceFactory* >(this), 1);

			// lock it
			configapi::SetElement* pElementAccess = configapi::findSetElement(m_pProviderImpl->getWriterFactory(), aElementTree);
			if (pElementAccess == 0) 
				throw lang::IllegalArgumentException(rtl::OUString::createFromAscii("object is not accessible!."), static_cast< lang::XSingleServiceFactory* >(this), 1);

			OWriteSynchronized aElementLock(aElementTree.getTreeLock());

			// now look what has changed in comparision to the default user
			IAdminProvider* pAdminProvider = m_pProviderImpl->getSession()->asIAdminProvider();
			OSL_ENSURE(pAdminProvider, "OUserAccess::updateTree : admin session not available in local session!");
			if (!pAdminProvider)
				return;

			::vos::ORef<OOptions> xOptions(new OOptions(m_pProviderImpl->getDefaultOptions()));

            ::vos::ORef< OUpdateCallback > xDataReqCb = 
                            new OUpdateCallback(getUserProfilePath().compose( makeFullUserName(sName) ), xOptions);

			// get the groupname for the user
			uno::Reference< container::XHierarchicalNameAccess > xUser;
			_rElement >>= xUser;
			if (xUser.is() == 0)
				throw lang::IllegalArgumentException(rtl::OUString::createFromAscii("object is not accessible!."), static_cast< lang::XSingleServiceFactory* >(this), 1);


			rtl::OUString sGroupName(ssDefaultUser);			
			try
			{
				uno::Reference< beans::XPropertySet > xSet;
				uno::Any aAccess = xUser->getByHierarchicalName(ssPathToUserGroup);
				aAccess >>= xSet;

				rtl::OUString sUserGroup;
				OSL_ENSURE(xSet.is(), "user access: an error occured, not able to set the user group");
				if (xSet.is())
				{
					uno::Any aGroup = xSet->getPropertyValue(ssUserGroup);
					aGroup >>= sUserGroup;
				}				

				if (sUserGroup.getLength())
					sGroupName = sUserGroup;				
			}
			catch (uno::Exception&)
			{
				OSL_ENSURE(0, "OUserAccess::no user group or login name set for the user");
			}												   
			
			// make a temporary change tree that takes the ownership of the node during the transaction
			TemporaryAddNode aInsertHelper(aElementTree);
			if (SubtreeChange* pDummyRoot = aInsertHelper.makeAddNodeChange(sName))
			{
				ORemoteUpdateXMLAttributeHandler aAttributeHandler;
				XMLFormater aInterpreter(pDummyRoot, xOptions,aAttributeHandler);

				pAdminProvider->addUser(makeUserName(sName), makeUserName(sGroupName), &aInterpreter, xDataReqCb.getBodyPtr());						
			}
			else
				throw lang::IllegalArgumentException(rtl::OUString::createFromAscii("object is not accessible!."), static_cast< lang::XSingleServiceFactory* >(this), 1);

			CFG_TRACE_INFO_NI("user access: adding user: waiting for the server response");			
			if (!xDataReqCb->waitForUpdate())		
			{
				CFG_TRACE_ERROR("user access: an error occured ...");				
				StatusInfo aStatus = xDataReqCb->getStatus();
				if (0 == aStatus.nCode)
				{
					aStatus.sMessage = ::rtl::OUString::createFromAscii("an error occured while inserting a user. code(");
					aStatus.sMessage += ::rtl::OUString::valueOf(xDataReqCb->getConnError());
					aStatus.sMessage += ::rtl::OUString::createFromAscii(").");
				}				
				throw lang::WrappedTargetException(aStatus.sMessage, NULL, uno::Any());
			}			
		}
		catch (configuration::Exception& e)
		{
			throw lang::WrappedTargetException(e.message(),NULL, uno::Any());
		}
	}


	//-----------------------------------------------------------------------------
	void SAL_CALL OUserAccess::removeByName( const ::rtl::OUString& sName ) throw(container::NoSuchElementException, lang::WrappedTargetException, uno::RuntimeException)
	{
		CFG_TRACE_INFO("user access: removing an existing user (named %s)", OUSTRING2ASCII(sName));		

		// check the arguments
		if (!sName.getLength())
		{
			CFG_TRACE_WARNING_NI("user access: removing a user with no name");
			throw lang::IllegalArgumentException(rtl::OUString::createFromAscii("The name must not be empty."), static_cast< lang::XSingleServiceFactory* >(this), 1);
		}

		MutexGuard aGuard(m_aMutex);
		checkAlive();

		try
		{
			// now look what has changed in comparision to the default user
			IAdminProvider* pAdminProvider = m_pProviderImpl->getSession()->asIAdminProvider();
			OSL_ENSURE(pAdminProvider, "OUserAccess::updateTree : admin session not available in local session!");
			if (!pAdminProvider)
				return;

			::vos::ORef< TreeBuilderCallback > xBuilder = 
				new TreeBuilderCallback(TreeBuilderCallback::NoModule(), new OOptions(m_pProviderImpl->getDefaultOptions()));

			pAdminProvider->deleteUser(makeUserName(sName), xBuilder.getBodyPtr());
			CFG_TRACE_INFO_NI("user access: removing user: waiting for the server response");			
			xBuilder->waitToResponse(m_pProviderImpl->getSession()->getMasterTimeout());
			
			StatusInfo aStatus = xBuilder->getCallResult();						
			
			if (0 == aStatus.nCode)
			{
				vos::ORef< OOptions > xUser( new OOptions(0) );

				xUser->setUser(sName);
				OSL_ASSERT(xUser->getLocale().getLength() == 0); // Must identify a user, not an option set

				m_pProviderImpl->disposeData(xUser);
			}
			else
			{
				CFG_TRACE_ERROR("user access: an error occured ...");									
				throw lang::WrappedTargetException(aStatus.sMessage, NULL, uno::Any());
			}			
		}
		catch (configuration::Exception& e)
		{
			throw lang::WrappedTargetException(e.message(),NULL, uno::Any());
		}
	}

	// XNameReplace
	//-----------------------------------------------------------------------------
	void SAL_CALL OUserAccess::replaceByName( const ::rtl::OUString& _rName, const uno::Any& _rElement ) throw(lang::IllegalArgumentException, container::NoSuchElementException, lang::WrappedTargetException, uno::RuntimeException)
	{
		CFG_TRACE_WARNING_NI("user access: replacing users not allowed!");
		OSL_ENSURE(false,"ERROR: replaceing of users not allowed, will be ignored!");
	}

	// XSingleServiceFactory
	//-----------------------------------------------------------------------------
	uno::Reference< uno::XInterface > SAL_CALL OUserAccess::createInstance(  ) throw(uno::Exception, uno::RuntimeException)
	{
		return createInstanceWithArguments(uno::Sequence< uno::Any >());
	}
	
	//-----------------------------------------------------------------------------
	uno::Reference< uno::XInterface > SAL_CALL OUserAccess::createInstanceWithArguments( const uno::Sequence< uno::Any >& _rArgs ) throw(uno::Exception, uno::RuntimeException)
	{
		MutexGuard aGuard(m_aMutex);
		checkAlive();

		try
		{			
			rtl::OUString sGroupName(ssDefaultUser);
			
			// do we have a different group to use to ?
			if (_rArgs.getLength() == 1)
			{
				beans::PropertyValue aGroupSetting;		
				if (_rArgs[0] >>= aGroupSetting)
				{
					if (aGroupSetting.Name.equalsIgnoreAsciiCase(ssGroup))
						aGroupSetting.Value >>= sGroupName;
					else						
					{
						throw lang::IllegalArgumentException(
										(OUString(RTL_CONSTASCII_USTRINGPARAM("The argument ")) += aGroupSetting.Name) += OUString(RTL_CONSTASCII_USTRINGPARAM(" could not be extracted.")),
										uno::Reference< uno::XInterface >(),0);
					}
				}
			}
			
			
			CFG_TRACE_INFO("user access: providing template for user");			

			// read the tree for the default group the user should belong to			
			ORef <OOptions> xOptions = new OOptions(m_pProviderImpl->getDefaultOptions());			
			
			// just a dummy, should not be used			
			TemplateHolder aDummyHolder = configuration::makeTreeTemplate(ssUserTemplateName,ssUserTemplateModule,m_pProviderImpl->getSpecialTemplateProvider());
			
			// create a template holder from the hardcoded path XXX
			configuration::SetElementFactory aFactory = configuration::SetElementFactory( m_pProviderImpl->getTemplateInstanceProvider(xOptions) );			
			
			ElementTree aTree(aFactory.instantiateTemplate(aDummyHolder));
			UnoInterfaceRef xObj = m_pProviderImpl->getWriterFactory().makeUnoSetElement(aTree);

			// if we got a Profile, we have to set the Group the user belongs to
			uno::Any aGroup;
			aGroup <<= sGroupName;

			uno::Reference< container::XHierarchicalNameAccess > xUser(xObj, uno::UNO_QUERY);
			OSL_ENSURE(xUser.is(), "user access: an error occured, not able to set the user group");

			if (xUser.is())
			{					
				uno::Reference< beans::XPropertySet > xSet;
				uno::Any aAccess = xUser->getByHierarchicalName(ssPathToUserGroup);
				aAccess >>= xSet;

				OSL_ENSURE(xSet.is(), "user access: an error occured, not able to set the user group");
				if (xSet.is())
					xSet->setPropertyValue(ssUserGroup, aGroup);				
			}
			return xObj;
		}
		catch (configuration::Exception& e)
		{
			throw uno::Exception(e.message(),0);
		}		

		return uno::Reference< uno::XInterface >();
	}
	
} // namespace configmgr


