/*************************************************************************
 *
 *  $RCSfile: binarydecide.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: lla $ $Date: 2001/06/14 08:26:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef CONFIGMGR_BINARYDECIDE_HXX_
#define CONFIGMGR_BINARYDECIDE_HXX_

#include <osl/time.h>
#include <rtl/ustring.hxx>
#include "pathhelper.hxx"

namespace configmgr
{
// -----------------------------------------------------------------------------
	// Helper structure to handle a FileURL AND it's context, here the file type XML or BINARY.

	struct ODecideContext
	{
		rtl::OUString     sFileURL;

		enum Enum
		{
			XML_FILE,
			BINARY_FILE,
			NO_FILE
		} eType;

		ODecideContext()
				: eType(NO_FILE)
			{}
		ODecideContext(rtl::OUString const& _sFilename, Enum _eType)
				: sFileURL(_sFilename), eType(_eType)
			{}
	};
// -----------------------------------------------------------------------------
	class OFileTimeStampDecision
	{
		// Helperclass which decide on some FileStamps and existings what we have to do
		// load the right file xml or binary
		// if we load xml, write binary so next we load binary
		
		ODecideContext        m_aContext;
		PathHelper     const& m_aPath;

		bool isBTimeGreaterATime(TimeValue const& A, TimeValue const& B) const;
		ODecideContext getNewerFile(ODecideContext const& _sFileA, ODecideContext const& _sFileB) const;
		ODecideContext checkFileStamp(PathHelper const& _aPath);
	public:
		explicit OFileTimeStampDecision(PathHelper const& _aPath)
				:m_aPath(_aPath)
			{}
		
		rtl::OUString getFileURL();

		ODecideContext::Enum getFileType();

	};
// -----------------------------------------------------------------------------
/*
	class OFileWriteBinaryDecision
	{
		// Helperclass which decide on some FileStamps and existings what we have to do
		// load the right file xml or binary
		// if we load xml, write binary so next we load binary
		
		ODecideContext m_aContext;
		PathHelper m_aPath;

		bool isWritable(rtl::OUString const& _aPath);
	public:
		OFileWriteBinaryDecision(PathHelper const& _aPath)
				:m_aPath(_aPath)
			{}
		
		rtl::OUString getFileURL();

		ODecideContext::Enum getFileType();
	};
*/

} // namespace

#endif
