/*************************************************************************
 *
 *  $RCSfile: WCPage.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: fme $ $Date: 2001/06/21 15:21:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the License); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an AS IS basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef DBAUI_WIZARD_CPAGE_HXX
#define DBAUI_WIZARD_CPAGE_HXX

#ifndef DBAUI_WIZ_TABBPAGE_HXX
#include "WTabPage.hxx"
#endif
#ifndef DBAUI_WIZ_COPYTABLEDIALOG_HXX
#include "WCopyTable.hxx"
#endif
#ifndef DBAUI_ENUMTYPES_HXX
#include "QEnumTypes.hxx"
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif

namespace dbaui
{
	class OWizColumnSelect;
	class OWizNormalExtend;
	//========================================================================
	class OCopyTable : public OWizardPage
	{
	protected:
		FixedText								m_ftTableName;
		Edit									m_edTableName;
        FixedLine                               m_aFL_Options;
		RadioButton								m_aRB_DefData;
		RadioButton								m_aRB_Def;
		RadioButton								m_aRB_View;
		RadioButton								m_aRB_AppendData;
		CheckBox								m_aCB_PrimaryColumn;
		FixedText								m_aFT_KeyName;
		Edit									m_edKeyName;
		OCopyTableWizard::Wizard_Create_Style	m_eOldStyle;

		OWizColumnSelect*						m_pPage2;
		OWizNormalExtend*						m_pPage3;

		BOOL									m_bIsViewAllowed;
		BOOL									m_bPKeyAllowed;


		DECL_LINK( AppendDataClickHdl, Button* );
		DECL_LINK( RadioChangeHdl, Button* );
		DECL_LINK( KeyClickHdl, Button* );

	public:
		virtual	void			Reset();
		virtual void			ActivatePage();
		virtual BOOL			LeavePage();
		virtual String			GetTitle() const ;

		OCopyTable( Window * pParent, EImportMode atWhat, BOOL bIsQuery, OCopyTableWizard::Wizard_Create_Style nLastAction );
		virtual ~OCopyTable();

		BOOL IsOptionDefData()		const { return m_aRB_DefData.IsChecked(); }
		BOOL IsOptionDef()			const { return m_aRB_Def.IsChecked(); }
		BOOL IsOptionAppendData()	const { return m_aRB_AppendData.IsChecked(); }
		BOOL IsOptionView()			const { return m_aRB_View.IsChecked(); }

	};
}
#endif // DBAUI_WIZARD_CPAGE_HXX


