/*************************************************************************
 *
 *  $RCSfile: filenotation.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: fs $ $Date: 2001/07/27 05:55:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXTENSIONS_DBI_FILENOTATION_HXX_
#define _EXTENSIONS_DBI_FILENOTATION_HXX_

#include <rtl/ustring.hxx>

//.........................................................................
namespace dbi
{
//.........................................................................

	//=====================================================================
	//= OFileNotation
	//=====================================================================
	class OFileNotation
	{
	protected:
		::rtl::OUString		m_sSystem;
		::rtl::OUString		m_sNormalized;
		::rtl::OUString		m_sFileURL;

	public:
		enum NOTATION
		{
			N_SYSTEM,
			N_URL
		};

		OFileNotation(const ::rtl::OUString& _rFileOrPath, NOTATION _eInputNotation);

		::rtl::OUString get(NOTATION _eOutputNotation);
	};

//.........................................................................
}	// namespace dbi
//.........................................................................

#endif // _EXTENSIONS_DBI_FILENOTATION_HXX_

/*************************************************************************
 * history:
 *	$Log: filenotation.hxx,v $
 *	Revision 1.4  2001/07/27 05:55:31  fs
 *	#90267# remove TF_FILEURL
 *	
 *	Revision 1.3  2001/05/16 11:48:15  fs
 *	#65293# osl changes are TF_FILEURL-, not SUPD-dependent
 *	
 *	Revision 1.2  2001/05/11 10:51:56  fs
 *	osl removed the support for normalized file names
 *	
 *	Revision 1.1  2001/02/12 07:12:17  fs
 *	initial checkin - importing StarOffice 5.2 database files
 *	
 *
 *	Revision 1.0 07.02.01 16:27:57  fs
 ************************************************************************/

