/*************************************************************************
 *
 *  $RCSfile: brwcontrol.hxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: fs $ $Date: 2001/01/12 11:26:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _EXTENSIONS_PROPCTRLR_BRWCONTROL_HXX_
#define _EXTENSIONS_PROPCTRLR_BRWCONTROL_HXX_

#ifndef _RTL_USTRING_HXX_
#include <rtl/ustring.hxx>
#endif
#ifndef _EXTENSIONS_PROPCTRLR_PCRCOMMON_HXX_
#include "pcrcommon.hxx"
#endif

class Size;
class Point;
class Window;
//............................................................................
namespace pcr
{
//............................................................................

	class IBrowserControlListener;

	//========================================================================
	//= BrowserControlType
	//========================================================================
	enum BrowserControlType
	{
		BCT_UNDEFINED,
		BCT_LISTBOX,
		BCT_COMBOBOX,
		BCT_EDIT,
		BCT_COLORBOX,
		BCT_USERDEFINED,
		BCT_MEDIT,
		BCT_NUMFIELD,
		BCT_DATEFIELD,
		BCT_TIMEFIELD,
		BCT_LEDIT,
		BCT_CURFIELD,
		BCT_CHAREDIT
	};

	//========================================================================
	//= BrowserControlType
	//========================================================================
	class IBrowserControl
	{
	public:
			virtual							~IBrowserControl() { };

			virtual void					setListener(IBrowserControlListener*) = 0;
			virtual IBrowserControlListener*	getListener() = 0;

			virtual void					SetProperty(const ::rtl::OUString &rString,sal_Bool bIsUnknown = sal_False) = 0;
			virtual ::rtl::OUString			GetProperty() const = 0;
			virtual sal_Bool				HasList() = 0;
			virtual void					ClearList() = 0;
			virtual	void					InsertCtrEntry(const ::rtl::OUString& rString,
													sal_uInt16 nPos = EDITOR_LIST_APPEND) = 0;

			virtual void					SetCtrSize(const Size& rSize) = 0;
			virtual void					SetCtrPos(const Point& aPoint) = 0;
			virtual Point					GetCtrPos() const = 0;
			virtual Size					GetCtrSize() const = 0;
			virtual void					SetCtrHelpId(sal_uInt32 nHelpId) = 0;

			virtual sal_Bool				IsModified() = 0;
			virtual void					CommitModified() = 0;
			virtual void					SetTabOrder(Window* pRefWindow, sal_uInt16 nFlags ) = 0;

			virtual	void					ShowCtr(sal_Bool bFlag = sal_True) = 0;
			virtual	void					HideCtr() = 0;

			virtual	void					SetCtrParent(Window *) = 0;
			virtual	void					InvalidateCtr() = 0;
			virtual	void					UpdateCtr() = 0;

			virtual Window*					GetMe() = 0;

			virtual void					SetLocked(sal_Bool bLocked = sal_True) = 0;

			virtual void					SetMyName(const ::rtl::OUString &rString) = 0;
			virtual ::rtl::OUString			GetMyName() const = 0;

			virtual void					SetMyData(void*) = 0;
			virtual void*					GetMyData() = 0;

			virtual sal_Bool				GetDirection() = 0;

			virtual void					SetLine(sal_uInt16 nLine) = 0;
			virtual sal_uInt16				GetLine() = 0;
	};

//............................................................................
} // namespace pcr
//............................................................................

#endif // _EXTENSIONS_PROPCTRLR_BRWCONTROL_HXX_

/*************************************************************************
 * history:
 *	$Log: brwcontrol.hxx,v $
 *	Revision 1.1  2001/01/12 11:26:33  fs
 *	initial checkin - outsourced the form property browser
 *	
 *
 *	Revision 1.0 08.01.01 16:39:06  fs
 ************************************************************************/

