/*************************************************************************
 *
 *  $RCSfile: xmldocproperties.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: as $ $Date: 2001/06/11 10:18:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef __FRAMEWORK_HELPER_XMLDOCPROPERTIES_HXX_
#define __FRAMEWORK_HELPER_XMLDOCPROPERTIES_HXX_

//_________________________________________________________________________________________________________________
//	my own includes
//_________________________________________________________________________________________________________________

#ifndef __FRAMEWORK_THREADHELP_THREADHELPBASE_HXX_
#include <threadhelp/threadhelpbase.hxx>
#endif

#ifndef __FRAMEWORK_HELPER_FIXEDDOCUMENTPROPERTIES_HXX_
#include <helper/fixeddocumentproperties.hxx>
#endif

//_________________________________________________________________________________________________________________
//	interface includes
//_________________________________________________________________________________________________________________

#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif

#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif

#ifndef _COM_SUN_STAR_UTIL_DATETIME_HPP_
#include <com/sun/star/util/DateTime.hpp>
#endif

//_________________________________________________________________________________________________________________
//	other includes
//_________________________________________________________________________________________________________________

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif


#include <map>

namespace framework
{

class XMLDocumentPropertiesHandlerBase : public ::com::sun::star::xml::sax::XDocumentHandler,
										 public ThreadHelpBase,	// Struct for right initalization of mutex member! Must be first of baseclasses.
										 public ::cppu::OWeakObject
{
	public:
		XMLDocumentPropertiesHandlerBase();
		virtual ~XMLDocumentPropertiesHandlerBase();

		// XInterface
		virtual void SAL_CALL acquire() throw( ::com::sun::star::uno::RuntimeException )
			{ OWeakObject::acquire(); }
		virtual void SAL_CALL release() throw( ::com::sun::star::uno::RuntimeException )
			{ OWeakObject::release(); }
		virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( 
			const ::com::sun::star::uno::Type & rType ) throw( ::com::sun::star::uno::RuntimeException );

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
		throw (	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException ) = 0;
		
		virtual void SAL_CALL endDocument(void)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException ) = 0;
		
		virtual void SAL_CALL startElement(
			const rtl::OUString& aName,
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > &xAttribs)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException ) = 0;
		
		virtual void SAL_CALL endElement(const rtl::OUString& aName)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException ) = 0;
		
		virtual void SAL_CALL characters(const rtl::OUString& aChars)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException ) = 0;

		virtual void SAL_CALL ignorableWhitespace(const rtl::OUString& aWhitespaces)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );

		virtual void SAL_CALL processingInstruction(const rtl::OUString& aTarget,
													const rtl::OUString& aData)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );
		
		virtual void SAL_CALL setDocumentLocator( 
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > &xLocator)
		throw(	::com::sun::star::xml::sax::SAXException,
				::com::sun::star::uno::RuntimeException );

	protected:
		::rtl::OUString getErrorLineString();

		::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > m_xLocator;
		::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler> m_xReader;
};

class XMLDocumentPropertiesHandler : public XMLDocumentPropertiesHandlerBase
{
	public:
		enum DocPropertiesElement
		{
			DOCPROPELEM_NONE,
			DOCPROPELEM_META_GENERATOR,
			DOCPROPELEM_DC_TITLE,
			DOCPROPELEM_DC_DESCRIPTION,
			DOCPROPELEM_DC_SUBJECT,
			DOCPROPELEM_META_INITIALCREATOR,
			DOCPROPELEM_META_CREATIONDATE,
			DOCPROPELEM_DC_DATE,
			DOCPROPELEM_META_PRINTEDBY,
			DOCPROPELEM_META_PRINTDATE,
			DOCPROPELEM_META_KEYWORDS,
			DOCPROPELEM_META_KEYWORD,
			DOCPROPELEM_DC_LANGUAGE,
			DOCPROPELEM_META_EDITINGCYCLES,
			DOCPROPELEM_META_EDITINGDURATION,
			DOCPROPELEM_META_HYPERLINKBEHAVIOUR,
			DOCPROPELEM_META_AUTORELOAD,
			DOCPROPELEM_META_USERDEFINED,
			DOCPROPELEM_META_DOCUMENTSTATISTIC,
			DOCPROPELEM_META_TEMPLATE,
			DOCPROPELEM_DC_CREATOR,
			DOCPROPELEM_COUNT
		};

		XMLDocumentPropertiesHandler( ::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer >& rNameContainer,
									  FixedDocumentProperties& rFixedDocProperties );
		virtual ~XMLDocumentPropertiesHandler();

		// XDocumentHandler
		virtual void SAL_CALL startDocument(void)
		throw (	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );
		
		virtual void SAL_CALL endDocument(void)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );
		
		virtual void SAL_CALL startElement(
			const rtl::OUString& aName,
			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > &xAttribs)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );
		
		virtual void SAL_CALL endElement(const rtl::OUString& aName)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );
		
		virtual void SAL_CALL characters(const rtl::OUString& aChars)
		throw(	::com::sun::star::xml::sax::SAXException, 
				::com::sun::star::uno::RuntimeException );

	private:
		sal_Bool GetDateTime( const rtl::OUString& aDateTimeStr, ::com::sun::star::util::DateTime& aDateTime );
		sal_Bool GetDuration( const rtl::OUString& aDurationStr, sal_Int32& nDelayInSec );
		
		typedef ::std::map< ::rtl::OUString, DocPropertiesElement > DocPropHashMap;
		
		::com::sun::star::uno::Reference< ::com::sun::star::container::XNameContainer > m_xNameContainer;
		FixedDocumentProperties&			m_rDocumentProperties;
		DocPropertiesElement				m_nCurrentElement;
		DocPropHashMap						m_aDocPropHashMap;
		sal_Bool							m_bKeywordsElementFound;
		int									m_nKeywords;
		int									m_nUserData;
		::rtl::OUString						m_aUserDataName;
		::rtl::OUString						m_aCharacters;
};

}

#endif // __FRAMEWORK_HELPER_XMLDOCPROPERTIES_HXX_
