#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.10 $
#
#   last change: $Author: khendricks $ $Date: 2001/07/16 15:56:53 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

#these lines are mandatory for all makefile.mk
PRJ=..$/..$/..
PRJNAME=lingucomponent
TARGET=thencode

#avoid linking GUI libraries
TARGETTYPE=CUI

#avoid default behavior to collect all objects in
#a *.lib file. Not needed here
LIBTARGET=NO

# --- Settings -----------------------------------------------------
#get the common variables set
.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- Files --------------------------------------------------------

#get your source in the dependency process
#OBJ for non PIC code, the extension is always .obj
#and will be replaced according to the plattform
OBJFILES=   $(OBJ)$/thencode.obj

#now take care of the application
#just the basename
APP1TARGET=	$(TARGET)

APP1OBJS=	$(OBJFILES)

.IF "$(GUI)" == "WNT"
ATHENCODE=	thencode.exe
.ELSE
ATHENCODE=	thencode
.ENDIF

#every library you need that's not linked by default
APP1STDLIBS=	$(SALLIB)
APP1DEPN=
APP1DEF=

ALL:	\
	ALLTAR			\
	th_en_US.don


th_en_US: $(BIN)$/$(ATHENCODE) wordlist.txt trimthes.txt
	$(BIN)$/$(ATHENCODE) ${SRC_ROOT}$/$(PRJNAME)$/source$/thesaurus$/parser ${SRC_ROOT}$/$(PRJNAME)$/${INPATH}$/bin

th_en_US.don: th_en_US
	@-$(TOUCH) $(@)

#unzip the text input files
wordlist.txt:	wordlist.zip
	jar xf wordlist.zip

trimthes.txt:	trimthes.zip
	jar xf trimthes.zip


# --- Targets ------------------------------------------------------
#get the main target and lots off subtargets...
.INCLUDE :  target.mk


