import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XComponent;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.beans.PropertyValue;


public class DocumentLoader {
  public static void main(String args[]) {
    try {
      /* Bootstraps a servicemanager with the jurt base components
         registered */
      XMultiServiceFactory xmultiservicefactory =
      com.sun.star.comp.helper.Bootstrap.createSimpleServiceManager();
      
      /* Creates an instance of the component UnoUrlResolver which
         supports the services specified by the factory. */
      Object objectUrlResolver = xmultiservicefactory.createInstance(
      "com.sun.star.bridge.UnoUrlResolver" );
      
      // Create a new url resolver
      XUnoUrlResolver xurlresolver = ( XUnoUrlResolver )
      UnoRuntime.queryInterface( XUnoUrlResolver.class,
      objectUrlResolver );
      
      // Resolves an object that is specified as follow:
      // uno:<connection description>;<protocol description>;<initial object name>
      Object objectInitial = xurlresolver.resolve(
      "uno:socket,host=localhost,port=8100;urp;StarOffice.ServiceManager" );
      
      // Create a service manager from the initial object
      xmultiservicefactory = ( XMultiServiceFactory )
      UnoRuntime.queryInterface( XMultiServiceFactory.class,
      objectInitial );
      
      /* A desktop environment contains tasks with one or more
         frames in which components can be loaded. Desktop is the
         environment for components which can instanciate within
         frames. */
      XComponentLoader xcomponentloader = ( XComponentLoader )
      UnoRuntime.queryInterface( XComponentLoader.class,
      xmultiservicefactory.createInstance(
      "com.sun.star.frame.Desktop" ) );
      
      // Load a Writer document, which will be automaticly displayed
      XComponent xcomponent = xcomponentloader.loadComponentFromURL(
      "private:factory/swriter", "_blank", 0,
      new PropertyValue[0] );
      
      System.exit(0);
    }
    catch( Exception exception ) {
      System.err.println( exception );
    }
  }
}
