import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XComponent;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.beans.PropertyValue;
import com.sun.star.frame.XStorable;


public class DocumentSaver {
  public static void main(String args[]) {
    try {
      /* Bootstraps a servicemanager with the jurt base components
         registered */
      XMultiServiceFactory xmultiservicefactory =
      com.sun.star.comp.helper.Bootstrap.createSimpleServiceManager();
      
      /* Creates an instance of the component UnoUrlResolver which
         supports the services specified by the factory. */
      Object objectUrlResolver = xmultiservicefactory.createInstance(
      "com.sun.star.bridge.UnoUrlResolver" );
      
      // Create a new url resolver
      XUnoUrlResolver xurlresolver = ( XUnoUrlResolver )
      UnoRuntime.queryInterface( XUnoUrlResolver.class,
      objectUrlResolver );
      
      // Resolves an object that is specified as follow:
      // uno:<connection description>;<protocol description>;<initial object name>
      Object objectInitial = xurlresolver.resolve(
      "uno:socket,host=localhost,port=8100;urp;StarOffice.ServiceManager" );
      
      // Create a service manager from the initial object
      xmultiservicefactory = ( XMultiServiceFactory )
      UnoRuntime.queryInterface( XMultiServiceFactory.class,
      objectInitial );
      
      /* A desktop environment contains tasks with one or more
         frames in which components can be loaded. Desktop is the
         environment for components which can instanciate within
         frames. */
      XComponentLoader xcomponentloader = ( XComponentLoader )
      UnoRuntime.queryInterface( XComponentLoader.class,
      xmultiservicefactory.createInstance(
      "com.sun.star.frame.Desktop" ) );
      
      String stringUrl = "file:///g:/test.sxw";
      Object objectDocumentToStore = xcomponentloader.loadComponentFromURL(
      stringUrl, "_blank", 0, new PropertyValue[0] );
      XStorable xstorable =
      ( XStorable ) UnoRuntime.queryInterface( XStorable.class,
      objectDocumentToStore );

      PropertyValue propertyvalue[] = new PropertyValue[ 1 ];
      propertyvalue[ 0 ] = new PropertyValue();
      propertyvalue[ 0 ].Name = "Overwrite";
      propertyvalue[ 0 ].Value = new Boolean(true);
      xstorable.storeAsURL("file:///g:/teststore.sxw", propertyvalue );
      
      propertyvalue = new PropertyValue[ 2 ];
      propertyvalue[ 0 ] = new PropertyValue();
      propertyvalue[ 0 ].Name = "Overwrite";
      propertyvalue[ 0 ].Value = new Boolean(true);
      propertyvalue[ 1 ] = new PropertyValue();
      propertyvalue[ 1 ].Name = "FilterName";
      propertyvalue[ 1 ].Value = "swriter: MS Word 97";
      xstorable.storeAsURL("file:///g:/teststore.doc", propertyvalue );
      
      System.exit(0);
    }
    catch( Exception exception ) {
      System.err.println( exception );
    }
  }
}
