/*************************************************************************
 *
 *  $RCSfile: XclExpCharts.cxx,v $
 *
 *  $Revision: 1.9 $
 *
 *  last change: $Author: dr $ $Date: 2001/07/16 10:51:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifdef PCH
#include "filt_pch.hxx"
#endif

#pragma hdrstop


#ifndef _XCLEXPCHARTS_HXX
#include "XclExpCharts.hxx"
#endif

SV_IMPL_REF_LIST( ScRangeList, ScRangeList* );

#include "xcl97esc.hxx"

#include "chartarr.hxx"
#ifndef _SCH_DLL_HXX //autogen wg. SchMemChart
#include <sch/schdll.hxx>
#endif
#include <sch/memchrt.hxx>

#include "compiler.hxx"
#include "excupn.hxx"


#ifndef _SVDOOLE2_HXX //autogen wg. SdrOle2Obj
#include <svx/svdoole2.hxx>
#endif
#ifndef _SVDOBJ_HXX //autogen wg. SdrObject
#include <svx/svdobj.hxx>
#endif
#ifndef _SFX_INTERNO_HXX //autogen wg. SfxInPlaceObject
#include <sfx2/interno.hxx>
#endif
#ifndef _SV_OUTDEV_HXX //autogen wg. OutputDevice
#include <vcl/outdev.hxx>
#endif
#ifndef _TOOLKIT_HELPER_VCLUNOHELPER_HXX_
#include <toolkit/unohlp.hxx>
#endif

#ifndef _SVSTDARR_USHORTS
#define _SVSTDARR_USHORTS
#endif
#include <svtools/svstdarr.hxx>

// lang
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif
// text
#ifndef _COM_SUN_STAR_TEXT_XTEXT_HPP_
#include <com/sun/star/text/XText.hpp>
#endif
// awt
#ifndef _COM_SUN_STAR_AWT_FONTSLANT_HPP_
#include <com/sun/star/awt/FontSlant.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTUNDERLINE_HPP_
#include <com/sun/star/awt/FontUnderline.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTFAMILY_HPP_
#include <com/sun/star/awt/FontFamily.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_CHARSET_HPP_
#include <com/sun/star/awt/CharSet.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_GRADIENT_HPP_
#include <com/sun/star/awt/Gradient.hpp>
#endif
// drawing
#ifndef _COM_SUN_STAR_DRAWING_LINESTYLE_HPP_
#include <com/sun/star/drawing/LineStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LINEDASH_HPP_
#include <com/sun/star/drawing/LineDash.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_FILLSTYLE_HPP_
#include <com/sun/star/drawing/FillStyle.hpp>
#endif
// chart
#ifndef _COM_SUN_STAR_CHART_CHARTDATAROWSOURCE_HPP_
#include <com/sun/star/chart/ChartDataRowSource.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XSHAPE_HPP_
#include <com/sun/star/drawing/XShape.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISXSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisXSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XTWOAXISXSUPPLIER_HPP_
#include <com/sun/star/chart/XTwoAxisXSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISYSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisYSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XTWOAXISYSUPPLIER_HPP_
#include <com/sun/star/chart/XTwoAxisYSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISZSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisZSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSOLIDTYPE_HPP_
#include <com/sun/star/chart/ChartSolidType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTLEGENDPOSITION_HPP_
#include <com/sun/star/chart/ChartLegendPosition.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTAXISMARKS_HPP_
#include <com/sun/star/chart/ChartAxisMarks.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSYMBOLTYPE_HPP_
#include <com/sun/star/chart/ChartSymbolType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTDATACAPTION_HPP_
#include <com/sun/star/chart/ChartDataCaption.hpp>
#endif
#ifndef __com_sun_star_chart_XStatisticDisplay_HPP__
#include <com/sun/star/chart/XStatisticDisplay.hpp>
#endif


using namespace ::rtl;
using namespace ::com::sun::star;


#ifndef _XCEPTION_HXX_ //autogen wg. TRY
#include <vos/xception.hxx>
#endif
#ifndef _VOS_NO_NAMESPACE
using namespace vos;
#endif


// --- little helpers ------------------------------------------------

UINT16 lcl_GetXclLineStyle( drawing::LineStyle eStyle, const drawing::LineDash& rDash, sal_Int16 nTrans )
{
	UINT16 nStyle = EXC_CHART_LINEF_SOLID;
	switch( eStyle )
	{
		case drawing::LineStyle_NONE:
			nStyle = EXC_CHART_LINEF_NONE;
		break;
		case drawing::LineStyle_SOLID:
		{
			if( nTrans < 13 )
				nStyle = EXC_CHART_LINEF_SOLID;
			else if( nTrans < 38 )
				nStyle = EXC_CHART_LINEF_DARKTRANS;
			else if( nTrans < 63 )
				nStyle = EXC_CHART_LINEF_MEDTRANS;
			else if( nTrans < 100 )
				nStyle = EXC_CHART_LINEF_LIGHTTRANS;
			else
				nStyle = EXC_CHART_LINEF_NONE;
		}
		break;
		case drawing::LineStyle_DASH:
		{
			if( (rDash.Dots == 1) && (rDash.Dashes == 1) )
				nStyle = EXC_CHART_LINEF_DASHDOT;
			else if( (rDash.Dots == 2) && (rDash.Dashes == 1) ||
					(rDash.Dots == 1) && (rDash.Dashes == 2) )
				nStyle = EXC_CHART_LINEF_DASHDOTDOT;
			else if( ((rDash.Dots == 0) && (rDash.DashLen < 250)) ||
					((rDash.Dashes == 0) && (rDash.DotLen < 250)) ||
					((rDash.DotLen < 250) && (rDash.DashLen < 250)) )
				nStyle = EXC_CHART_LINEF_DOT;
			else
				nStyle = EXC_CHART_LINEF_DASH;
		}
		break;
	}
	return nStyle;
}


INT16 lcl_GetXclLineWidth( sal_Int32 nWidth )
{
	if ( nWidth <= 0 )
		return EXC_CHART_LINEF_HAIR;
	else if ( nWidth <= 35 )
		return EXC_CHART_LINEF_SINGLE;
	else if ( nWidth <= 70 )
		return EXC_CHART_LINEF_DOUBLE;
	else
		return EXC_CHART_LINEF_TRIPLE;
}


UINT16 lcl_GetXclFillStyle( drawing::FillStyle eStyle )
{
	switch( eStyle )
	{
		case drawing::FillStyle_NONE:		return EXC_CHART_AREAF_NONE;
		case drawing::FillStyle_SOLID:		return EXC_CHART_AREAF_SOLID;
		case drawing::FillStyle_GRADIENT:	return EXC_CHART_AREAF_SOLID;
//		case drawing::FillStyle_HATCH:		return EXC_CHART_AREAF_;
	}
	return EXC_CHART_AREAF_SOLID;
}


void lcl_ChangeBrightness( Color& rColor, INT16 nPercent )
{
	rColor.SetRed( (UINT8)((UINT32) rColor.GetRed() * nPercent / 100) );
	rColor.SetGreen( (UINT8)((UINT32) rColor.GetGreen() * nPercent / 100) );
	rColor.SetBlue( (UINT8)((UINT32) rColor.GetBlue() * nPercent / 100) );
}


FontUnderline lcl_GetFontUnderline( sal_Int16 nUnder )
{
	switch( nUnder )
	{
		case awt::FontUnderline::SINGLE:			return UNDERLINE_SINGLE;
		case awt::FontUnderline::DOUBLE:			return UNDERLINE_DOUBLE;
		case awt::FontUnderline::DOTTED:			return UNDERLINE_DOTTED;
		case awt::FontUnderline::DASH:				return UNDERLINE_DASH;
		case awt::FontUnderline::LONGDASH:			return UNDERLINE_LONGDASH;
		case awt::FontUnderline::DASHDOT:			return UNDERLINE_DASHDOT;
		case awt::FontUnderline::DASHDOTDOT:		return UNDERLINE_DASHDOTDOT;
		case awt::FontUnderline::SMALLWAVE:			return UNDERLINE_SMALLWAVE;
		case awt::FontUnderline::WAVE:				return UNDERLINE_WAVE;
		case awt::FontUnderline::DOUBLEWAVE:		return UNDERLINE_DOUBLEWAVE;
		case awt::FontUnderline::BOLD:				return UNDERLINE_BOLD;
		case awt::FontUnderline::BOLDDOTTED:		return UNDERLINE_BOLDDOTTED;
		case awt::FontUnderline::BOLDDASH:			return UNDERLINE_BOLDDASH;
		case awt::FontUnderline::BOLDLONGDASH:		return UNDERLINE_BOLDLONGDASH;
		case awt::FontUnderline::BOLDDASHDOT:		return UNDERLINE_BOLDDASHDOT;
		case awt::FontUnderline::BOLDDASHDOTDOT:	return UNDERLINE_BOLDDASHDOTDOT;
		case awt::FontUnderline::BOLDWAVE:			return UNDERLINE_BOLDWAVE;
	}
	return UNDERLINE_NONE;
}


FontFamily lcl_GetFontFamily( sal_Int16 nFamily )
{
	switch( nFamily )
	{
		case awt::FontFamily::DECORATIVE:	return FAMILY_DECORATIVE;
		case awt::FontFamily::MODERN:		return FAMILY_MODERN;
		case awt::FontFamily::ROMAN:		return FAMILY_ROMAN;
		case awt::FontFamily::SCRIPT:		return FAMILY_SCRIPT;
		case awt::FontFamily::SWISS:		return FAMILY_SWISS;
		case awt::FontFamily::SYSTEM:		return FAMILY_SYSTEM;
	}
	return FAMILY_DONTKNOW;
}


rtl_TextEncoding lcl_GetFontCharSet( sal_Int16 nCharSet )
{
	switch( nCharSet )
	{
		case awt::CharSet::ANSI:		return RTL_TEXTENCODING_MS_1252;
		case awt::CharSet::MAC:			return RTL_TEXTENCODING_APPLE_ROMAN;
		case awt::CharSet::IBMPC_437:	return RTL_TEXTENCODING_IBM_437;
		case awt::CharSet::IBMPC_850:	return RTL_TEXTENCODING_IBM_850;
		case awt::CharSet::IBMPC_860:	return RTL_TEXTENCODING_IBM_860;
		case awt::CharSet::IBMPC_861:	return RTL_TEXTENCODING_IBM_861;
		case awt::CharSet::IBMPC_863:	return RTL_TEXTENCODING_IBM_863;
		case awt::CharSet::IBMPC_865:	return RTL_TEXTENCODING_IBM_865;
		case awt::CharSet::SYSTEM:		return (rtl_TextEncoding) 9;
		case awt::CharSet::SYMBOL:		return RTL_TEXTENCODING_SYMBOL;
   	}
	return RTL_TEXTENCODING_DONTKNOW;
}


UINT8 lcl_GetLegendPosition( chart::ChartLegendPosition ePos )
{
	switch( ePos )
	{
		case chart::ChartLegendPosition_LEFT:	return EXC_CHART_LEGEND_LEFT;
		case chart::ChartLegendPosition_TOP:	return EXC_CHART_LEGEND_TOP;
		case chart::ChartLegendPosition_RIGHT:	return EXC_CHART_LEGEND_RIGHT;
		case chart::ChartLegendPosition_BOTTOM:	return EXC_CHART_LEGEND_BOTTOM;
	}
	return EXC_CHART_LEGEND_NOTDOCKED;
}


UINT8 lcl_GetMarkPos( sal_Int32 nPos )
{
	UINT8 nRet = EXC_CHART_TICK_NOMARK;
	if( nPos & chart::ChartAxisMarks::INNER )
		nRet |= EXC_CHART_TICK_INSIDE;
	if( nPos & chart::ChartAxisMarks::OUTER )
		nRet |= EXC_CHART_TICK_OUTSIDE;
	return nRet;
}


// --- class XclChartDataFormat --------------------------------------

XclChartDataFormat::XclChartDataFormat() :
		nLineStyle( EXC_CHART_LINEF_NONE ),
		nLineWidth( EXC_CHART_LINEF_HAIR ),
		aLineColor( COL_BLACK ),
		nLineIndex( EXC_COLIND_AUTOLINE ),
		nAreaStyle( EXC_CHART_AREAF_NONE ),
		aAreaColor( COL_BLACK ),
		nAreaIndex( EXC_COLIND_AUTOFILLBG ),
		nGradientMode( EXC_CHART_GEL_NONE ),
		nGradientFIndex( 0 ),
		nGradientBIndex( 0 ),
		nGradientRot( 0 ),
		nGradientCol2Pos( 0 ),
		nSegment( 0 ),
		bHasSymbol( TRUE ),
		nFontx( EXC_CHART_FONTX_DEFAULT ),
		aTextColor( COL_BLACK ),
		nTextIndex( EXC_COLIND_AUTOTEXT ),
		nTextFlags( 0x0000 ),
		nLabelFlags( 0x0000 ),
		nDataFormatBase( EXC_CHART_DATAF_RECT ),
		nDataFormatTop( EXC_CHART_DATAF_STRAIGHT ),
		bDiff( TRUE )
{
}


XclChartDataFormat::XclChartDataFormat( const XclChartDataFormat& rSrc ) :
		nLineStyle( rSrc.nLineStyle ),
		nLineWidth( rSrc.nLineWidth ),
		aLineColor( rSrc.aLineColor.GetColor() ),
		nLineIndex( rSrc.nLineIndex ),
		nAreaStyle( rSrc.nAreaStyle ),
		aAreaColor( rSrc.aAreaColor.GetColor() ),
		nAreaIndex( rSrc.nAreaIndex ),
		nGradientMode( rSrc.nGradientMode ),
		nGradientFIndex( rSrc.nGradientFIndex ),
		nGradientBIndex( rSrc.nGradientBIndex ),
		nGradientRot( rSrc.nGradientRot ),
		nGradientCol2Pos( rSrc.nGradientCol2Pos ),
		nSegment( rSrc.nSegment ),
		bHasSymbol( rSrc.bHasSymbol ),
		nFontx( rSrc.nFontx ),
		aTextColor( rSrc.aTextColor.GetColor() ),
		nTextIndex( rSrc.nTextIndex ),
		nTextFlags( rSrc.nTextFlags ),
		nLabelFlags( rSrc.nLabelFlags ),
		nDataFormatBase( rSrc.nDataFormatBase ),
		nDataFormatTop( rSrc.nDataFormatTop ),
		bDiff( FALSE )
{
}


void XclChartDataFormat::SetLineFormat( UINT16 nStyle, INT16 nWidth, const Color& rColor, UINT16 nIndex )
{
	bDiff |= ((nLineStyle != nStyle) || (nLineWidth != nWidth) || (aLineColor != rColor));
	nLineStyle = nStyle;
	nLineWidth = nWidth;
	aLineColor.SetColor( rColor.GetColor() );
	nLineIndex = nIndex;
}


void XclChartDataFormat::SetAreaFormat( UINT16 nStyle, const Color& rColor, UINT16 nIndex )
{
	bDiff |= ((nAreaStyle != nStyle) || (aAreaColor != rColor));
	nAreaStyle = nStyle;
	aAreaColor.SetColor( rColor.GetColor() );
	nAreaIndex = nIndex;
}


void XclChartDataFormat::SetGradient( UINT32 nMode, const Color& rForeColor, UINT16 nForeIndex,
										const Color& rBackColor, UINT16 nBackIndex, INT16 nRot, INT16 nCol2Pos )
{
	bDiff |= ((nGradientMode |= nMode) || (aGradientFColor != rForeColor) || (aGradientBColor != rBackColor) ||
				(nGradientRot != nRot) || (nGradientCol2Pos != nCol2Pos));
	nGradientMode = nMode;
	aGradientFColor.SetColor( rForeColor.GetColor() );
	nGradientFIndex = nForeIndex;
	aGradientBColor.SetColor( rBackColor.GetColor() );
	nGradientBIndex = nBackIndex;
	nGradientRot = nRot;
	nGradientCol2Pos = nCol2Pos;
}


void XclChartDataFormat::SetTextFormat( UINT16 nFx, const Color& rColor, UINT16 nIndex, UINT16 nTFl, UINT16 nLFl )
{
	bDiff |= ((nFontx != nFx) || (aTextColor != rColor) || (nTextFlags != nTFl) || (nLabelFlags != nLFl));
	nFontx = nFx;
	aTextColor.SetColor( rColor.GetColor() );
	nTextIndex = nIndex;
	nTextFlags = nTFl;
	nLabelFlags = nLFl;
}


void XclChartDataFormat::SetSolidType( UINT8 nBase, UINT8 nTop )
{
	bDiff |= ((nDataFormatBase != nBase) || (nDataFormatTop != nTop));
	nDataFormatBase = nBase;
	nDataFormatTop = nTop;
}


UINT16 XclChartDataFormat::GetSymbol( UINT16 nSeries ) const
{
	if( !bHasSymbol )
		return EXC_CHART_MARKF_NOSYMBOL;

	// series number:	0 1 2 3 4 5 6 7 8
	// Xcl symbol:		2 1 3 4 5 8 9 6 7
	nSeries %= EXC_CHART_MARKF_COUNT;
	switch( nSeries )
	{
		case 0:						return 2;
		case 2: case 3: case 4:		return nSeries + 1;
		case 5: case 6:				return nSeries + 3;
		case 7: case 8:				return nSeries - 1;
		default:					return nSeries;
	}
}


// --- struct XclChartText -------------------------------------------

XclChartText::XclChartText( UINT16 nSer, UINT16 nPt, const XclChartDataFormat& rFormats ) :
		nSeries( nSer ),
		nPoint( nPt ),
		nFontx( rFormats.nFontx ),
		nIndex( rFormats.nTextIndex ),
		nRGB( rFormats.aTextColor.GetColor() ),
		nFlags( rFormats.nTextFlags )
{	}


// --- class XclChartTextList ----------------------------------------

XclChartTextList::~XclChartTextList()
{
	for( XclChartText* pText = _First(); pText; pText = _Next() )
		delete pText;
}


// --- class XclObjChart ---------------------------------------------

XclObjChart::XclObjChart( RootData& rRoot, const uno::Reference< drawing::XShape >& rShape )
			:
			XclObj( otChart, rRoot ),
			xChartShape( rShape ),
			rChartObj( *(EscherEx::GetSdrObject( rShape )) ),
			rRootData( rRoot ),
			rPal( *rRoot.pPalette2 ),
			rFontList( *rRoot.pFontRecs ),
			pChartArray( NULL ),
			pStrm( NULL ),
			eChartType( ctUnknown ),
			nMaxSegOffset( 0 ),
			nLevel( 0 ),
			nChartDataColumns( 0 ),
			nChartCategoriesDataType( EXC_CHART_SER_NUM ),		// numeric
			nChartGroup( EXC_CHART_FIRSTGROUP ),
			nCurrentAxis( 0 ),
			bColHeaders( FALSE ),
			bRowHeaders( FALSE ),
			bXAxisDescr( FALSE ),
			bYAxisDescr( FALSE ),
			bChartStacked( FALSE ),
			bChartPercent( FALSE ),
			bChartLine( FALSE ),
			bChartSpline( FALSE ),
			bChart3D( FALSE ),
			bChartDeep( FALSE ),
			bStockUpDown( FALSE ),
			bStockVolume( FALSE ),
			bChartTypeRound( FALSE ),
			bChartTypeBars( FALSE ),
			bWriteMode( FALSE )
{
	XclEscherEx* pEx = pMsodrawing->GetEscherEx();
	pEx->OpenContainer( ESCHER_SpContainer );
	pEx->AddShape( ESCHER_ShpInst_HostControl, SHAPEFLAG_HAVEANCHOR | SHAPEFLAG_HAVESPT );
	EscherPropertyContainer aPropOpt;
	aPropOpt.AddOpt( ESCHER_Prop_LockAgainstGrouping, 0x01040104 );
	aPropOpt.AddOpt( ESCHER_Prop_FitTextToShape, 0x00080008 );
	aPropOpt.AddOpt( ESCHER_Prop_fillColor, 0x0800004E );
	aPropOpt.AddOpt( ESCHER_Prop_fillBackColor, 0x0800004D );
	aPropOpt.AddOpt( ESCHER_Prop_fNoFillHitTest, 0x00110010 );
	aPropOpt.AddOpt( ESCHER_Prop_lineColor, 0x0800004D );
	aPropOpt.AddOpt( ESCHER_Prop_fNoLineDrawDash, 0x00080008 );
	aPropOpt.AddOpt( ESCHER_Prop_fshadowObscured, 0x00020000 );
	aPropOpt.AddOpt( ESCHER_Prop_fPrint, 0x00080000 );
	aPropOpt.Commit( pEx->GetStream() );
	XclEscherClientAnchor( rRoot, rChartObj ).WriteData( *pEx );
	pEx->AddAtom( 0, ESCHER_ClientData );						// OBJ record
	pEx->CloseContainer();	// ESCHER_SpContainer
	pMsodrawing->UpdateStopPos();

	aSerieslistList.Insert( NULL, LIST_APPEND );	// one dummy on index 0

	bInitOk = InitInterface();
	DBG_ASSERT( bInitOk, "XclObjChart: init failed" );
	if ( bInitOk )
	{
		GetChartType();
		// must do it here so that EXTERNSHEET XTIs get updated before written
		BuildSeriesList();

		InitValues();
		InitChartFormats();

		delete pChartArray, pChartArray = NULL;
	}
}


XclObjChart::~XclObjChart()
{
	ULONG j, nCnt;
	ExcUPN* p;
	nCnt = aSeriesYUpnList.Count();
	for ( j=0, p = (ExcUPN*) aSeriesYUpnList.First(); j<nCnt;
			j++, p = (ExcUPN*) aSeriesYUpnList.Next() )
	{
		delete p;
	}
	nCnt = aSeriesXUpnList.Count();
	for ( j=0, p = (ExcUPN*) aSeriesXUpnList.First(); j<nCnt;
			j++, p = (ExcUPN*) aSeriesXUpnList.Next() )
	{
		delete p;
	}
	nCnt = aSeriesNUpnList.Count();
	for ( j=0, p = (ExcUPN*) aSeriesNUpnList.First(); j<nCnt;
			j++, p = (ExcUPN*) aSeriesNUpnList.Next() )
	{
		delete p;
	}
	SvUShorts* ps;
	nCnt = aSerieslistList.Count();
	for ( j=0, ps = (SvUShorts*) aSerieslistList.First(); j<nCnt;
			j++, ps = (SvUShorts*) aSerieslistList.Next() )
	{
		delete ps;
	}
}


//___________________________________________________________________
// get properties

BOOL XclObjChart::GetPropValue( const uno::Reference< beans::XPropertySet >& xProp, const OUString& rString )
{
	BOOL bRet = FALSE;
	if ( xProp.is() )
	{
		TRY
		{
			uno::Reference< beans::XPropertySetInfo > xInfo = xProp->getPropertySetInfo();
			if( xInfo.is() && xInfo->hasPropertyByName( rString ) )
			{
				aAny = xProp->getPropertyValue( rString );
				if( aAny.hasValue() )
					bRet = TRUE;
			}
		}
		CATCH_ALL()
		{
			bRet = FALSE;
		}
		END_CATCH;
	}
	return bRet;
}


BOOL XclObjChart::GetPropBool( const uno::Reference< beans::XPropertySet >& xProp, const OUString& rString )
{
	sal_Bool bVal;
	return GetPropValue( xProp, rString ) && (aAny >>= bVal) && bVal;
}


BOOL XclObjChart::GetPropBool( sal_Bool& rValue, const uno::Reference< beans::XPropertySet >& xProp,
								const OUString& rString )
{
	sal_Bool bGetVal;
	if( GetPropValue( xProp, rString ) && (aAny >>= bGetVal) )
	{
		rValue = bGetVal;
		return TRUE;
	}
	return FALSE;
}


BOOL XclObjChart::GetPropInt32( sal_Int32& rValue, const uno::Reference< beans::XPropertySet >& xProp,
								const OUString& rString )
{
	sal_Int32 nGetVal;
	if( GetPropValue( xProp, rString ) && (aAny >>= nGetVal) )
	{
		rValue = nGetVal;
		return TRUE;
	}
	return FALSE;
}


BOOL XclObjChart::GetPropInt16( sal_Int16& rValue, const uno::Reference< beans::XPropertySet >& xProp,
								const OUString& rString )
{
	sal_Int16 nGetVal;
	if( GetPropValue( xProp, rString ) && (aAny >>= nGetVal) )
	{
		rValue = nGetVal;
		return TRUE;
	}
	return FALSE;
}


BOOL XclObjChart::GetPropDouble( double& rValue, const uno::Reference< beans::XPropertySet >& xProp,
								const OUString& rString )
{
	double fGetVal;
	if( GetPropValue( xProp, rString ) && (aAny >>= fGetVal) )
	{
		rValue = fGetVal;
		return TRUE;
	}
	return FALSE;
}


void XclObjChart::GetChartType()
{
	sal_Int32 nVal;

	OUString aType( xDiagram->getDiagramType() );
	if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_LINE ) ) )
		eChartType = ctLine;
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_AREA ) ) )
		eChartType = ctArea;
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_BAR ) ) )
	{
		if ( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_VERTICAL ) ) ) )
			eChartType = ctBar;
		else
			eChartType = ctColumn;
	}
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_PIE ) ) )
		eChartType = ctPie;
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_DONUT ) ) )
		eChartType = ctDonut;
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_XY ) ) )
		eChartType = ctScatter;
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_NET ) ) )
		eChartType = ctNet;
	else if ( aType == OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_STOCK ) ) )
	{
		eChartType = ctStock;
		bStockUpDown = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_UPDOWN ) ) );
		bStockVolume = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_VOLUME ) ) );
	}

	bChartPercent = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ) );
	bChartStacked = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ) );

	if( (eChartType == ctLine) || (eChartType == ctScatter) )
	{
		bChartLine = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINES ) ) );
		if( GetPropInt32( nVal, xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SPLINETYPE ) ) ) )
			bChartSpline = (nVal != 0);
	}

	bChart3D = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DIM3D ) ) );
	if( bChart3D )
		bChartDeep = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DEEP ) ) );

	bChartTypeBars = (eChartType == ctBar) || (eChartType == ctColumn);
	bChartTypeRound = (eChartType == ctPie) || (eChartType == ctDonut);
}


ColorData XclObjChart::GetColor( const uno::Reference< beans::XPropertySet >& xProp,
								const OUString& rString )
{
	sal_Int32 nRGB;
	if( GetPropValue( xProp, rString ) && (aAny >>= nRGB ) )
		return COLORDATA_RGB( nRGB );		// ignore transparency
	return ColorData( 0 );
}


void XclObjChart::GetTextColor( Color& rColor, UINT16& rIndex,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	rColor.SetColor( GetColor( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCOLOR ) ) ) );
	if( bWriteMode )						// write mode: find color index
	{
		rIndex = rPal.GetColorIndex( rColor );
		rColor.SetColor( rPal.GetRGBValue( rIndex ) );
	}
	else									// init mode: insert new color
		rPal.InsertColor( rColor, EXC_COLOR_CHARTTEXT );
}


ExcFont* XclObjChart::NewExcFont( const uno::Reference< beans::XPropertySet >& xProp )
{
	if( !xProp.is() ) return NULL;

	ExcFont*		pExcFont = new ExcFont( rRootData );
	float			fFloatVal;
	sal_Int16		nShortVal;
	awt::FontSlant	eItalic;
	OUString		sFontName;

	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARHEIGHT ) ) ) && (aAny >>= fFloatVal) )
		pExcFont->SetHeightPt( fFloatVal );
	else
	{
		delete pExcFont;		// property not found -> default font
		return NULL;
	}
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARFONTNAME ) ) ) && (aAny >>= sFontName) )
		pExcFont->SetName( String( sFontName ) );
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARPOSTURE ) ) ) && (aAny >>= eItalic) )
		pExcFont->SetItalic( eItalic != awt::FontSlant_NONE );
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARWEIGHT ) ) ) && (aAny >>= fFloatVal) )
		pExcFont->SetWeight( VCLUnoHelper::ConvertFontWeight( fFloatVal ) );
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARUNDERL ) ) ) && (aAny >>= nShortVal) )
		pExcFont->SetUnderline( lcl_GetFontUnderline( nShortVal ) );
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARFONTFAMILY ) ) ) && (aAny >>= nShortVal) )
		pExcFont->SetFamily( lcl_GetFontFamily( nShortVal ) );
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARFONTCHARSET ) ) ) && (aAny >>= nShortVal) )
		pExcFont->SetCharSet( lcl_GetFontCharSet( nShortVal ) );
	pExcFont->SetStrikeout( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCROSSEDOUT ) ) ) );
	pExcFont->SetOutline( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCONTOURED ) ) ) );
	pExcFont->SetShadow( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARSHADOWED ) ) ) );

	return pExcFont;
}


UINT16 XclObjChart::GetFontx( const uno::Reference< beans::XPropertySet >& xProp )
{
	ExcFont*	pExcFont	= NewExcFont( xProp );
	UINT16		nFontx		= EXC_CHART_FONTX_DEFAULT;

	if( pExcFont )
	{
		if( bWriteMode )						// write mode: find font in list
		{
			if( !rFontList.Find( pExcFont, nFontx ) )
				nFontx = EXC_CHART_FONTX_DEFAULT;
			delete pExcFont;
		}
		else									// init mode: add the font
			nFontx = rFontList.Add( pExcFont );
	}
	return nFontx;
}


void XclObjChart::GetTextFormat( UINT16& rFontx, Color& rColor, UINT16& rColIndex,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	rFontx = GetFontx( xProp );
	GetTextColor( rColor, rColIndex, xProp );
}


void XclObjChart::GetLineformat( UINT16& rStyle, INT16& rWidth, Color& rColor, UINT16& rColIndex,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	drawing::LineStyle	eStyle;
	drawing::LineDash	aDash;
	sal_Int32			nApiWidth;
	sal_Int16			nApiTrans;

	rColor.SetColor( GetColor( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINECOLOR ) ) ) );
	rStyle = EXC_CHART_LINEF_SOLID;
	rWidth = EXC_CHART_LINEF_HAIR;

	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINESTYLE ) ) ) && (aAny >>= eStyle) &&
		GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINEDASH ) ) ) && (aAny >>= aDash) &&
		GetPropInt16( nApiTrans, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINETRANSPARENCE ) ) ) )
		rStyle = lcl_GetXclLineStyle( eStyle, aDash, nApiTrans );
	if( GetPropInt32( nApiWidth, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINEWIDTH ) ) ) )
		rWidth = lcl_GetXclLineWidth( nApiWidth );

	if( bWriteMode )
	{
		rColIndex = rPal.GetColorIndex( rColor );
		rColor.SetColor( rPal.GetRGBValue( rColIndex ) );
	}
	else if( rStyle != EXC_CHART_LINEF_NONE )
		rPal.InsertColor( rColor, EXC_COLOR_CHARTLINE );
}


void XclObjChart::GetAreaformat( UINT16& rStyle, Color& rColor, UINT16& rColIndex,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	rColor.SetColor( GetColor( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLCOLOR ) ) ) );
	rStyle = EXC_CHART_AREAF_SOLID;

	drawing::FillStyle	eStyle;
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLSTYLE ) ) ) && (aAny >>= eStyle) )
		rStyle = lcl_GetXclFillStyle( eStyle );

	if( bWriteMode )
	{
		rColIndex = rPal.GetColorIndex( rColor );
		rColor.SetColor( rPal.GetRGBValue( rColIndex ) );
	}
	else if( rStyle != EXC_CHART_AREAF_NONE )
		rPal.InsertColor( rColor, EXC_COLOR_CHARTAREA );
}


void XclObjChart::GetGradient( UINT32& rMode, UINT16& rForeIndex, UINT16& rBackIndex, INT16& rRot, INT16& rCol2Pos,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	Color aForeColor, aBackColor;
	GetGradient( rMode, aForeColor, rForeIndex, aBackColor, rBackIndex, rRot, rCol2Pos, xProp );
}


void XclObjChart::GetGradient( UINT32& rMode, Color& rForeColor, UINT16& rForeIndex,
								Color& rBackColor, UINT16& rBackIndex, INT16& rRot, INT16& rCol2Pos,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	rMode = EXC_CHART_GEL_NONE;
	rForeIndex = rBackIndex = 0;
	rRot = rCol2Pos = 0;

	drawing::FillStyle	eStyle;
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLSTYLE ) ) ) &&
		(aAny >>= eStyle) && (eStyle == drawing::FillStyle_GRADIENT) )
	{
		awt::Gradient aGradient;
		if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLGRADIENT ) ) ) && (aAny >>= aGradient))
		{
			rForeColor.SetColor( (UINT32) aGradient.StartColor );
			lcl_ChangeBrightness( rForeColor, aGradient.StartIntensity );
			rBackColor.SetColor( (UINT32) aGradient.EndColor );
			lcl_ChangeBrightness( rBackColor, aGradient.EndIntensity );

			if( bWriteMode )
			{
				rForeIndex = rPal.GetColorIndex( rForeColor );
				rForeColor.SetColor( rPal.GetRGBValue( rForeIndex ) );
				rBackIndex = rPal.GetColorIndex( rBackColor );
				rBackColor.SetColor( rPal.GetRGBValue( rBackIndex ) );
			}
			else
			{
				rPal.InsertColor( rForeColor, EXC_COLOR_CHARTAREA );
				rPal.InsertColor( rBackColor, EXC_COLOR_CHARTAREA );
			}

			switch( aGradient.Style )
			{
    			case GradientStyle_LINEAR:
    			case GradientStyle_AXIAL:
				{
					rMode = EXC_CHART_GEL_LINEAR;
					INT16 nAngle = ((aGradient.Angle + 225) / 450) % 8;
					rRot = -45 * ((8 - nAngle) % 4);
					if( aGradient.Style == GradientStyle_LINEAR )
						rCol2Pos = (nAngle < 4) ? 100 : 0;
					else
						rCol2Pos = ((nAngle % 4) == 0) ? -50 : 50;
				}
				break;
    			case GradientStyle_RADIAL:
    			case GradientStyle_ELLIPTICAL:
    			case GradientStyle_SQUARE:
    			case GradientStyle_RECT:
				{
					rCol2Pos = 0;
					if( (aGradient.XOffset > 24) && (aGradient.XOffset < 76) &&
						(aGradient.YOffset > 24) && (aGradient.YOffset < 76) )
						rMode = EXC_CHART_GEL_CENTER | EXC_CHART_GEL_EXPCENTERFLAG;
					else
					{
						rMode = EXC_CHART_GEL_CORNER;
						if( aGradient.XOffset > 50 )
							rMode |= EXC_CHART_GEL_EXPCORN1FLAG;
						if( aGradient.YOffset > 50 )
							rMode |= EXC_CHART_GEL_EXPCORN2FLAG;
					}
				}
			}
		}
	}
}


BOOL XclObjChart::GetDataCaption( UINT16& rTextFlags, UINT16& rLabelFlags,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	rTextFlags = rLabelFlags = 0x0000;

	sal_Int32	nCaption;
	if( !GetPropInt32( nCaption, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DATACAPTION ) ) ) )
		return FALSE;

	BOOL bValue		= TRUEBOOL( nCaption & chart::ChartDataCaption::VALUE );
	BOOL bPercent	= TRUEBOOL( nCaption & chart::ChartDataCaption::PERCENT );
	BOOL bText		= TRUEBOOL( nCaption & chart::ChartDataCaption::TEXT );

	if( bPercent && !bChartTypeRound )
	{
		bValue = TRUE;
		bPercent = FALSE;
	}

	if( bValue )
	{
		rTextFlags |= EXC_CHART_TEXT_SHOWVALUE;
		rLabelFlags |= EXC_CHART_ATLAB_SHOWVALUE;
	}
	else if( bPercent )
	{
		rTextFlags |= EXC_CHART_TEXT_SHOWPERCENT;
		rLabelFlags |= EXC_CHART_ATLAB_SHOWPERCENT;
	}

	if( bText )
	{
		rTextFlags |= EXC_CHART_TEXT_SHOWLABEL;
		rLabelFlags |= EXC_CHART_ATLAB_SHOWLABEL;
		if( bPercent )
		{
			rTextFlags |= EXC_CHART_TEXT_SHOWLABELPERC;
			rLabelFlags |= EXC_CHART_ATLAB_SHOWLABELPERC;
		}
	}
	if( (bText || bValue || bPercent) && (nCaption & chart::ChartDataCaption::SYMBOL) )
		rTextFlags |= EXC_CHART_TEXT_SHOWKEY;
	return TRUE;
}


void XclObjChart::GetFormats( XclChartDataFormat& rFormats,
							const uno::Reference< beans::XPropertySet >& xProp,
							BOOL bGetLineArea, BOOL bGetText )
{
	sal_Int32	nVal;

	// lines & areas
	if( bGetLineArea )
	{
		UINT32		nMode;
		UINT16		nStyle, nIndex, nBackIndex;
		INT16		nWidth, nRot, nCol2Pos;
		Color		aColor, aBackColor;

		GetLineformat( nStyle, nWidth, aColor, nIndex, xProp );
		if( (eChartType == ctScatter) && !bChartLine )
			nStyle = EXC_CHART_LINEF_NONE;
		rFormats.SetLineFormat( nStyle, nWidth, aColor, nIndex );

		GetAreaformat( nStyle, aColor, nIndex, xProp );
		rFormats.SetAreaFormat( nStyle, aColor, nIndex );

		GetGradient( nMode, aColor, nIndex, aBackColor, nBackIndex, nRot, nCol2Pos, xProp );
		rFormats.SetGradient( nMode, aColor, nIndex, aBackColor, nBackIndex, nRot, nCol2Pos );
	}

	// pie chart segments
	if( bChartTypeRound )
		if( GetPropInt32( nVal, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SEGMENTOFFSET ) ) ) )
			rFormats.SetSegmentOffset( UINT16(nVal) );

	// line symbols
	if( GetPropInt32( nVal, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SYMBOLTYPE ) ) ) )
		rFormats.SetSymbol( nVal != chart::ChartSymbolType::NONE );

	// data captions
	if( bGetText )
	{
		UINT16 nTextFlags, nLabelFlags;
		if( GetDataCaption( nTextFlags, nLabelFlags, xProp ) )
		{
			UINT16	nFontx, nIndex;
			Color	aColor;

			GetTextFormat( nFontx, aColor, nIndex, xProp );
			rFormats.SetTextFormat( nFontx, aColor, nIndex, nTextFlags, nLabelFlags );
		}
	}

	// 3D bar style
	if ( GetPropInt32( nVal, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SOLIDTYPE ) ) ) )
		switch( nVal )
		{
			case chart::ChartSolidType::RECTANGULAR_SOLID:
				rFormats.SetSolidType( EXC_CHART_DATAF_RECT, EXC_CHART_DATAF_STRAIGHT );
			break;
			case chart::ChartSolidType::CYLINDER:
				rFormats.SetSolidType( EXC_CHART_DATAF_CIRC, EXC_CHART_DATAF_STRAIGHT );
			break;
			case chart::ChartSolidType::PYRAMID:
				rFormats.SetSolidType( EXC_CHART_DATAF_RECT, EXC_CHART_DATAF_SHARP );
			break;
			case chart::ChartSolidType::CONE:
				rFormats.SetSolidType( EXC_CHART_DATAF_CIRC, EXC_CHART_DATAF_SHARP );
			break;
			default:
				rFormats.SetSolidType( EXC_CHART_DATAF_RECT, EXC_CHART_DATAF_STRAIGHT );
		}
}


//___________________________________________________________________
// init, saving

ULONG XclObjChart::GetLen() const
{	// length of all OBJ subrecords including IDs and LENs
	return XclObj::GetLen() + 4;
}


void XclObjChart::InitChartFormats()
{
	GoThroughChart( FALSE );
}


void XclObjChart::SaveCont( XclExpStream& rStrm )
{
	XclObj::SaveCont( rStrm );				// ftCmo subrecord
	rStrm << UINT16(0) << UINT16(0);		// ftEnd subrecord
}


void XclObjChart::Save( XclExpStream& rStrm )
{
	// content of OBJ record
	XclObj::Save( rStrm );
	// second MSODRAWING record and TXO and CONTINUE records
	XclObj::SaveTextRecs( rStrm );			// we shouldn't have any ...

	// write the chart records - raw write mode with SvStream - no continue handling
	ExcBofC8().Save( rStrm );
	pStrm = &rStrm;
	GoThroughChart( TRUE );
	pStrm = NULL;
	ExcEof().Save( rStrm );
}


void XclObjChart::GoThroughChart( BOOL bSetWriteMode )
{
	bWriteMode = bSetWriteMode;
	DBG_ASSERT( !bWriteMode || pStrm, "XclObjChart::GoThroughChart() - no output stream!" );

	nChartGroup = EXC_CHART_FIRSTGROUP;
	nCurrentAxis = EXC_CHART_FIRSTXAXIS;

	if ( bInitOk )
	{
		WriteSheetHeaderSetup();
		WriteChart();

		WriteBeginLevel();
		WriteGroupFrame( xChartDoc->getArea(), FALSE );
		WriteTheSeries();
		WriteShtprops();
		WriteTheText();
		WriteAllAxes();
		WriteTheMainTitle();
		WriteTextList();
		WriteEndLevel();

		DBG_ASSERT( !nLevel, "XclObjChart::Save - missing END level!" );
		while( nLevel )
			WriteEndLevel();

		WriteTheSiindex();
	}
}


BOOL XclObjChart::InitInterface()
{
	SfxInPlaceObjectRef aIPObj( ((SdrOle2Obj&)rChartObj).GetObjRef() );
	if ( !aIPObj.Is() )	return FALSE;

	SfxObjectShell*	pObjSh = aIPObj->GetObjectShell();
	if( !pObjSh ) return FALSE;

	uno::Reference< lang::XComponent > xCompo( pObjSh->GetModel().get() );
	if( !xCompo.is() ) return FALSE;

	xChartDoc = uno::Reference< chart::XChartDocument >( xCompo, uno::UNO_QUERY );
	xDocProp = uno::Reference< beans::XPropertySet >( xChartDoc, uno::UNO_QUERY );
	if ( !xChartDoc.is() || !xDocProp.is() ) return FALSE;

	xDiagram = xChartDoc->getDiagram();
	xDiaProp = uno::Reference< beans::XPropertySet >( xDiagram, uno::UNO_QUERY );
	xDiagr3D = uno::Reference< chart::X3DDisplay >( xDiagram, uno::UNO_QUERY );
	if ( !xDiagram.is() || !xDiaProp.is() || !xDiagr3D.is() ) return FALSE;

	SvInPlaceObjectRef aIPObj2( aIPObj );
	SchMemChart* pChartData = SchDLL::GetChartData( aIPObj2 );
	if ( !pChartData ) return FALSE;

	pChartArray = new ScChartArray( rRootData.pDoc, *pChartData );

	return TRUE;
}


void XclObjChart::InitValues()
{
	// scaling factors for nearly all positions and sizes
	const awt::Size& rSize = xChartShape->getSize();
	fX4000 = 4000.0 / double( rSize.Width );
	fY4000 = 4000.0 / double( rSize.Height );

	// position and size of diagram shape (without axis titles), existence of axis description
	uno::Reference< drawing::XShape > xDiaShape( xDiagram, uno::UNO_QUERY );
	GetPosSize( aDiaPosSize, xDiaShape );

	uno::Reference< chart::XAxisXSupplier > xDiaXSup( xDiagram, uno::UNO_QUERY );
	if ( xDiaXSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXIS ) ) ) )
	{
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISTIT ) ) ) )
		{
			uno::Reference< drawing::XShape > xTitleShape = xDiaXSup->getXAxisTitle();
			if( xTitleShape.is() )
			{
				XclPosSize aPosSize;
				GetPosSize( aPosSize, xTitleShape );
				if( eChartType == ctBar )
				{
					aDiaPosSize.nPosX += aPosSize.nWidth;
					aDiaPosSize.nWidth -= aPosSize.nWidth;
				}
				else
					aDiaPosSize.nHeight -= aPosSize.nHeight;
			}
		}
		bXAxisDescr = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISDESCR ) ) );
	}

	uno::Reference< chart::XAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
	if ( xDiaYSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXIS ) ) ) )
	{
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISTIT ) ) ) )
		{
			uno::Reference< drawing::XShape > xTitleShape = xDiaYSup->getYAxisTitle();
			if( xTitleShape.is() )
			{
				XclPosSize aPosSize;
				GetPosSize( aPosSize, xTitleShape );
				if( eChartType == ctBar )
					aDiaPosSize.nHeight -= aPosSize.nHeight;
				else
				{
					aDiaPosSize.nPosX += aPosSize.nWidth;
					aDiaPosSize.nWidth -= aPosSize.nWidth;
				}
			}
		}
		bYAxisDescr = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISDESCR ) ) );
	}

	// global formats
	GetFormats( aDiaFormats, xDiaProp, TRUE, FALSE );
}


//___________________________________________________________________
// common records

void XclObjChart::WriteBeginLevel()
{
	if( !bWriteMode ) return;
	nLevel++;
	WriteEmptyRecord( 0x1033 );	// BEGIN
}


void XclObjChart::WriteEndLevel()
{
	if( !bWriteMode ) return;
	DBG_ASSERT( nLevel, "XclObjChart::WriteEndLevel: no level" );
	if ( !nLevel ) return;

	nLevel--;
	WriteEmptyRecord( 0x1034 );	// END
}


void XclObjChart::WriteSheetHeaderSetup()
{
	if( !bWriteMode ) return;
	const BYTE pData[] = {
		0x14, 0x00, 0x00, 0x00,								// HEADER (none)
		0x15, 0x00, 0x00, 0x00,								// FOOTER (none)
		0x83, 0x00, 0x02, 0x00, 0x00, 0x00,					// HCENTER
		0x84, 0x00, 0x02, 0x00, 0x00, 0x00,					// VCENTER
		0xa1, 0x00, 0x22, 0x00,								// SETUP
		0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x00,
		0x01, 0x00, 0x04, 0x00, 0x00, 0x00,	0x80, 0x07,
		0x8A, 0x1D, 0x3C, 0xFC, 0xFD, 0x7E, 0xDF, 0x3F,
		0x8A, 0x1D, 0x3C, 0xFC, 0xFD, 0x7E, 0xDF, 0x3F,
		0x00, 0x00
	};
	pStrm->SetStreamPos( STREAM_SEEK_TO_END );
	pStrm->Write( pData, sizeof(pData) );		// raw write mode
}


void XclObjChart::WriteChart()
{
	if( !bWriteMode ) return;

	const MapMode aSrc( MAP_100TH_MM );
	const MapMode aDst( MAP_POINT );
	Size aSize( OutputDevice::LogicToLogic( rChartObj.GetBoundRect().GetSize(), aSrc, aDst ) );

	StartRecord( 0x1002, 16 );	// CHART
		// xPos, yPos, xSize, ySize   all in 16.16 format
	*pStrm	<< UINT32(0) << UINT32(0)
			<< UINT32(UINT32(aSize.Width()) << 16)
			<< UINT32(UINT32(aSize.Height()) << 16);
	EndRecord();
}


void XclObjChart::WriteShtprops()
{
	if( !bWriteMode ) return;
	StartRecord( 0x1044, 4 );					// SHTPROPS
	*pStrm	<< UINT16(EXC_CHART_SHTPR_CHANGED)	// flags
			<< UINT8(0)							// empty cells: not plotted
			<< UINT8(0);						//! not mentioned in docs but Xcl writes it
	EndRecord();
}


//___________________________________________________________________
// FRAME group

void XclObjChart::WriteGroupFrame( const uno::Reference< drawing::XShape >& xShape, BOOL bAutoSize )
{
	uno::Reference< beans::XPropertySet > xProp( xShape, uno::UNO_QUERY );
	WriteGroupFrame( xProp, bAutoSize );
}


void XclObjChart::WriteGroupFrame( const uno::Reference< beans::XPropertySet >& xProp, BOOL bAutoSize )
{
	WriteFrame( bAutoSize );
	WriteBeginLevel();
	WriteLineformat( xProp );
	WriteAreaformat( xProp );
	WriteEndLevel();
}


void XclObjChart::WriteFrame( BOOL bAutoSize )
{
	if( !bWriteMode ) return;
	StartRecord( 0x1032, 4 );	// FRAME
	*pStrm	<< UINT16(0)		// regular rectangle, no border
			<< UINT16( EXC_CHART_FRAME_AUTOSIZE | (bAutoSize ? EXC_CHART_FRAME_AUTOPOS : 0) );
	EndRecord();
}


void XclObjChart::WriteLineformat( const uno::Reference< beans::XPropertySet >& xProp, UINT16 nGrbit )
{
	UINT16	nStyle, nIndex;
	INT16	nWidth;
	Color	aColor;
	GetLineformat( nStyle, nWidth, aColor, nIndex, xProp );
	WriteLineformat( aColor.GetColor(), nIndex, nStyle, nWidth, nGrbit );
}


void XclObjChart::WriteLineformat( const XclChartDataFormat& rF, UINT16 nGrbit )
{
	WriteLineformat( rF.aLineColor.GetColor(), rF.nLineIndex, rF.nLineStyle, rF.nLineWidth, nGrbit );
}


void XclObjChart::WriteLineformat( ColorData nRGB, UINT16 nIndex, UINT16 nStyle, INT16 nWidth, UINT16 nGrbit )
{
	if( !bWriteMode ) return;
	StartRecord( 0x1007, 12 );	// LINEFORMAT
	WriteRGB( nRGB );			// line RGB
	*pStrm	<< nStyle			// line style
			<< nWidth			// line weight
			<< nGrbit			// flags
			<< nIndex;			// color index
	EndRecord();
}


void XclObjChart::WriteAreaformat( const uno::Reference< beans::XPropertySet >& xProp, UINT16 nGrbit )
{
	UINT16	nStyle, nIndex;
	Color	aColor;
	GetAreaformat( nStyle, aColor, nIndex, xProp );
	WriteAreaformat( aColor.GetColor(), COL_BLACK, nIndex, EXC_COLIND_AUTOFILLBG, nStyle, nGrbit );
	WriteGelframe( xProp );
}


void XclObjChart::WriteAreaformat( const XclChartDataFormat& rF, UINT16 nGrbit )
{
	WriteAreaformat( rF.aAreaColor.GetColor(), COL_BLACK, rF.nAreaIndex, EXC_COLIND_AUTOFILLBG, rF.nAreaStyle, nGrbit );
	WriteGelframe( rF );
}


void XclObjChart::WriteAreaformat( ColorData nForeRGB, ColorData nBackRGB,
			UINT16 nForeIndex, UINT16 nBackIndex, UINT16 nStyle, UINT16 nGrbit )
{
	if( !bWriteMode ) return;
	StartRecord( 0x100A, 16 );	// AREAFORMAT
	WriteRGB( nForeRGB );		// foreground RGB
	WriteRGB( nBackRGB );		// background RGB
	*pStrm	<< nStyle			// fill style
			<< nGrbit			// flags
			<< nForeIndex		// foreground color index
			<< nBackIndex;		// background color index
	EndRecord();
}


void XclObjChart::WriteGelframe( const uno::Reference< beans::XPropertySet >& xProp )
{
	UINT32	nMode;
	UINT16	nForeIndex, nBackIndex;
	INT16	nRot, nCol2Pos;
	GetGradient( nMode, nForeIndex, nBackIndex, nRot, nCol2Pos, xProp );
	WriteGelframe( nMode, nForeIndex, nBackIndex, nRot, nCol2Pos );
}


void XclObjChart::WriteGelframe( const XclChartDataFormat& rF )
{
	WriteGelframe( rF.nGradientMode, rF.nGradientFIndex, rF.nGradientBIndex, rF.nGradientRot, rF.nGradientCol2Pos );
}


void XclObjChart::WriteGelframe( UINT32 nMode, UINT16 nForeIndex, UINT16 nBackIndex, INT16 nRot, INT16 nCol2Pos )
{
	if( !bWriteMode || ((nMode & EXC_CHART_GEL_EXPMODEMASK) == EXC_CHART_GEL_NONE) )
		return;

	StartRecord( 0x1066, 188 );			// GELFRAME
	*pStrm	<< UINT32(0xF00B01E3)
			<< UINT32(180);
	for( UINT16 nCounter = 0x0180; nCounter <= 0x019C; nCounter++ )
	{
		UINT16 nCounterOut = nCounter;
		UINT32 nData = 0;
		switch( nCounter )
		{
			case 0x0180:				// gradient mode
				nData = nMode & EXC_CHART_GEL_EXPMODEMASK;
			break;
			case 0x0181:				// color 1
				nData = EXC_CHART_GEL_TYPECOLOR | nForeIndex;
			break;
			case 0x0183:				// color 2
				nData = EXC_CHART_GEL_TYPECOLOR | nBackIndex;
			break;
			case 0x0182:
			case 0x0184:
				nData = 0x00010000;
			break;
			case 0x0185:
				nData = 0x100000F4;
			break;
			case 0x0186:
			case 0x0187:
			case 0x0197:
				nCounterOut |= 0xC000;
			break;
			case 0x018B:				// rotation
			{
				INT32 nIntData = nRot;
				nData = (*((UINT32*)(&nIntData)) << 16) & 0xFFFF0000;
			}
			break;
			case 0x018C:				// col2pos
			{
				INT32 nIntData = nCol2Pos;
				nData = *(UINT32*)(&nIntData);
			}
			break;
			case 0x018D:
			case 0x018F:
				if( nMode & EXC_CHART_GEL_EXPCORN1FLAG )
					nData |= EXC_CHART_GEL_CORNERFLAG;
				if( nMode & EXC_CHART_GEL_EXPCENTERFLAG )
					nData |= EXC_CHART_GEL_CENTERFLAG;
			break;
			case 0x018E:
			case 0x0190:
				if( nMode & EXC_CHART_GEL_EXPCORN2FLAG )
					nData |= EXC_CHART_GEL_CORNERFLAG;
				if( nMode & EXC_CHART_GEL_EXPCENTERFLAG )
					nData |= EXC_CHART_GEL_CENTERFLAG;
			break;
			case 0x019C:
				nData = 0x40000003;
			break;
		}
		*pStrm	<< nCounterOut
				<< nData;
	}
	*pStrm	<< UINT16(0x01BF)
			<< UINT32(0x001F001C);
	EndRecord();
}


//___________________________________________________________________
// POS record, positions & sizes

void XclObjChart::WritePos( const uno::Reference< drawing::XShape >& xShape, TextType eType )
{
	if( !bWriteMode ) return;
	XclPosSize aPos;
	GetPosSize( aPos, xShape );
	WritePos( aPos, eType );
}


void XclObjChart::WritePos( const XclPosSize& rPos, TextType eType )
{
	if( !bWriteMode ) return;
	StartRecord( 0x104F, 20 );	// POS
	if( eType == ttLegend )
		*pStrm << UINT16(5) << UINT16(2);
	else
		*pStrm << UINT16(2) << UINT16(2);
	WritePosData( rPos, eType );
	EndRecord();
}


void XclObjChart::WritePosData( const uno::Reference< drawing::XShape >& xShape, TextType eType )
{
	if( !bWriteMode ) return;
	XclPosSize aPos;
	GetPosSize( aPos, xShape );
	WritePosData( aPos, eType );
}


void XclObjChart::WritePosData( const XclPosSize& rPos, TextType eType )
{
	if( !bWriteMode ) return;

	// sometimes Excel expects default-relative position:
	// -> position is relative to default position
	// -> default position is dependent on text type
	// -> axis title position is dependent on axis direction
	// -> axis direction is dependent on chart type
	INT32 nPosX = rPos.nPosX;
	INT32 nPosY = rPos.nPosY;
	if( eType == ttTitle )
	{
		nPosX = GetDefRelPos( rPos.nPosX, rPos.nWidth, 0, 4000, daCenter, 0 );
		nPosY = GetDefRelPos( rPos.nPosY, rPos.nHeight, 0, 4000, daBelowTop, 80 );
	}
	else if( ((eType == ttXAxisTitle) && (eChartType != ctBar)) || ((eType == ttYAxisTitle) && (eChartType == ctBar)) )
	{
		nPosY = GetDefRelPos( rPos.nPosX, rPos.nWidth, aDiaPosSize.nPosX, aDiaPosSize.nWidth, daCenter, 0, 1000 );
		nPosX = GetDefRelPos( rPos.nPosY, rPos.nHeight, aDiaPosSize.nPosY, aDiaPosSize.nHeight, daBelowBottom, 0, -1000 );
	}
	else if( ((eType == ttYAxisTitle) && (eChartType != ctBar)) || ((eType == ttXAxisTitle) && (eChartType == ctBar)) )
	{
		nPosX = GetDefRelPos( rPos.nPosX, rPos.nWidth, aDiaPosSize.nPosX, aDiaPosSize.nWidth, daAboveTop, 0, 1000 );
		nPosY = GetDefRelPos( rPos.nPosY, rPos.nHeight, aDiaPosSize.nPosY, aDiaPosSize.nHeight, daCenter, 0, -1000 );
	}
	else if( eType == ttZAxisTitle )
		nPosX = nPosY = 0;

	// correct size
	INT32	nWidth	= rPos.nWidth;
	INT32	nHeight	= rPos.nHeight;
	switch( eType )
	{
		case ttTitle:
		case ttXAxisTitle:
		case ttYAxisTitle:
		case ttZAxisTitle:
			nWidth = MM100_TO_PIXEL( double(nWidth) / fX4000 );
			nHeight = MM100_TO_PIXEL( double(nHeight) / fY4000 );
		break;
	}
	if( eType == ttTitle )
		nHeight += (nHeight >> 1);

	*pStrm << nPosX << nPosY << nWidth << nHeight;
}


// INT32 GetDefRelPos() - get position relative to default position
// >nPos<, >nSize<:			position, size of object
// >nParPos<, >nParSize<:	position, size of parent shape
// >eDefaultAlign<:			enum DefaultAlign, alignment of default pos to parent shape
// >nDist<:					distance between margins of parent shape and default pos
// >nScaling<:				alternative scaling factor, default is 4000
INT32 XclObjChart::GetDefRelPos( INT32 nPos, INT32 nSize, INT32 nParPos, INT32 nParSize,
								DefaultAlign eDefAlign, INT32 nDist, INT32 nScaling )
{
	switch( eDefAlign )
	{
		case daAboveTop:	nPos -= (nParPos - nSize - nDist);				break;
		case daBelowTop:	nPos -= (nParPos + nDist);						break;
		case daCenter:		nPos -= (nParPos + ((nParSize - nSize) >> 1));	break;
		case daAboveBottom:	nPos -= (nParPos + nParSize - nSize - nDist);	break;
		case daBelowBottom:	nPos -= (nParPos + nParSize + nDist);			break;
	}
	return INT32(double(nPos) * nScaling / nParSize);
}


void XclObjChart::GetPosSize( XclPosSize& rP, const uno::Reference< drawing::XShape >& xShape )
{
	rP.Set( 0, 0, 0, 0, 0 );
	if ( !xShape.is() ) return;

	const awt::Point&	rPos	= xShape->getPosition();
	const awt::Size&	rSize	= xShape->getSize();
	rP.Set( INT32(rPos.X), INT32(rPos.Y), INT32(rSize.Width), INT32(rSize.Height) );

	uno::Reference< beans::XPropertySet > xProp( xShape, uno::UNO_QUERY );
	if( xProp.is() )
	{
		UINT16 nRealAngle;
		if( GetRotation( nRealAngle, rP.nAngle, xProp ) && nRealAngle )
		{
			double	fSin			= sin( F_PI180 * nRealAngle );
			double	fCos			= cos( F_PI180 * nRealAngle );
			INT32	nSinWidth		= INT32(fSin * rP.nWidth);
			INT32	nCosWidth		= INT32(fCos * rP.nWidth);
			INT32	nSinHeight		= INT32(fSin * rP.nHeight);
			INT32	nCosHeight		= INT32(fCos * rP.nHeight);
			INT32	nBoundWidth		= Abs( nCosWidth ) + Abs( nSinHeight );
			INT32	nBoundHeight	= Abs( nSinWidth ) + Abs( nCosHeight );

			if( nRealAngle <= 90 )
				rP.nPosY -= nSinWidth;
			else if( nRealAngle < 180 )
			{
				rP.nPosX += nCosWidth;
				rP.nPosY -= nBoundHeight;
			}
			else if( nRealAngle < 270 )
			{
				rP.nPosX -= nBoundWidth;
				rP.nPosY += nCosHeight;
			}
			else
				rP.nPosX += nSinHeight;

			rP.nWidth = nBoundWidth;
			rP.nHeight = nBoundHeight;
		}
	}

	rP.nPosX	= INT32(double(rP.nPosX) * fX4000);
	rP.nPosY	= INT32(double(rP.nPosY) * fY4000);
	rP.nWidth	= INT32(double(rP.nWidth) * fX4000);
	rP.nHeight	= INT32(double(rP.nHeight) * fY4000);
}


BOOL XclObjChart::GetRotation( UINT16& nRealAngle, UINT16& nExcAngle,
								const uno::Reference< beans::XPropertySet >& xProp )
{
	nRealAngle = nExcAngle = 0;

	sal_Int32 nApiAngle;
	if( GetPropInt32( nApiAngle, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTROTATION ) ) ) )
	{
		nRealAngle = (UINT16)(nApiAngle / 100);
		nExcAngle = XclExpHelper::GetRotation( nApiAngle );
		return TRUE;
	}
	return FALSE;
}


UINT16 XclObjChart::GetRotationFlags( UINT16 nExcAngle )
{
	if( (nExcAngle > 45) && (nExcAngle <= 90) )
		return EXC_CHART_ROT_CCLOCKW;
	if( (nExcAngle > 135) && (nExcAngle <=180) )
		return EXC_CHART_ROT_CLOCKW;
	return 0x0000;
}


//___________________________________________________________________
// TEXT group

void XclObjChart::WriteTheText()
{
	if( !bWriteMode ) return;

	WriteDefaulttext( 2 );		// default text characteristics for all text in the chart
	uno::Reference< drawing::XShape > xTextShape;
	WriteGroupText( xTextShape, ttNone );
	switch ( eChartType )
	{
		case ctPie :
		case ctDonut :
		case ctStock :
		{
			WriteDefaulttext( 3 );			// undocumented
			uno::Reference< drawing::XShape > xTextShape;
			WriteGroupText( xTextShape, ttNone );
		}
		break;
	}
}


void XclObjChart::WriteDefaulttext( UINT16 nId )
{
	if( bWriteMode )
		WriteUINT16Record( 0x1024, nId );	// DEFAULTTEXT
}


void XclObjChart::WriteGroupText( const uno::Reference< drawing::XShape >& xTextShape, TextType eType )
{
	// starting the text group...
	XclPosSize aPosSize;
	GetPosSize( aPosSize, xTextShape );
	WriteText( xTextShape, aPosSize, eType );	// find color or write TEXT

	WriteBeginLevel();

	// write POS for specific text types
	switch( eType )
	{
		case ttTitle:
		case ttXAxisTitle:
		case ttYAxisTitle:
		case ttZAxisTitle:	WritePos( aPosSize, eType );	break;
	}

	uno::Reference< beans::XPropertySet > xProp( xTextShape, uno::UNO_QUERY );
	WriteFontx( xProp );		// insert font to font list or write the index
	WriteAI();

	// link data for specific text types
	UINT16 nLinkObj = EXC_CHART_OLINK_NONE;
	switch( eType )
	{
		case ttTitle:		nLinkObj = EXC_CHART_OLINK_TITLE;	break;
		case ttXAxisTitle:	nLinkObj = EXC_CHART_OLINK_XAXIS;	break;
		case ttYAxisTitle:	nLinkObj = EXC_CHART_OLINK_YAXIS;	break;
		case ttZAxisTitle:	nLinkObj = EXC_CHART_OLINK_ZAXIS;	break;
	}

	if ( (nLinkObj != EXC_CHART_OLINK_NONE) && xTextShape.is() )
	{
		WriteSeriestext( xProp );
		WriteGroupFrame( xTextShape );		// find frame colors or write them
		WriteObjectlink( nLinkObj, 0, 0 );
	}

	WriteEndLevel();
}


// data point caption
void XclObjChart::WriteGroupText( UINT16 nSeries, UINT16 nPoint, UINT16 nFontx,
								ColorData nRGB, UINT16 nIndex, UINT16 nFlags )
{
	XclPosSize aPosSize;
	aPosSize.nPosX = aPosSize.nPosY = aPosSize.nWidth = aPosSize.nHeight = 0;
	aPosSize.nAngle = 0;

	WriteText( aPosSize, nRGB, nIndex, ttDataCaption, nFlags | EXC_CHART_TEXT_AUTOTEXT );
	WriteBeginLevel();
	WritePos( aPosSize, ttDataCaption );
	WriteFontx( nFontx );
	WriteAI();
	WriteObjectlink( EXC_CHART_OLINK_DATA, nSeries, nPoint );
	WriteEndLevel();
}


void XclObjChart::WriteText( const uno::Reference< drawing::XShape >& xTextShape,
							const XclPosSize& rPosSize, TextType eType )
{
	UINT16	nFlags = xTextShape.is() ? 0x0000 : EXC_CHART_TEXT_AUTOTEXT;
	UINT16	nIndex = EXC_COLIND_AUTOTEXT;
	Color	aColor( COL_BLACK );

	// text color
	uno::Reference< beans::XPropertySet > xProp( xTextShape, uno::UNO_QUERY );
	if( xProp.is() )
		GetTextColor( aColor, nIndex, xProp );		// insert into palette or get index
	else
		nFlags |= EXC_CHART_TEXT_AUTOCOLOR;

	WriteText( rPosSize, aColor.GetColor(), nIndex, eType, nFlags );
}


void XclObjChart::WriteText( const XclPosSize& rPosSize, const ColorData nRGB,
							UINT16 nIndex, TextType eType, UINT16 nFlags )
{
	if( !bWriteMode ) return;

	// flags
	nFlags |= EXC_CHART_TEXT_AUTOMODE;
	nFlags |= EXC_CHART_TEXT_GETROTFLAGS( GetRotationFlags( rPosSize.nAngle ) );

	// label placement
	UINT16 nPlacement = EXC_CHART_TEXT_POSDEFAULT;
	switch( eType )
	{
		case ttTitle:
		case ttXAxisTitle:
		case ttYAxisTitle:	nPlacement = EXC_CHART_TEXT_POSMOVED;	break;
		case ttLegend:
		case ttZAxisTitle:	nPlacement = EXC_CHART_TEXT_POSDEFAULT;	break;
		case ttDataCaption:
			if( (eChartType == ctLine) || (eChartType == ctArea) )
				nPlacement = EXC_CHART_TEXT_POSABOVE;
		break;
	}

	StartRecord( 0x1025, 32 );						// TEXT
	*pStrm	<< UINT8(EXC_CHART_TEXT_ALIGNCENTER)	// horizontal alignment
			<< UINT8(EXC_CHART_TEXT_ALIGNCENTER)	// vertical alignment
			<< UINT16(EXC_CHART_TEXT_BGTRANS);		// character background
	WriteRGB( nRGB );								// RGB value of the text color
	WritePosData( rPosSize, ttCommon );				// position & size
	*pStrm	<< nFlags								// option flags
			<< nIndex								// index to color value of text
			<< nPlacement							// data label placement
			<< rPosSize.nAngle;						// text rotation
	EndRecord();
}


void XclObjChart::WriteFontx( const uno::Reference< beans::XPropertySet >& xProp )
{
	WriteFontx( GetFontx( xProp ) );
}


void XclObjChart::WriteFontx( UINT16 nFontx )
{
	if( bWriteMode )
		WriteUINT16Record( 0x1026, nFontx );	// FONTX
}


void XclObjChart::WriteAI()
{
	if( !bWriteMode ) return;
	StartRecord( 0x1051, 8 );	// AI linked data
	*pStrm	<< UINT8(0)			// title or text
			<< UINT8(1)			// text or value entered directly into the formula bar (2do: really?)
			<< UINT16(0)		// flags, number format is linked to data source
			<< UINT16(0)		// index to number format record
			<< UINT16(0);		// size of formula
	EndRecord();
}


void XclObjChart::WriteSeriestext( const uno::Reference< beans::XPropertySet >& xProp )
{
	if( !bWriteMode ) return;

	OUString sString;
	if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STRING ) ) ) && (aAny >>= sString) )
		WriteSeriestext( XclExpUniString( sString, EXC_CHART_MAXSTRLEN, TRUE ) );
}


void XclObjChart::WriteSeriestext( const XclExpUniString& rString )
{
	if( !bWriteMode ) return;

	ULONG nLen = 3 + (rString.GetLen() ? rString.GetBufferByteCount() + 1 : 0);
	StartRecord( 0x100D, nLen );			// SERIESTEXT
	*pStrm	<< UINT16(0);					// text identifier: 0:= series name or text
	rString.Write( *pStrm, FALSE, FALSE );	// 8 bit length, no flags if length==0
	EndRecord();
}


void XclObjChart::WriteObjectlink( UINT16 nLinkObj, UINT16 nLinkVar1, UINT16 nLinkVar2 )
{
	if( !bWriteMode ) return;
	StartRecord( 0x1027, 6 );	// OBJECTLINK
	*pStrm	<< nLinkObj			// object text link ( EXC_CHART_OLINK_*** )
			<< nLinkVar1		// link index 1, series number
			<< nLinkVar2;		// link index 2, data point number
	EndRecord();
}


void XclObjChart::WriteTextList()
{
	for( const XclChartText* pText = aTextList.First(); pText; pText = aTextList.Next() )
		WriteGroupText( pText->nSeries, pText->nPoint, pText->nFontx, pText->nRGB, pText->nIndex, pText->nFlags );
}


//___________________________________________________________________
// SERIES group

void XclObjChart::AppendToSeriesNUpnList( const ScAddress* pA )
{
	if ( pA )
	{
		ScTokenArray aArr;
		SingleRefData aRef;
		aRef.InitAddress( *pA );
		aArr.AddSingleReference( aRef );
		EC_Codetype eDummy;
		aSeriesNUpnList.Insert( new ExcUPN( &rRootData, aArr, eDummy, NULL ), LIST_APPEND );
	}
	else
		aSeriesNUpnList.Insert( NULL, LIST_APPEND );	//!
}


void XclObjChart::BuildSeriesList()
{
	chart::ChartDataRowSource eSource;
	//! how about extracting an enum value from any?
	if( GetPropValue( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ROWSOURCE ) ) ) &&
			(aAny.getValueTypeClass() == uno::TypeClass_ENUM) )
		eSource = (chart::ChartDataRowSource) *(sal_Int32*)aAny.getValue();
	else
		eSource = chart::ChartDataRowSource_ROWS;
	const ScChartPositionMap* pPosMap = pChartArray->GetPositionMap();
	bColHeaders = pChartArray->HasColHeaders();
	bRowHeaders = pChartArray->HasRowHeaders();
	if ( eSource == chart::ChartDataRowSource_ROWS )
	{
		nChartDataColumns = pPosMap->GetColCount();
		USHORT nRows = pPosMap->GetRowCount();
		USHORT nRow = 0;
		switch ( eChartType )
		{
			case ctScatter :
				if ( nRow < nRows )
					aSeriesXRangeList.Append( pPosMap->GetRowRanges( nRow++ ) );
			break;
			default:
				if ( bColHeaders )
				{
					nChartCategoriesDataType = EXC_CHART_SER_TEXT;	// text
					ScRangeListRef xRL = new ScRangeList;
					USHORT nCols = pPosMap->GetColCount();
					for ( USHORT nCol = 0; nCol < nCols; nCol++ )
					{
						const ScAddress* pAdr = pPosMap->GetColHeaderPosition( nCol );
						if ( pAdr )
							xRL->Join( ScRange( *pAdr ) );
					}
					aSeriesXRangeList.Append( xRL );
				}
		}
		for ( ; nRow < nRows; nRow++ )
		{
			aSeriesYRangeList.Append( pPosMap->GetRowRanges( nRow ) );
			// N-list must have same count as Y-list if any
			if ( bRowHeaders )
				AppendToSeriesNUpnList( pPosMap->GetRowHeaderPosition( nRow ) );
		}
	}
	else
	{
		nChartDataColumns = pPosMap->GetRowCount();
		USHORT nCols = pPosMap->GetColCount();
		USHORT nCol = 0;
		switch ( eChartType )
		{
			case ctScatter :
				if ( nCol < nCols )
					aSeriesXRangeList.Append( pPosMap->GetColRanges( nCol++ ) );
			break;
			default:
				if ( bRowHeaders )
				{
					nChartCategoriesDataType = EXC_CHART_SER_TEXT;	// text
					ScRangeListRef xRL = new ScRangeList;
					USHORT nRows = pPosMap->GetRowCount();
					for ( USHORT nRow = 0; nRow < nRows; nRow++ )
					{
						const ScAddress* pAdr = pPosMap->GetRowHeaderPosition( nRow );
						if ( pAdr )
							xRL->Join( ScRange( *pAdr ) );
					}
					aSeriesXRangeList.Append( xRL );
				}
		}
		for ( ; nCol < nCols; nCol++ )
		{
			aSeriesYRangeList.Append( pPosMap->GetColRanges( nCol ) );
			// N-list must have same count as Y-list if any
			if ( bColHeaders )
				AppendToSeriesNUpnList( pPosMap->GetColHeaderPosition( nCol ) );
		}
	}
	// Y-values
	ScRangeListMemberList* pRLML = &aSeriesYRangeList;
	List* pUL = &aSeriesYUpnList;
	ULONG nCnt = pRLML->Count();
	do
	{
		ULONG j;
		ScRangeListRef xRL;
		for ( j=0, xRL = pRLML->First(); j<nCnt; j++, xRL = pRLML->Next() )
		{
			ScTokenArray aArr;
			if ( xRL->Count() == 1 )
			{
				ScRange* pR = xRL->First();
				if ( pR->aStart == pR->aEnd )
				{
					SingleRefData aRef;
					aRef.InitAddress( pR->aStart );
					aArr.AddSingleReference( aRef );
				}
				else
				{
					ComplRefData aRef;
					aRef.InitRange( *pR );
					aArr.AddDoubleReference( aRef );
				}
			}
			else
			{
				aArr.AddOpCode( ocOpen );
				BOOL bFirst = TRUE;
				for ( ScRange* pR = xRL->First(); pR; pR = xRL->Next() )
				{
					if ( bFirst )
						bFirst = FALSE;
					else
						aArr.AddOpCode( ocUnion );
					if ( pR->aStart == pR->aEnd )
					{
						SingleRefData aRef;
						aRef.InitAddress( pR->aStart );
						aArr.AddSingleReference( aRef );
					}
					else
					{
						ComplRefData aRef;
						aRef.InitRange( *pR );
						aArr.AddDoubleReference( aRef );
					}
				}
				aArr.AddOpCode( ocClose );
			}
			// Address*==NULL => all references will have Reference-Class
			EC_Codetype eDummy;
			pUL->Insert( new ExcUPN( &rRootData, aArr, eDummy, NULL ), LIST_APPEND );
		}
		if ( pRLML != &aSeriesXRangeList )
		{
			// X-categories
			pRLML = &aSeriesXRangeList;
			pUL = &aSeriesXUpnList;
			nCnt = pRLML->Count();
		}
		else
			nCnt = 0;
	} while ( nCnt );
}


void XclObjChart::WriteTheSeries()
{
	ULONG nCount = aSeriesYRangeList.Count();
	DBG_ASSERT( nCount, "XclObjChart::WriteTheSeries: no Y-RangeList" );
	if ( !nCount )
		return ;
	DBG_ASSERT( aSeriesXRangeList.Count() <= 1, "XclObjChart::WriteTheSeries: more than one X-RangeList" );
	ScRangeListRef xYRL, xXRL;
	xXRL = aSeriesXRangeList.First();
	UINT16 nXCellCount = xXRL.Is() ? UINT16(xXRL->GetCellCount()) : 0;
#ifndef PRODUCT
	switch ( eChartType )
	{
		case ctScatter :
			DBG_ASSERT( nXCellCount, "XclObjChart::WriteTheSeries: no X-Range" );
		break;
	}
#endif
	ExcUPN *pYUPN, *pXUPN, *pNUPN;
	UINT16 nIndex, nNumber;
	SvUShorts* pSerieslist = NULL;
	pXUPN = (ExcUPN*) aSeriesXUpnList.First();

	BOOL bReverse = ((eChartType == ctArea) && !bChart3D && !bChartStacked && !bChartPercent) || (eChartType == ctDonut);
	if ( bReverse )
	{	// reverse order to make it more look alike
		xYRL = aSeriesYRangeList.Last();
		pYUPN = (ExcUPN*) aSeriesYUpnList.Last();
		pNUPN = (ExcUPN*) aSeriesNUpnList.Last();
		nIndex = nNumber = (UINT16)(nCount - 1);
	}
	else
	{
		xYRL = aSeriesYRangeList.First();
		pYUPN = (ExcUPN*) aSeriesYUpnList.First();
		pNUPN = (ExcUPN*) aSeriesNUpnList.First();
		nIndex = nNumber = 0;
	}
	for ( ULONG nCnt = 0; nCnt < nCount; nCnt++ )
	{
		UINT16 nYValCount = UINT16(xYRL->GetCellCount());
		UINT16 nXCatCount;
		switch ( eChartType )
		{
			case ctScatter :
				nXCatCount = nXCellCount;
			break;
			default:
				nXCatCount = nYValCount;
		}

		UINT16 nOldGroup = nChartGroup;
		if ( eChartType == ctStock && bStockVolume )
		{
			switch ( nIndex )
			{
				case 0:		nNumber = bStockUpDown ? 4 : 3;	break;
				case 1:		nNumber = 0; nChartGroup++;		break;
				case 2:		nNumber = 1;					break;
				case 3:		nNumber = 2;					break;
				case 4:		nNumber = bStockUpDown ? 3 : 4;	break;
				default:	nNumber = nIndex;				break;
			}
		}
		if ( nChartGroup < nOldGroup )
			pSerieslist = (SvUShorts*) aSerieslistList.GetObject( nChartGroup );
		else if ( nChartGroup > nOldGroup )
		{
			pSerieslist = new SvUShorts( 4, 4 );
			aSerieslistList.Insert( pSerieslist, LIST_APPEND );
		}
		if ( pSerieslist )
			pSerieslist->Insert( nIndex, pSerieslist->Count() );

		WriteGroupSeries( (UINT16) nCnt, nIndex, nNumber, nXCatCount, nYValCount, *pYUPN, pXUPN, pNUPN );

		if ( bReverse )
		{
			xYRL = aSeriesYRangeList.Prev();
			pYUPN = (ExcUPN*) aSeriesYUpnList.Prev();
			pNUPN = (ExcUPN*) aSeriesNUpnList.Prev();
			nIndex--;
			nNumber--;
		}
		else
		{
			xYRL = aSeriesYRangeList.Next();
			pYUPN = (ExcUPN*) aSeriesYUpnList.Next();
			pNUPN = (ExcUPN*) aSeriesNUpnList.Next();
			nIndex++;
			nNumber++;
		}
	}
}


void XclObjChart::WriteGroupSeries( UINT16 nSeriesCnt, UINT16 nSeriesIndex, UINT16 nSeriesNumber,
									UINT16 nXCatCount, UINT16 nYValCount,
									const ExcUPN& rYUPN, const ExcUPN* pXUPN, const ExcUPN* pNUPN )
{
	WriteSeries( nXCatCount, nYValCount );
	WriteBeginLevel();

	if( bWriteMode )
	{
		UINT16	nFmt = 0;	// linked to data source
		UINT8	nRef = pNUPN ? EXC_CHART_AI_REFWORKSH : EXC_CHART_AI_REFDIRECTLY;
		WriteAI( pNUPN, EXC_CHART_AI_LINKTITLE, nRef, nFmt );

		WriteAI( &rYUPN, EXC_CHART_AI_LINKVALUE, EXC_CHART_AI_REFWORKSH, nFmt );

		nRef = pXUPN ? EXC_CHART_AI_REFWORKSH : EXC_CHART_AI_REFDEF;
		WriteAI( pXUPN, EXC_CHART_AI_LINKCAT, nRef, nFmt );

		// undocumented but written by Xcl
		WriteAI( NULL, EXC_CHART_AI_LINKUNKNOWN, EXC_CHART_AI_REFDIRECTLY, 0 );
	}

	// properties of entire series
	BOOL				bGetLineArea = bChartTypeBars || bChartTypeRound;
	XclChartDataFormat	aSerFormats( aDiaFormats );
	UINT16				nSerNum = (eChartType == ctScatter) ? nSeriesIndex + 1 : nSeriesIndex;
	if( !bChartTypeRound )
	{
		uno::Reference< beans::XPropertySet >	xSerProp = xDiagram->getDataRowProperties( nSerNum );
		GetFormats( aSerFormats, xSerProp, TRUE, TRUE );
		WriteGroupDataformat( nSeriesCnt, nSeriesNumber, EXC_CHART_DATAF_SERIES, aSerFormats );
	}

	for( USHORT nCol = 0; nCol < nChartDataColumns; nCol++ )
	{
		// properties of single data points
		XclChartDataFormat						aPointFormats( aSerFormats );
		uno::Reference< beans::XPropertySet >	xPointProp = (eChartType == ctDonut) ?
			xDiagram->getDataPointProperties( nSerNum, nCol ) :
			xDiagram->getDataPointProperties( nCol, nSerNum );
		GetFormats( aPointFormats, xPointProp, bGetLineArea, TRUE );
		if( aPointFormats.IsDifferent() )
			WriteGroupDataformat( nSeriesCnt, nSeriesNumber, nCol, aPointFormats );
	}
	WriteSertocrt();
	WriteEndLevel();
}


void XclObjChart::WriteSeries( UINT16 nXCatCount, UINT16 nYValCount )
{
	if( !bWriteMode ) return;

	UINT16 sdtY, sdtBSize, cValBSize;

//2do: data types
	sdtY = EXC_CHART_SER_NUM;	// assume numeric data type

//2do: data type and count of bubble size values ?!?
	sdtBSize = EXC_CHART_SER_NUM;
	cValBSize = 0;

	StartRecord( 0x1003, 12 );				// SERIES
	*pStrm	<< nChartCategoriesDataType		// type of data in categories
			<< sdtY							// type of data in values
			<< nXCatCount					// count of categories
			<< nYValCount					// count of values
			<< sdtBSize						// type of data in bubble size series
			<< cValBSize;					// count of bubble series values
	EndRecord();
}


//___________________________________________________________________
// DATAFORMAT group

void XclObjChart::WriteGroupDataformat( UINT16 nSeriesIndex, UINT16 nSeriesNumber,
										UINT16 nSeriesPoint, const XclChartDataFormat& rFormats )
{
	if( !(bWriteMode && ((nSeriesPoint == EXC_CHART_DATAF_SERIES) || rFormats.IsDifferent())) ) return;

	WriteDataformat( nSeriesIndex, nSeriesNumber, nSeriesPoint );
	WriteBeginLevel();
	Write3DDataformat( rFormats );
	WriteLineformat( rFormats );
	WriteAreaformat( rFormats );
	if( bChartTypeRound )
		WritePieformat( rFormats.nSegment );
	if( (eChartType == ctLine) || (eChartType == ctScatter) || (eChartType == ctNet) || (eChartType == ctStock) )
	{
		UINT16 nSymbol;
		if( eChartType == ctStock )
			nSymbol = (!bStockUpDown && ((!bStockVolume && (nSeriesIndex == 2)) || (bStockVolume && (nSeriesIndex == 3)))) ?
				EXC_CHART_MARKF_DOWJ : EXC_CHART_MARKF_NOSYMBOL;
		else
			nSymbol = rFormats.GetSymbol( nSeriesNumber );
		if( (eChartType == ctScatter) && !bChartLine )
			WriteMarkerformat( nSymbol, rFormats.nLineIndex, rFormats.nAreaIndex );
		else
			WriteMarkerformat( nSymbol, EXC_COLIND_AUTOLINE, rFormats.nLineIndex );
	}
	if( (nSeriesPoint == EXC_CHART_DATAF_SERIES) && bChartSpline )
		WriteSerfmt( EXC_CHART_SERF_SMOOTHED );
	if( (nSeriesPoint == EXC_CHART_DATAF_SERIES) || rFormats.nLabelFlags )
		WriteAttachedLabel( rFormats.nLabelFlags );
	WriteEndLevel();

	aTextList.Append( new XclChartText( nSeriesIndex, nSeriesPoint, rFormats ) );
}


void XclObjChart::WriteDataformat( UINT16 nSeriesIndex, UINT16 nSeriesNumber,
			UINT16 nSeriesPoint )
{
	if( !bWriteMode ) return;
	StartRecord( 0x1006, 8 );	// DATAFORMAT
	*pStrm	<< nSeriesPoint		// point number, 0xFFFF:= entire series
			<< nSeriesIndex		// series index
			<< nSeriesNumber	// series number
			<< UINT16(0);		// format flags
	EndRecord();
}


void XclObjChart::Write3DDataformat( const XclChartDataFormat& rFormats )
{
	if( !bWriteMode ) return;
	StartRecord( 0x105F, 2 );	// 3DDATAFORMAT
	*pStrm	<< rFormats.nDataFormatBase
			<< rFormats.nDataFormatTop;
	EndRecord();
}


void XclObjChart::WritePieformat( UINT16 nPercent )
{
	if( !bWriteMode ) return;
	nMaxSegOffset = Max( nMaxSegOffset, nPercent );
	WriteUINT16Record( 0x100B, nPercent );	// PIEFORMAT
}


void XclObjChart::WriteMarkerformat( UINT16 nType, UINT16 nBordInd, UINT16 nFillInd )
{
	if( !bWriteMode ) return;
	StartRecord( 0x1009, 20 );					// MARKERFORMAT
	WriteRGB( rPal.GetRGBValue( nBordInd ) );	// foreground color RGB
	WriteRGB( rPal.GetRGBValue( nFillInd ) );	// background color RGB
	*pStrm	<< nType							// type of marker
			<< UINT16(0)						// format flags
			<< nBordInd							// index to color of marker border
			<< nFillInd							// index to color of marker fill
			<< UINT32(120);						// size of line markers in twips
	EndRecord();
}


void XclObjChart::WriteSerfmt( UINT16 nFlags )
{
	if( bWriteMode )
		WriteUINT16Record( 0x105D, nFlags );	// SERFMT
}


void XclObjChart::WriteAttachedLabel( UINT16 nFlags )
{
	if( bWriteMode )
		WriteUINT16Record( 0x100C, nFlags );	// ATTACHEDLABEL
}


void XclObjChart::WriteSertocrt()
{
	if( bWriteMode )
		WriteUINT16Record( 0x1045, nChartGroup );	// SERTOCRT
}


void XclObjChart::WriteAI( const ExcUPN* pUPN, UINT8 nType, UINT8 nRef, UINT16 nFmt )
{
	if( !bWriteMode ) return;

	UINT16 nFormLen = pUPN ? pUPN->GetLen() : 0;
	StartRecord( 0x1051, 8 + nFormLen );	// AI linked data
	*pStrm	<< nType						// link type: title, values, categories
			<< nRef							// reference type
			<< UINT16(0)					// flags: number format is linked to data source
			<< nFmt							// index to number format record
			<< nFormLen;					// size of formula
	if ( pUPN )
		pStrm->Write( pUPN->GetData(), nFormLen );
	EndRecord();
}


//___________________________________________________________________
// AXIS group

void XclObjChart::SetCurrentAxesSet( UINT16 nAxesSet )
{
	nCurrentAxis &= 0x0000FFFF;
	nCurrentAxis |= (UINT32(nAxesSet) << 16);
}


void XclObjChart::SetCurrentAxis( UINT16 nAxis )
{
	nCurrentAxis &= 0xFFFF0000;
	nCurrentAxis |= nAxis;
}


void XclObjChart::WriteAllAxes()
{
	BOOL bHasSecAxes = (eChartType == ctStock) && bStockVolume;

	if( !bHasSecAxes )
	{
		uno::Reference< chart::XTwoAxisXSupplier > xDiaXSup( xDiagram, uno::UNO_QUERY );
		uno::Reference< beans::XPropertySet > xXProp( xDiaXSup, uno::UNO_QUERY );
		bHasSecAxes = GetPropBool( xXProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECXAXIS ) ) );

		uno::Reference< chart::XTwoAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
		uno::Reference< beans::XPropertySet > xYProp( xDiaYSup, uno::UNO_QUERY );
		bHasSecAxes |= GetPropBool( xYProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXIS ) ) );
	}

	WriteAxesused( bHasSecAxes ? 2 : 1 );
	WriteTheAxes( EXC_CHART_FIRSTAXES );
	if( bHasSecAxes )
		WriteTheAxes( EXC_CHART_SECONDAXES );
}


void XclObjChart::WriteAxesused( UINT16 nNumber )
{
	if( bWriteMode )
		WriteUINT16Record( 0x1046, nNumber );	// AXESUSED
}


void XclObjChart::WriteTheAxes( UINT16 nAxesSet )
{
	SetCurrentAxesSet( nAxesSet );

	WriteAxisparent();
	WriteBeginLevel();
	WritePos( aDiaPosSize, ttCommon );

	if( !bChartTypeRound )
	{
		WriteGroupAxis( EXC_CHART_XAXIS );
		WriteGroupAxis( EXC_CHART_YAXIS );

		if( nAxesSet == EXC_CHART_FIRSTAXES )
		{
			if( bChart3D )
				WriteGroupAxis( EXC_CHART_ZAXIS );
			else if( eChartType != ctNet )
			{
				WritePlotarea();
				WriteGroupFrame( xDiagr3D->getWall() );
			}
		}
	}

	WriteGroupChartformat( nAxesSet );
	WriteEndLevel();
}


void XclObjChart::WriteAxisparent()
{
	if( !bWriteMode ) return;

	// shrink diagram area for exploded pie charts
	if( nMaxSegOffset )
	{
		double fScale = 100.0 / (double(nMaxSegOffset) + 100.0);
		INT32 nNew = INT32(double(aDiaPosSize.nWidth) * fScale);
		aDiaPosSize.nPosX += ((aDiaPosSize.nWidth - nNew) >> 1);
		aDiaPosSize.nWidth = nNew;
		nNew = INT32(double(aDiaPosSize.nHeight) * fScale);
		aDiaPosSize.nPosY += ((aDiaPosSize.nHeight - nNew) >> 1);
		aDiaPosSize.nHeight = nNew;
	}

	StartRecord( 0x1041, 18 );			// AXISPARENT
	*pStrm	<< GetCurrentAxesSet();		// index of axes set
	WritePosData( aDiaPosSize, ttCommon );
	EndRecord();
}


void XclObjChart::WritePlotarea()
{
	if( bWriteMode )
		WriteEmptyRecord( 0x1035 );	// PLOTAREA
}


void XclObjChart::WriteGroupAxis( UINT16 nAxis )
{
	SetCurrentAxis( nAxis );

	uno::Reference< drawing::XShape >	xTitleShape;
	TextType							eTextType = ttNone;

	WriteAxis();
	WriteBeginLevel();

	switch( nCurrentAxis )
	{
		case EXC_CHART_FIRSTXAXIS:
		{
			WriteXZRange();
			if( eChartType == ctNet )
				WriteFirstYAxis( xTitleShape, eTextType, FALSE );
			else
				WriteFirstXAxis( xTitleShape, eTextType );
		}
		break;
		case EXC_CHART_SECONDXAXIS:
			WriteXZRange();
			WriteSecondXAxis();
		break;
		case EXC_CHART_FIRSTYAXIS:
			WriteFirstYAxis( xTitleShape, eTextType, TRUE );
		break;
		case EXC_CHART_SECONDYAXIS:
			WriteSecondYAxis();
		break;
		case EXC_CHART_FIRSTZAXIS:
			WriteXZRange();
			WriteFirstZAxis( xTitleShape, eTextType );
		break;
	}

	WriteEndLevel();

	if( (eChartType != ctNet) && (eTextType != ttNone) )
		WriteGroupText( xTitleShape, eTextType );
}


void XclObjChart::WriteFirstXAxis( uno::Reference< drawing::XShape >& xTitle, TextType& rType )
{
	uno::Reference< chart::XAxisXSupplier > xDiaXSup( xDiagram, uno::UNO_QUERY );
	DBG_ASSERT( xDiaXSup.is(), "XclObjChart::WriteFirstXAxis: no XAxisXSupplierRef" );
	rType = ttNone;

	if ( xDiaXSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXIS ) ) ) )
	{
		uno::Reference< beans::XPropertySet > xXAxis = xDiaXSup->getXAxis();

		if( eChartType == ctScatter )
		{
			WriteValuerange( xXAxis );
			WriteIfmt( xXAxis );
		}
		WriteTick( xXAxis, bXAxisDescr );
		WriteFontx( xXAxis );
		WriteTheAxisline( xXAxis, EXC_CHART_AXLINEF_AXISLINE, bXAxisDescr );
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISGRID ) ) ) )
			WriteTheAxisline( xDiaXSup->getXMainGrid(), EXC_CHART_AXLINEF_MAJORGRID );
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISHELPGRID ) ) ) )
			WriteTheAxisline( xDiaXSup->getXHelpGrid(), EXC_CHART_AXLINEF_MINORGRID );
		if( bChart3D )
			WriteTheAxisframe( xDiagr3D->getWall(), EXC_CHART_AXLINEF_WALLS );
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISTIT ) ) ) )
		{
			xTitle = xDiaXSup->getXAxisTitle();
			rType = ttXAxisTitle;
		}
	}
}


void XclObjChart::WriteSecondXAxis()
{
	uno::Reference< chart::XTwoAxisXSupplier > xDiaXSup( xDiagram, uno::UNO_QUERY );
	DBG_ASSERT( xDiaXSup.is(), "XclObjChart::WriteGroupAxis: no XTwoAxisXSupplierRef" );

	if ( xDiaXSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECXAXIS ) ) ) )
	{
		uno::Reference< beans::XPropertySet > xXAxis = xDiaXSup->getSecondaryXAxis();

		if( eChartType == ctScatter )
		{
			WriteValuerange( xXAxis );
			WriteIfmt( xXAxis );
		}
		BOOL bSecXAxisDescr = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECXAXISDESCR ) ) );
		WriteTick( xXAxis, bSecXAxisDescr );
		WriteFontx( xXAxis );
		WriteTheAxisline( xXAxis, EXC_CHART_AXLINEF_AXISLINE, bSecXAxisDescr );
	}
}


void XclObjChart::WriteFirstYAxis( uno::Reference< drawing::XShape >& xTitle, TextType& rType, BOOL bWriteExtras )
{
	uno::Reference< chart::XAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
	DBG_ASSERT( xDiaYSup.is(), "XclObjChart::WriteGroupAxis: no XAxisYSupplierRef" );
	rType = ttNone;

	if ( xDiaYSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXIS ) ) ) )
	{
		uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getYAxis();

		if( bWriteExtras )
		{
			WriteValuerange( xYAxis );
			WriteIfmt( xYAxis );
		}

		WriteTick( xYAxis, bYAxisDescr );
		WriteFontx( xYAxis );

		if( bWriteExtras )
		{
			WriteTheAxisline( xYAxis, EXC_CHART_AXLINEF_AXISLINE, bYAxisDescr );
			if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISGRID ) ) ) )
				WriteTheAxisline( xDiaYSup->getYMainGrid(), EXC_CHART_AXLINEF_MAJORGRID );
			if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISHELPGRID ) ) ) )
				WriteTheAxisline( xDiaYSup->getYHelpGrid(), EXC_CHART_AXLINEF_MINORGRID );
			if( bChart3D )
				WriteTheAxisframe( xDiagr3D->getFloor(), EXC_CHART_AXLINEF_WALLS );
			if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISTIT ) ) ) )
			{
				xTitle = xDiaYSup->getYAxisTitle();
				rType = ttYAxisTitle;
			}
		}
	}
}


void XclObjChart::WriteSecondYAxis()
{
	uno::Reference< chart::XTwoAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
	DBG_ASSERT( xDiaYSup.is(), "XclObjChart::WriteGroupAxis: no XTwoAxisYSupplierRef" );

	if ( xDiaYSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXIS ) ) ) )
	{
		uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getSecondaryYAxis();

		WriteValuerange( xYAxis );
		WriteIfmt( xYAxis );
		BOOL bSecYAxisDescr = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXISDESCR ) ) );
		WriteTick( xYAxis, bSecYAxisDescr );
		WriteFontx( xYAxis );
		WriteTheAxisline( xYAxis, EXC_CHART_AXLINEF_AXISLINE, bSecYAxisDescr );
	}
}


void XclObjChart::WriteFirstZAxis( uno::Reference< drawing::XShape >& xTitle, TextType& rType )
{
	uno::Reference< chart::XAxisZSupplier > xDiaZSup( xDiagram, uno::UNO_QUERY );
	DBG_ASSERT( xDiaZSup.is(), "XclObjChart::WriteFirstZAxis: no XAxisZSupplierRef" );
	rType = ttNone;

	if ( xDiaZSup.is() && GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXIS ) ) ) )
	{
		uno::Reference< beans::XPropertySet > xZAxis = xDiaZSup->getZAxis();

		BOOL bZAxisDescr = GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISDESCR ) ) );
		WriteTick( xZAxis, bZAxisDescr );
		WriteFontx( xZAxis );
		WriteTheAxisline( xZAxis, EXC_CHART_AXLINEF_AXISLINE, bZAxisDescr );
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISGRID ) ) ) )
			WriteTheAxisline( xDiaZSup->getZMainGrid(), EXC_CHART_AXLINEF_MAJORGRID );
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISHELPGRID ) ) ) )
			WriteTheAxisline( xDiaZSup->getZHelpGrid(), EXC_CHART_AXLINEF_MINORGRID );
		if( GetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISTIT ) ) ) )
		{
			xTitle = xDiaZSup->getZAxisTitle();
			rType = ttZAxisTitle;
		}
	}
}


void XclObjChart::WriteAxis()
{
	if( !bWriteMode ) return;
	StartRecord( 0x101D, 18 );			// AXIS
	*pStrm	<< GetCurrentAxis();		// X, Y, Z axis
	pStrm->WriteZeroBytes( 16 );		// reserved
	EndRecord();
}


void XclObjChart::WriteXZRange()
{
	if( eChartType != ctScatter )
	{
		WriteCatserrange();
		if( !bChart3D )
			WriteAxcext();
	}
}


void XclObjChart::WriteCatserrange()
{
	if( !bWriteMode ) return;

	UINT16 nGrbit = 0x0000;
	if( bChartTypeBars || (eChartType == ctStock) )
		nGrbit |= EXC_CHART_CATR_BETWEEN;
	if( GetCurrentAxesSet() == EXC_CHART_SECONDAXES )
		nGrbit |= EXC_CHART_CATR_MAXCROSS;

	StartRecord( 0x1020, 8 );	// CATSERRANGE
	*pStrm	<< UINT16(1)		// value axis / category crossing point (2D charts only)
			<< UINT16(1)		// frequency of labels
			<< UINT16(1)		// frequency of tick marks
			<< nGrbit;			// format flags
	EndRecord();
}


void XclObjChart::WriteAxcext()
{
	if( !bWriteMode ) return;
	StartRecord( 0x1062, 18 );					// AXCEXT
	*pStrm	<< UINT16(0)						// minimum category on axis
			<< UINT16(0)						// maximum category on axis
			<< UINT16(1)						// value of major unit
			<< UINT16(0)						// units of major unit
			<< UINT16(1)						// value of minor unit
			<< UINT16(0)						// units of minor unit
			<< UINT16(0)						// base unit of axis
			<< UINT16(0)						// crossing point of value axis (date)
			<< UINT16(EXC_CHART_AXCEXT_FLAGS);	// option flags
	EndRecord();
}


BOOL XclObjChart::WriteTick( const uno::Reference< beans::XPropertySet >& xProp, BOOL bHasDescr )
{
	sal_Int32	nVal32;
	UINT8		nMarkPos		= EXC_CHART_TICK_NOMARK;
	UINT8		nHelpMarkPos	= EXC_CHART_TICK_NOMARK;
	UINT8		nLabel			= EXC_CHART_TICK_NOLABEL;
	Color		aColor( COL_BLACK );
	UINT16		nIndex;
	UINT16		nFlags			= 0x0000;
	UINT16		nAngle;
	UINT16		nDummy;

	GetTextColor( aColor, nIndex, xProp );		// insert into palette or get index
	if( !bWriteMode ) return FALSE;

	if( GetPropInt32( nVal32, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MARKS ) ) ) )
		nMarkPos = lcl_GetMarkPos( nVal32 );
	if( GetPropInt32( nVal32, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HELPMARKS ) ) ) )
		nHelpMarkPos = lcl_GetMarkPos( nVal32 );
	if( bHasDescr )
	{
		if( eChartType == ctNet )
			nLabel = EXC_CHART_TICK_NEXT;
		else if( GetCurrentAxesSet() == EXC_CHART_FIRSTAXES )
			nLabel = EXC_CHART_TICK_LOW;
		else
			nLabel = EXC_CHART_TICK_HIGH;
	}
	GetRotation( nDummy, nAngle, xProp );
	nFlags |= EXC_CHART_TICK_GETROTFLAGS( GetRotationFlags( nAngle ) );

	StartRecord( 0x101E, 30 );					// TICK
	*pStrm	<< nMarkPos							// major tick mark
			<< nHelpMarkPos						// minor tick mark
			<< nLabel							// tick label position
			<< UINT8(EXC_CHART_TEXT_BGTRANS);	// background mode: transparent
	WriteRGB( aColor.GetColor() );				// tick label text color
	*pStrm	<< UINT32(0) << UINT32(0)			// reserved
			<< UINT32(0) << UINT32(0)			// reserved
			<< nFlags							// display flags
			<< nIndex							// index to text color
			<< nAngle;							// text rotation
	EndRecord();

	return (nMarkPos != EXC_CHART_TICK_NOMARK) || (nHelpMarkPos != EXC_CHART_TICK_NOMARK);
}


void XclObjChart::WriteValuerange( const uno::Reference< beans::XPropertySet >& xProp )
{
	if( !bWriteMode ) return;

	UINT16	nGrbit = 0x0000;
	double	fMin, fMax, fMain, fHelp, fOrigin;

	if( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOMIN ) ) ) ||
			!GetPropDouble( fMin, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MIN ) ) ) )
		nGrbit |= EXC_CHART_VALR_AUTOMIN;
	if( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOMAX ) ) ) ||
			!GetPropDouble( fMax, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MAX ) ) ) )
		nGrbit |= EXC_CHART_VALR_AUTOMAX;
	if( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOSTMAIN ) ) ) ||
			!GetPropDouble( fMain, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STEPMAIN ) ) ) )
		nGrbit |= EXC_CHART_VALR_AUTOMAJOR;
	if( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOSTHELP ) ) ) ||
			!GetPropDouble( fHelp, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STEPHELP ) ) ) )
		nGrbit |= EXC_CHART_VALR_AUTOMINOR;
	if( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOORIG ) ) ) ||
			!GetPropDouble( fOrigin, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ORIGIN ) ) ) )
		nGrbit |= EXC_CHART_VALR_AUTOCROSS;
	if( GetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LOG ) ) ) )
		nGrbit |= EXC_CHART_VALR_LOGSCALE;
	if ( eChartType == ctStock )
		nGrbit |= EXC_CHART_VALR_STOCKFLAG;		// reserved, but Xcl writes it

	StartRecord( 0x101F, 42 );	// VALUERANGE
	*pStrm	<< fMin				// minimum value on axis
			<< fMax				// maximum value on axis
			<< fMain			// value of major increment
			<< fHelp			// value of minor increment
			<< fOrigin			// value where the category axis crosses
			<< nGrbit;			// format flags
	EndRecord();
}


void XclObjChart::WriteIfmt( const uno::Reference< beans::XPropertySet >& xProp )
{
	sal_Int32 nIndex;
	if( GetPropInt32( nIndex, xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ) ) )
	{
		DBG_ASSERT( rRootData.pFormRecs, "XclObjChart::WriteIfmt - missing format buffer" );
        UINT16 nExcIndex = rRootData.pFormRecs->Add( nIndex );

		if( bWriteMode )
			WriteUINT16Record( 0x104E, nExcIndex );	// IFMT
	}
}


void XclObjChart::WriteTheAxisline( const uno::Reference< beans::XPropertySet >& xProp, UINT16 nId, BOOL bTicks )
{
	if( !xProp.is() ) return;
	WriteAxislineformat( nId );
	WriteLineformat( xProp, bTicks ? EXC_CHART_LINEF_TICK : 0x0000 );
}


void XclObjChart::WriteTheAxisframe( const uno::Reference< beans::XPropertySet >& xProp, UINT16 nId )
{
	if( !xProp.is() ) return;
	WriteAxislineformat( nId );
	WriteLineformat( xProp );
	WriteAreaformat( xProp );
}


void XclObjChart::WriteAxislineformat( UINT16 nId )
{
	if( bWriteMode )
		WriteUINT16Record( 0x1021, nId );	// AXISLINEFORMAT
}


//___________________________________________________________________
// chart type formats

void XclObjChart::WriteGroupChartformat( UINT16 nAxesSet )
{
	WriteChartformat( nAxesSet );
	WriteBeginLevel();

    if( bWriteMode )
    {
        switch( eChartType )
        {
            case ctLine:        WriteLine();        break;
            case ctArea:        WriteArea();        break;
            case ctBar:
            case ctColumn:      WriteBar();         break;
            case ctPie:
            case ctDonut:       WritePie();         break;
            case ctScatter:     WriteScatter();     break;
            case ctNet:         WriteRadar();       break;
            case ctStock:
                if ( bStockVolume )
                    WriteBar();
                else
                    WriteLine();
            break;
            default:            WriteBar();
        }

        if( bChart3D )
            Write3D();
    }

	if( nAxesSet == EXC_CHART_FIRSTAXES )
	{
		WriteGroupLegend();

		if( (eChartType == ctStock) && !bStockVolume )
		{
			WriteTheDropbars();
			WriteTheChartline( EXC_CHART_CHLINE_HILO );
			WriteGroupDataformat( 0, EXC_CHART_DATAF_CHART, 0, aDiaFormats );
		}
	}
	else if( eChartType == ctStock )
	{
		WriteLine();
		WriteSerieslist( nAxesSet );
		WriteTheDropbars();
		WriteTheChartline( EXC_CHART_CHLINE_HILO );
		WriteGroupDataformat( 0, EXC_CHART_DATAF_CHART, 0, aDiaFormats );
	}

	WriteEndLevel();
}


void XclObjChart::WriteChartformat( UINT16 nZOrder )
{
	if( !bWriteMode ) return;

	UINT16 nGrbit = bChartTypeRound ? EXC_CHART_CHARTF_VARIED : 0x0000;
	StartRecord( 0x1014, 20 );	// CHARTFORMAT
	*pStrm 	<< UINT32(0)		// reserved
			<< UINT32(0)		// reserved
			<< UINT32(0)		// reserved
			<< UINT32(0)		// reserved
			<< nGrbit			// format flags
			<< nZOrder;			// drawing order, 0:= bottom of the z-order
	EndRecord();
}


void XclObjChart::Write3D()
{
	UINT16	nRot	= bChartTypeRound ? 0 : 30;
	UINT16	nElev	= 20;
	UINT16	nDist	= 30;
	UINT16	nHeight	= 100;
	UINT16	nDepth	= 100;
	UINT16	nGap	= 150;
	UINT16	nGrbit	= EXC_CHART_3D_FLAGS;
	if( bChartTypeBars && !bChartStacked && !bChartPercent && !bChartDeep )
		nGrbit |= EXC_CHART_3D_CLUSTER;

	StartRecord( 0x103A, 14 );	// 3D
	*pStrm	<< nRot				// rotation angle (0 to 360 degrees)
			<< nElev			// elevation angle (-90 to +90 degrees)
			<< nDist			// distance from eye to chart (0 to 100)
			<< nHeight			// height of plot volume relative to width and depth
			<< nDepth			// depth of points relative to width
			<< nGap				// space between series
			<< nGrbit;			// option flags
	EndRecord();
}


void XclObjChart::WriteTheChartline( UINT16 nId )
{
	if( nId == EXC_CHART_CHLINE_HILO )
	{
		uno::Reference< chart::XStatisticDisplay > xStat( xDiagram, uno::UNO_QUERY );
		if( !xStat.is() ) return;
		uno::Reference< beans::XPropertySet > xProp( xStat->getMinMaxLine() );
		if( !xProp.is() ) return;

		WriteChartline( nId );
		WriteLineformat( xProp );
	}
}


void XclObjChart::WriteChartline( UINT16 nId )
{
	if( bWriteMode )
		WriteUINT16Record( 0x101C, nId );	// CHARTLINE
}


void XclObjChart::WriteTheDropbars()
{
	if( bStockUpDown )
	{
		WriteGroupDropbar( EXC_CHART_DROP_UP );
		WriteGroupDropbar( EXC_CHART_DROP_DOWN );
	}
}


void XclObjChart::WriteGroupDropbar( UINT16 nBar )
{
	uno::Reference< chart::XStatisticDisplay > xStat( xDiagram, uno::UNO_QUERY );
	if( !xStat.is() ) return;

	uno::Reference< beans::XPropertySet > xProp;
	switch( nBar )
	{
		case EXC_CHART_DROP_UP:		xProp = xStat->getUpBar();		break;
		case EXC_CHART_DROP_DOWN:	xProp = xStat->getDownBar();	break;
	}
	if( !xProp.is() ) return;

	WriteDropbar();
	WriteBeginLevel();
	WriteLineformat( xProp );
	WriteAreaformat( xProp );
	WriteEndLevel();
}


void XclObjChart::WriteDropbar()
{
	if( bWriteMode )
		WriteUINT16Record( 0x103D, 100 );	// DROPBAR
}


void XclObjChart::WriteSerieslist( UINT16 nAxesSet )
{
	if( !bWriteMode ) return;

	SvUShorts* pList = (SvUShorts*) aSerieslistList.GetObject( nAxesSet );
	if( pList )
	{
		UINT16 nCnt = pList->Count();
		StartRecord( 0x1016, 2 + nCnt * 2 );	// SERIESLIST
		*pStrm	<< nCnt;
		for ( UINT16 j = 0; j < nCnt; j++ )
			*pStrm << UINT16( (*pList)[j] );
		EndRecord();
	}
}


//___________________________________________________________________
// chart types

void XclObjChart::WriteLineArea( UINT16 nRecId )
{
	if( !bWriteMode ) return;

	UINT16 nGrbit = 0x0000;
	if( bChartStacked )
		nGrbit |= EXC_CHART_LINE_STACKED;
	if( bChartPercent )
		nGrbit |= EXC_CHART_LINE_PERCENT;

	WriteUINT16Record( nRecId, nGrbit );	// LINE or AREA
}


void XclObjChart::WriteBar()
{
	if( !bWriteMode ) return;

	UINT16 nGrbit = (eChartType == ctBar) ? EXC_CHART_BAR_TRANS : 0x0000;
	if( bChartStacked )
		nGrbit |= EXC_CHART_BAR_STACKED;
	if( bChartPercent )
		nGrbit |= EXC_CHART_BAR_PERCENT;

	BOOL	bIsOnTop	= (bChartStacked || bChartPercent);
	INT16	nOverlap	= bIsOnTop ? -100 : 0;
	INT16	nGap		= 50;

	uno::Reference< chart::XAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
	if ( xDiaYSup.is() )
	{
		uno::Reference< beans::XPropertySet >	xYAxis( xDiaYSup->getYAxis() );
		sal_Int32								nVal;

		if ( !bIsOnTop && GetPropInt32( nVal, xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_OVERLAP ) ) ) )
			nOverlap = -INT16(nVal);		//! negative
		if ( GetPropInt32( nVal, xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_GAPWIDTH ) ) ) )
			nGap = INT16(nVal);
	}

	StartRecord( 0x1017, 6 );	// BAR
	*pStrm	<< nOverlap			// space between bars (percent of bar width), default=0
			<< nGap				// space between categories (percent of bar width), default=50
			<< nGrbit;			// format flags
	EndRecord();
}


void XclObjChart::WritePie()
{
	if( !bWriteMode ) return;
	// we have a donut hole radius of the size of one data ring
	UINT16 nHole = (eChartType == ctDonut) ? (UINT16)(100 / (aSeriesYUpnList.Count() + 1)) : 0;
	StartRecord( 0x1019, 6 );	// PIE
	*pStrm	<< UINT16(0)		// angle of the first pie slice expressed in degrees
			<< nHole			// 0:= true pie chart; !0:= size of center hole in a donut chart (as a percentage)
			<< UINT16(0);		// option flags
	EndRecord();
}


void XclObjChart::WriteScatter()
{
	if( !bWriteMode ) return;
	StartRecord( 0x101B, 6 );	// SCATTER
	*pStrm	<< UINT16(100)		// percent of largest bubble compared to chart in general
			<< UINT16(1)		// 1:= bubble size is area; 2:= bubble size is width
			<< UINT16(0);		// option flags
	EndRecord();
}


void XclObjChart::WriteRadar()
{
	if( !bWriteMode ) return;
	UINT16 nGrbit = bYAxisDescr ? EXC_CHART_RADAR_AXLAB : 0x0000;
	WriteUINT16Record( 0x103E, nGrbit );	// RADAR
}


//___________________________________________________________________
// main titel, legend

void XclObjChart::WriteTheMainTitle()
{
	if ( GetPropBool( xDocProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASMAINTIT ) ) ) )
		WriteGroupText( xChartDoc->getTitle(), ttTitle );
}


void XclObjChart::WriteGroupLegend()
{
	if( GetPropBool( xDocProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASLEGEND ) ) ) )
	{
		uno::Reference< drawing::XShape > xLegendShape = xChartDoc->getLegend();

		WriteLegend( xLegendShape );
		WriteBeginLevel();
		WritePos( xLegendShape, ttLegend );		// needed for user defined position
		WriteGroupText( xLegendShape, ttLegend );
		WriteGroupFrame( xLegendShape );
		WriteEndLevel();
	}
}


void XclObjChart::WriteLegend( const uno::Reference< drawing::XShape >& xShape )
{
	if( !bWriteMode ) return;

	uno::Reference< beans::XPropertySet >	xProp( xShape, uno::UNO_QUERY );
	UINT8									nPos	= EXC_CHART_LEGEND_NOTDOCKED;
	UINT16									nFlags	= 0x0000;

//--------------------------
//Chart doesn't return "chart::ChartLegendPosition_NONE"
//-> results in wrong position in Excel, if moved manually in Calc
//	if( xProp.is() )
//		if( GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ALIGNMENT ) ) ) && (aAny >>= ePos) )
//			nPos = lcl_GetLegendPosition( ePos );
//--------------------------

    chart::ChartLegendPosition ePos;
    if( !xProp.is() || !GetPropValue( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ALIGNMENT ) ) ) || !(aAny >>= ePos) )
        ePos = chart::ChartLegendPosition_NONE;

    nFlags |= EXC_CHART_LEGEND_AUTOSERIES;
    if( (ePos == chart::ChartLegendPosition_LEFT) || (ePos == chart::ChartLegendPosition_RIGHT) || (ePos == chart::ChartLegendPosition_NONE) )
        nFlags |= EXC_CHART_LEGEND_AUTOSERIES | EXC_CHART_LEGEND_VERT;
	if( nPos != EXC_CHART_LEGEND_NOTDOCKED )
		nFlags |= EXC_CHART_LEGEND_AUTOPOS;

	StartRecord( 0x1015, 20 );						// LEGEND
	WritePosData( xShape, ttCommon );
	*pStrm	<< nPos									// default position
			<< UINT8(EXC_CHART_LEGEND_SPACINGMED)	// spacing, always medium
			<< nFlags;								// flags
	EndRecord();
}


//___________________________________________________________________
// SIINDEX

void XclObjChart::WriteTheSiindex()
{
	if( !bWriteMode ) return;
#if 0
//2do: what the .... are they for?
	WriteSiindex( 2 );
	WriteSiindex( 1 );
	WriteSiindex( 3 );
#endif
}


void XclObjChart::WriteSiindex( UINT16 nIndex )
{
	if( bWriteMode )
		WriteUINT16Record( 0x1065, nIndex );	// SIINDEX
}

