/*************************************************************************
 *
 *  $RCSfile: namecont.cxx,v $
 *
 *  $Revision: 1.13 $
 *
 *  last change: $Author: ab $ $Date: 2001/07/09 16:03:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XCONTAINER_HPP_
#include <com/sun/star/container/XContainer.hpp>
#endif

#ifndef __RSC //autogen
#include <tools/errinf.hxx>
#endif
#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif

#include <cppuhelper/typeprovider.hxx>
#include "namecont.hxx"

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _UTL_STREAM_WRAPPER_HXX_
#include <unotools/streamwrap.hxx>
#endif
#include <svtools/pathoptions.hxx>
#include <svtools/sfxecode.hxx>
#include <svtools/ehdl.hxx>
#include <xmlscript/xmllib_imexp.hxx>


#ifndef _COM_SUN_STAR_XML_SAX_XEXTENDEDDOCUMENTHANDLER_HPP_
#include <com/sun/star/xml/sax/XExtendedDocumentHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XPARSER_HPP_
#include <com/sun/star/xml/sax/XParser.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_INPUTSOURCE_HPP_
#include <com/sun/star/xml/sax/InputSource.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XINPUTSTREAM_HPP_
#include <com/sun/star/io/XInputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XSIMPLEFILEACCESS_HPP_
#include <com/sun/star/ucb/XSimpleFileAccess.hpp>
#endif


using namespace com::sun::star::container;
using namespace com::sun::star::uno;
using namespace com::sun::star::lang;
using namespace com::sun::star::io;
using namespace com::sun::star::ucb;
using namespace com::sun::star::script;
using namespace com::sun::star::xml::sax;
using namespace cppu;
using namespace rtl;
using namespace osl;


//============================================================================
// Implementation class NameContainer_Impl

namespace SfxContainer_Impl
{

// Methods XElementAccess
Type NameContainer_Impl::getElementType()
	throw(RuntimeException)
{
	return mType;
}

sal_Bool NameContainer_Impl::hasElements()
	throw(RuntimeException)
{
	sal_Bool bRet = (mnElementCount > 0);
	return bRet;
}

// Methods XNameAccess
Any NameContainer_Impl::getByName( const OUString& aName )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	NameContainerNameMap::iterator aIt = mHashMap.find( aName );
	if( aIt == mHashMap.end() )
	{
		throw NoSuchElementException();
	}
	sal_Int32 iHashResult = (*aIt).second;
	Any aRetAny = mValues.getConstArray()[ iHashResult ];
	return aRetAny;
}

Sequence< OUString > NameContainer_Impl::getElementNames()
	throw(RuntimeException)
{
	return mNames;
}

sal_Bool NameContainer_Impl::hasByName( const OUString& aName )
	throw(RuntimeException)
{
	NameContainerNameMap::iterator aIt = mHashMap.find( aName );
	sal_Bool bRet = ( aIt != mHashMap.end() );
	return bRet;
}


// Methods XNameReplace
void NameContainer_Impl::replaceByName( const OUString& aName, const Any& aElement )
	throw(IllegalArgumentException, NoSuchElementException, WrappedTargetException, RuntimeException)
{
	Type aAnyType = aElement.getValueType();
	if( mType != aAnyType )
		throw IllegalArgumentException();

	NameContainerNameMap::iterator aIt = mHashMap.find( aName );
	if( aIt == mHashMap.end() )
	{
		throw NoSuchElementException();
	}
	sal_Int32 iHashResult = (*aIt).second;
	Any aOldElement = mValues.getConstArray()[ iHashResult ];
	mValues.getArray()[ iHashResult ] = aElement;


	// Fire event
	ContainerEvent aEvent;		
	aEvent.Source = mpxEventSource;
	aEvent.Accessor <<= aName;
	aEvent.Element = aElement;
	aEvent.ReplacedElement = aOldElement;

	OInterfaceIteratorHelper aIterator( maListenerContainer );
	while( aIterator.hasMoreElements() )
	{
		Reference< XInterface > xIface = aIterator.next();
		Reference< XContainerListener > xListener( xIface, UNO_QUERY );
		xListener->elementReplaced( aEvent );
	}
}


// Methods XNameContainer
void NameContainer_Impl::insertByName( const OUString& aName, const Any& aElement )
	throw(IllegalArgumentException, ElementExistException, WrappedTargetException, RuntimeException)
{
	Type aAnyType = aElement.getValueType();
	if( mType != aAnyType )
		throw IllegalArgumentException();

	NameContainerNameMap::iterator aIt = mHashMap.find( aName );
	if( aIt != mHashMap.end() )
	{
		throw ElementExistException();
	}

	sal_Int32 nCount = mNames.getLength();
	mNames.realloc( nCount + 1 );
	mValues.realloc( nCount + 1 );
	mNames.getArray()[ nCount ] = aName;
	mValues.getArray()[ nCount ] = aElement;

	mHashMap[ aName ] = nCount;
	mnElementCount++;


	// Fire event
	ContainerEvent aEvent;		
	aEvent.Source = mpxEventSource;
	aEvent.Accessor <<= aName;
	aEvent.Element = aElement;

	OInterfaceIteratorHelper aIterator( maListenerContainer );
	while( aIterator.hasMoreElements() )
	{
		Reference< XInterface > xIface = aIterator.next();
		Reference< XContainerListener > xListener( xIface, UNO_QUERY );
		xListener->elementInserted( aEvent );
	}

}

void NameContainer_Impl::removeByName( const OUString& Name )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	NameContainerNameMap::iterator aIt = mHashMap.find( Name );
	if( aIt == mHashMap.end() )
	{
		throw NoSuchElementException();
	}

	sal_Int32 iHashResult = (*aIt).second;
	Any aOldElement = mValues.getConstArray()[ iHashResult ];
	mHashMap.erase( aIt );
	sal_Int32 iLast = mNames.getLength() - 1;
	if( iLast != iHashResult )
	{
		OUString* pNames = mNames.getArray();
		Any* pValues = mValues.getArray();
		pNames[ iHashResult ] = pNames[ iLast ];
		pValues[ iHashResult ] = pValues[ iLast ];
		mHashMap[ pNames[ iHashResult ] ] = iHashResult;
	}
	mNames.realloc( iLast );
	mValues.realloc( iLast );
	mnElementCount--;

	
	// Fire event
	ContainerEvent aEvent;		
	aEvent.Source = mpxEventSource;
	aEvent.Accessor <<= Name;
	aEvent.Element = aOldElement;

	OInterfaceIteratorHelper aIterator( maListenerContainer );
	while( aIterator.hasMoreElements() )
	{
		Reference< XInterface > xIface = aIterator.next();
		Reference< XContainerListener > xListener( xIface, UNO_QUERY );
		xListener->elementRemoved( aEvent );
	}
}


// Methods XContainer
void SAL_CALL NameContainer_Impl::addContainerListener( const Reference< XContainerListener >& xListener ) 
	throw (RuntimeException)
{
	if( !xListener.is() )
		throw RuntimeException();
	Reference< XInterface > xIface( xListener, UNO_QUERY );
	maListenerContainer.addInterface( xIface );
}

void SAL_CALL NameContainer_Impl::removeContainerListener( const Reference< XContainerListener >& xListener ) 
	throw (RuntimeException)
{
	if( !xListener.is() )
		throw RuntimeException();
	Reference< XInterface > xIface( xListener, UNO_QUERY );
	maListenerContainer.removeInterface( xIface );
}


}	// namespace SfxContainer_Impl


//============================================================================

// Implementation class SfxLibraryContainer_Impl

// Ctor
SfxLibraryContainer_Impl::SfxLibraryContainer_Impl
( const OUString& aLibInfoFileName, const OUString& aLibElementFileExtension,
  const OUString& aLibraryPath, const OUString& aLibrariesDir )
	: maNameContainer( getCppuType( (Reference< XNameAccess >*) NULL ) )
	, mbModified( sal_False )
	, maLibInfoFileName( aLibInfoFileName )
	, maLibElementFileExtension( aLibElementFileExtension )
	, maLibraryPath( aLibraryPath )
	, maLibrariesDir( aLibrariesDir )
{
}

sal_Bool SfxLibraryContainer_Impl::init( SotStorageRef xStorage )
{
	mxStorage = xStorage;

	// TODO: Member because later it will be a component
	Reference< XMultiServiceFactory > xMSF( comphelper::getProcessServiceFactory() );
	if( !xMSF.is() )
		return sal_False;

	Reference< XParser > xParser( xMSF->createInstance(
		OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.xml.sax.Parser") ) ), UNO_QUERY );
	if( !xParser.is() )
	{
		OSL_ENSURE( 0, "### couln't create sax parser component\n" );
		return sal_False;
	}

	Reference< XSimpleFileAccess > xSFI( xMSF->createInstance
		( OUString::createFromAscii( "com.sun.star.ucb.SimpleFileAccess" ) ), UNO_QUERY );
	if( !xSFI.is() )
	{
		OSL_ENSURE( 0, "### couln't create SimpleFileAccess component\n" );
		return sal_False;
	}
	Reference< XInputStream > xInput;

	sal_Bool bStorage = xStorage.Is();
	SotStorageRef xLibrariesStor;
	SotStorageStreamRef xStream;
	String aFileName;
	if( bStorage )
	{
        xLibrariesStor = xStorage->OpenSotStorage( maLibrariesDir, STREAM_READ | STREAM_NOCREATE );
		if( xLibrariesStor.Is() && xLibrariesStor->GetError() == ERRCODE_NONE )
		{
			aFileName = maLibInfoFileName;
			aFileName += String( RTL_CONSTASCII_USTRINGPARAM(".xml") );

			xStream = xLibrariesStor->OpenSotStream( aFileName, STREAM_READ );
			if( xStream->GetError() != ERRCODE_NONE )
			{
				// Check for EA2 document version with wrong extensions
				aFileName = maLibInfoFileName;
				aFileName += String( RTL_CONSTASCII_USTRINGPARAM(".xli") );
				xStream = xLibrariesStor->OpenSotStream( aFileName, STREAM_READ );
			}

			if( xStream->GetError() == ERRCODE_NONE )
			{
				xInput = new utl::OInputStreamWrapper( *xStream );
			}
		}
	}
	else
	{
		String aBasicPath( maLibraryPath );
		INetURLObject aLibInfoInetObj( aBasicPath.GetToken(1) );
		aLibInfoInetObj.insertName( maLibInfoFileName, sal_True, INetURLObject::LAST_SEGMENT, sal_True, INetURLObject::ENCODE_ALL );
		aLibInfoInetObj.setExtension( OUString( RTL_CONSTASCII_USTRINGPARAM("xli") ) );
		aFileName = aLibInfoInetObj.GetMainURL();

		try
		{
			xInput = xSFI->openFileRead( aFileName );
		}
		catch( Exception& )
		//catch( Exception& e )
		{
			// TODO:
			//throw WrappedTargetException( e );
			//throw e;
		}
	}

	if( !xInput.is() )
	{
		// TODO: When really error?
		//OSL_ENSURE( 0, "### couln't open input stream\n" );
		return sal_False;
	}	
	InputSource source;
	source.aInputStream = xInput;
	source.sSystemId 	= aFileName;

	// start parsing
    ::xmlscript::LibDescriptorArray* pLibArray = new ::xmlscript::LibDescriptorArray();
	xParser->setDocumentHandler( ::xmlscript::importLibraryContainer( pLibArray ) );
	xParser->parseStream( source );

    sal_Int32 nLibCount = pLibArray->mnLibCount;
	for( sal_Int32 i = 0 ; i < nLibCount ; i++ )
	{
		::xmlscript::LibDescriptor& rLib = pLibArray->mpLibs[i];

		// Check storage URL
		OUString aStorageURL = rLib.aStorageURL;
		if( rLib.bLink && !aStorageURL.getLength() )
		{
			String aBasicPath( maLibraryPath );
			INetURLObject aInetObj( aBasicPath.GetToken(1) );
			aInetObj.insertName( rLib.aName, sal_True, INetURLObject::LAST_SEGMENT,
				sal_True, INetURLObject::ENCODE_ALL );
			OUString aLibDirPath = aInetObj.GetMainURL();
			if( xSFI->isFolder( aLibDirPath ) )
			{
				rLib.aStorageURL = aLibDirPath;
				mbModified = sal_True;
			}
			else
			{
				// Check "share" path
				INetURLObject aShareInetObj( aBasicPath.GetToken(0) );
				aShareInetObj.insertName( rLib.aName, sal_True, INetURLObject::LAST_SEGMENT,
					sal_True, INetURLObject::ENCODE_ALL );
				OUString aShareLibDirPath = aShareInetObj.GetMainURL();
				if( xSFI->isFolder( aShareLibDirPath ) )
				{
					rLib.aStorageURL = aShareLibDirPath;
					mbModified = sal_True;
				}
			}
		}

		SfxLibrary_Impl* pImplLib;
		if( rLib.bLink )
		{
			Reference< XNameAccess > xLib =
				createLibraryLink( rLib.aName, rLib.aStorageURL, rLib.bReadOnly );
			pImplLib = static_cast< SfxLibrary_Impl* >( xLib.get() );
		}
		else
		{
			Reference< XNameContainer > xLib = createLibrary( rLib.aName );
			pImplLib = static_cast< SfxLibrary_Impl* >( xLib.get() );
			pImplLib->mbLoaded = sal_False;
		}

		sal_Int32 nElementCount = rLib.aElementNames.getLength();
		const OUString* pElementNames = rLib.aElementNames.getConstArray();
		Any aDummyElement = createEmptyLibraryElement();
		for( sal_Int32 j = 0 ; j < nElementCount ; j++ )
		{
			pImplLib->insertByName( pElementNames[j], aDummyElement );
		}
	}

	delete pLibArray;

	return sal_True;
}


// Storing
void SfxLibraryContainer_Impl::implStoreLibrary( SfxLibrary_Impl* pLib,
	const ::rtl::OUString& aName, SotStorageRef xStorage )
{
	// TODO: Member because later it will be a component
	Reference< XMultiServiceFactory > xMSF( comphelper::getProcessServiceFactory() );
    	if( !xMSF.is() )
		return;

	sal_Bool bLink = (pLib->maStorageURL.getLength() > 0);
	sal_Bool bStorage = xStorage.Is() && !bLink;

	String aLibDirPath;
	if( bLink )
	{
		aLibDirPath = pLib->maStorageURL;
	}
	else if( !bStorage )
	{
		String aBasicPath( maLibraryPath );
		INetURLObject aInetObj( aBasicPath.GetToken(1) );
		aInetObj.insertName( aName, sal_True, INetURLObject::LAST_SEGMENT, sal_True, INetURLObject::ENCODE_ALL );
		aLibDirPath = aInetObj.GetMainURL();
	}

	if( bStorage )
	{
		Sequence< OUString > aElementNames = pLib->getElementNames();
		sal_Int32 nNameCount = aElementNames.getLength();

		const OUString* pNames = aElementNames.getConstArray();
		for( sal_Int32 i = 0 ; i < nNameCount ; i++ )
		{
			OUString aElementName = pNames[ i ];

			OUString aStreamName = aElementName;
			aStreamName += String( RTL_CONSTASCII_USTRINGPARAM(".xml") );

			Any aElement = pLib->getByName( aElementName );
			if( isLibraryElementValid( aElement ) )
			{
				SotStorageStreamRef xElementStream = xStorage->OpenSotStream
					( aStreamName, STREAM_WRITE | STREAM_SHARE_DENYWRITE );

				if( xElementStream->GetError() == ERRCODE_NONE )
				{
					String aPropName( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM("MediaType") ) );
					OUString aMime( RTL_CONSTASCII_USTRINGPARAM("text/xml") );
					Any aAny;
					aAny <<= aMime;
					xElementStream->SetProperty( aPropName, aAny );

                    // #87671 Allow encryption
					aPropName = String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM("Encrypted") );
					aAny <<= sal_True;
					xElementStream->SetProperty( aPropName, aAny );

					Reference< XOutputStream > xOutput =
						new utl::OOutputStreamWrapper( *xElementStream );
					writeLibraryElement( aElement, aElementName, xOutput );
					xOutput->closeOutput();

					xElementStream->Commit();
				}
			}
		}
	}
	else
	{
		try
		{
			// Get Output stream
			Reference< XSimpleFileAccess > xSFI( xMSF->createInstance
				( OUString::createFromAscii( "com.sun.star.ucb.SimpleFileAccess" ) ), UNO_QUERY );
			if( !xSFI.is() )
			{
				OSL_ENSURE( 0, "### couln't create SimpleFileAccess component\n" );
			}
			if( !xSFI->isFolder( aLibDirPath ) )
				xSFI->createFolder( aLibDirPath );

			Sequence< OUString > aElementNames = pLib->getElementNames();
			sal_Int32 nNameCount = aElementNames.getLength();

			const OUString* pNames = aElementNames.getConstArray();
			for( sal_Int32 i = 0 ; i < nNameCount ; i++ )
			{
				OUString aElementName = pNames[ i ];

				INetURLObject aElementInetObj( aLibDirPath );
				aElementInetObj.insertName( aElementName, sal_False,
					INetURLObject::LAST_SEGMENT, sal_True, INetURLObject::ENCODE_ALL );
				aElementInetObj.setExtension( maLibElementFileExtension );
				String aElementPath( aElementInetObj.GetMainURL() );

				Any aElement = pLib->getByName( aElementName );
				if( isLibraryElementValid( aElement ) )
				{
					// TODO: Check modified
		            try
		            {
					    if( xSFI->exists( aElementPath ) )
						    xSFI->kill( aElementPath );
    					Reference< XOutputStream > xOutput = xSFI->openFileWrite( aElementPath );
					    writeLibraryElement( aElement, aElementName, xOutput );
					    xOutput->closeOutput();
                    }
            		catch( Exception& )
                    {
			            SfxErrorContext aEc( ERRCTX_SFX_SAVEDOC, aElementPath );
                        ULONG nErrorCode = ERRCODE_IO_GENERAL;
                	    ErrorHandler::HandleError( nErrorCode );
                    }
				}
			}
		}
		catch( Exception& )
		//catch( Exception& e )
		{
			// TODO
			//throw e;
		}
	}
}

void SfxLibraryContainer_Impl::storeLibraries( sal_Bool bComplete )
{
	SotStorageRef xStorage;
	storeLibraries_Impl( xStorage, bComplete );
}

void SfxLibraryContainer_Impl::storeLibrariesToStorage( SotStorageRef xStorage )
{
	sal_Bool bComplete = sal_True;
	storeLibraries_Impl( xStorage, bComplete );
}

// Methods of new XLibraryStorage interface?
void SfxLibraryContainer_Impl::storeLibraries_Impl( SotStorageRef xStorage, sal_Bool bComplete )
{
	Sequence< OUString > aNames = maNameContainer.getElementNames();
	const OUString* pNames = aNames.getConstArray();
	sal_Int32 i, nNameCount = aNames.getLength();
    if( !nNameCount )
        return;

	::xmlscript::LibDescriptorArray* pLibArray = new ::xmlscript::LibDescriptorArray( nNameCount );

	// Write to storage?
	sal_Bool bStorage = xStorage.Is();
	SotStorageRef xLibrariesStor;
	if( bStorage )
	{
        // Don't write if all libs are empty
        sal_Bool bAllLibsEmpty = sal_True;
	    for( i = 0 ; i < nNameCount ; i++ )
	    {
		    ::xmlscript::LibDescriptor& rLib = pLibArray->mpLibs[i];
		    rLib.aName = pNames[ i ];
		    Any aLibAny = maNameContainer.getByName( rLib.aName );
		    Reference< XNameAccess > xNameAccess;
		    aLibAny >>= xNameAccess;

            if( xNameAccess->hasElements() )
            {
                bAllLibsEmpty = sal_False;
                break;
            }
        }
        if( bAllLibsEmpty )
            return;

		xLibrariesStor = xStorage->OpenUCBStorage( maLibrariesDir, STREAM_WRITE );
		if( !xLibrariesStor.Is() || xLibrariesStor->GetError() != ERRCODE_NONE )
		{
			OSL_ENSURE( 0, "### couln't create libraries sub storage\n" );
			return;
		}
	}

	for( i = 0 ; i < nNameCount ; i++ )
	{
		::xmlscript::LibDescriptor& rLib = pLibArray->mpLibs[i];
		rLib.aName = pNames[ i ];
		Any aLibAny = maNameContainer.getByName( rLib.aName );
		Reference< XNameAccess > xNameAccess;
		aLibAny >>= xNameAccess;

		SfxLibrary_Impl* pImplLib = static_cast< SfxLibrary_Impl* >( xNameAccess.get() );
		rLib.bLink = ( pImplLib->maStorageURL.getLength() > 0 );
		if( rLib.bLink )
		{
			rLib.aStorageURL = pImplLib->maStorageURL;
		}
		rLib.bReadOnly = pImplLib->mbReadOnly;
		rLib.aElementNames = pImplLib->getElementNames();

		if( pImplLib->mbModified || (bComplete && pImplLib->hasElements() ) )
		{
			if( !pImplLib->mbReadOnly )
			{
				SotStorageRef xLibraryStor;
				if( bStorage )
				{
					xLibraryStor = xLibrariesStor->OpenUCBStorage( rLib.aName, STREAM_WRITE );
					if( !xLibraryStor.Is() || xLibraryStor->GetError() != ERRCODE_NONE )
					{
						OSL_ENSURE( 0, "### couln't create sub storage for library\n" );
						return;
					}
				}

				// Maybe lib is not loaded?!
				if( bComplete )
					loadLibrary( rLib.aName );

				implStoreLibrary( pImplLib, rLib.aName, xLibraryStor );

				if( bStorage )
				{
					xLibraryStor->Commit();
				}
			}

			mbModified = sal_True;
			pImplLib->mbModified = sal_False;
		}
	}

	if( !mbModified )
		return;
	mbModified = sal_False;

	// Write library container info
	Reference< XMultiServiceFactory > xMSF( comphelper::getProcessServiceFactory() );
	if( !xMSF.is() )
		return;

	// Create sax writer
	Reference< XExtendedDocumentHandler > xHandler(
		xMSF->createInstance(
			OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.xml.sax.Writer") ) ), UNO_QUERY );
	if( !xHandler.is() )
	{
		OSL_ENSURE( 0, "### couln't create sax-writer component\n" );
		return;
	}

	Reference< XSimpleFileAccess > xSFI( xMSF->createInstance
		( OUString::createFromAscii( "com.sun.star.ucb.SimpleFileAccess" ) ), UNO_QUERY );
	if( !xSFI.is() )
	{
		OSL_ENSURE( 0, "### couln't create SimpleFileAccess component\n" );
		return;
	}

	// Write info file
	Reference< XOutputStream > xOut;
	SotStorageStreamRef xInfoStream;
	if( bStorage )
	{
		OUString aStreamName( maLibInfoFileName );
		aStreamName += String( RTL_CONSTASCII_USTRINGPARAM(".xml") );

		xInfoStream = xLibrariesStor->OpenSotStream( aStreamName,
			STREAM_WRITE | STREAM_SHARE_DENYWRITE );

		if( xInfoStream->GetError() == ERRCODE_NONE )
		{
			String aPropName( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM("MediaType") ) );
			OUString aMime( RTL_CONSTASCII_USTRINGPARAM("text/xml") );
			Any aAny;
			aAny <<= aMime;
			xInfoStream->SetProperty( aPropName, aAny );

            // #87671 Allow encryption
			aPropName = String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM("Encrypted") );
			aAny <<= sal_True;
			xInfoStream->SetProperty( aPropName, aAny );

			xOut = new utl::OOutputStreamWrapper( *xInfoStream );
		}
	}
	else
	{
		// Create Output stream
		String aBasicPath( maLibraryPath );
		INetURLObject aLibInfoInetObj( aBasicPath.GetToken(1) );
		aLibInfoInetObj.insertName( maLibInfoFileName, sal_True, INetURLObject::LAST_SEGMENT, sal_True, INetURLObject::ENCODE_ALL );
		aLibInfoInetObj.setExtension( OUString( RTL_CONSTASCII_USTRINGPARAM("xli") ) );
		String aLibInfoPath( aLibInfoInetObj.GetMainURL() );

		try
		{
		    if( xSFI->exists( aLibInfoPath ) )
			    xSFI->kill( aLibInfoPath );
		    xOut = xSFI->openFileWrite( aLibInfoPath );
        }
        catch( Exception& )
        {
			SfxErrorContext aEc( ERRCTX_SFX_SAVEDOC, aLibInfoPath );
            ULONG nErrorCode = ERRCODE_IO_GENERAL;
            ErrorHandler::HandleError( nErrorCode );
        }

	}
	if( !xOut.is() )
	{
		OSL_ENSURE( 0, "### couln't open output stream\n" );
		return;
	}

	Reference< XActiveDataSource > xSource( xHandler, UNO_QUERY );
	xSource->setOutputStream( xOut );

	xmlscript::exportLibraryContainer( xHandler, pLibArray );
	if( xInfoStream.Is() )
		xInfoStream->Commit();
	if( xLibrariesStor.Is() )
		xLibrariesStor->Commit();

	delete pLibArray;
}


// Methods XElementAccess
Type SfxLibraryContainer_Impl::getElementType()
	throw(RuntimeException)
{
	return maNameContainer.getElementType();
}

sal_Bool SfxLibraryContainer_Impl::hasElements()
	throw(RuntimeException)
{
	sal_Bool bRet = maNameContainer.hasElements();
	return bRet;
}

// Methods XNameAccess
Any SfxLibraryContainer_Impl::getByName( const OUString& aName )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	Any aRetAny = maNameContainer.getByName( aName ) ;
	return aRetAny;
}

Sequence< OUString > SfxLibraryContainer_Impl::getElementNames()
	throw(RuntimeException)
{
	return maNameContainer.getElementNames();
}

sal_Bool SfxLibraryContainer_Impl::hasByName( const OUString& aName )
	throw(RuntimeException)
{
	sal_Bool bRet = maNameContainer.hasByName( aName ) ;
	return bRet;
}

// Methods XLibraryContainer
Reference< XNameContainer > SAL_CALL SfxLibraryContainer_Impl::createLibrary( const OUString& Name )
		throw(IllegalArgumentException, ElementExistException, RuntimeException)
{
	SfxLibrary_Impl* pNewLib = implCreateLibrary();
	Reference< XNameAccess > xNameAccess = static_cast< XNameAccess* >( pNewLib );
	Any aElement;
	aElement <<= xNameAccess;
	maNameContainer.insertByName( Name, aElement );
	mbModified = sal_True;
	Reference< XNameContainer > xRet( xNameAccess, UNO_QUERY );
	return xRet;
}

Reference< XNameAccess > SAL_CALL SfxLibraryContainer_Impl::createLibraryLink
	( const OUString& Name, const OUString& StorageURL, sal_Bool ReadOnly )
		throw(IllegalArgumentException, ElementExistException, RuntimeException)
{
	// TODO: Check other reasons to force ReadOnly status
	//if( !ReadOnly )
	//{
	//}

	SfxLibrary_Impl* pNewLib = implCreateLibraryLink( StorageURL, ReadOnly );
	Reference< XNameAccess > xRet = static_cast< XNameAccess* >( pNewLib );
	Any aElement;
	aElement <<= xRet;
	maNameContainer.insertByName( Name, aElement );
	mbModified = sal_True;
	return xRet;
}

void SAL_CALL SfxLibraryContainer_Impl::removeLibrary( const OUString& Name )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	maNameContainer.removeByName( Name );
	mbModified = sal_True;

	// TODO: Remove Lib from File!
}

sal_Bool SAL_CALL SfxLibraryContainer_Impl::isLibraryLoaded( const OUString& Name )
	throw(NoSuchElementException, RuntimeException)
{
	Any aLibAny = maNameContainer.getByName( Name ) ;
	Reference< XNameAccess > xNameAccess;
	aLibAny >>= xNameAccess;
	SfxLibrary_Impl* pImplLib = static_cast< SfxLibrary_Impl* >( xNameAccess.get() );
	sal_Bool bRet = pImplLib->mbLoaded;
	return bRet;
}


void SAL_CALL SfxLibraryContainer_Impl::loadLibrary( const OUString& Name )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	Any aLibAny = maNameContainer.getByName( Name ) ;
	Reference< XNameAccess > xNameAccess;
	aLibAny >>= xNameAccess;
	SfxLibrary_Impl* pImplLib = static_cast< SfxLibrary_Impl* >( xNameAccess.get() );
	if( !pImplLib->mbLoaded && xNameAccess->hasElements() )
	{
		pImplLib->mbLoaded = sal_True;

		sal_Bool bLink = (pImplLib->maStorageURL.getLength() > 0);
		sal_Bool bStorage = mxStorage.Is() && !bLink;

		SotStorageRef xLibrariesStor;
		SotStorageRef xLibraryStor;
		SotStorageStreamRef xElementStream;
		if( bStorage )
		{
            xLibrariesStor = mxStorage->OpenSotStorage( maLibrariesDir, STREAM_READ | STREAM_NOCREATE );
			if( xLibrariesStor.Is() && xLibrariesStor->GetError() == ERRCODE_NONE )
			{
                xLibraryStor = xLibrariesStor->OpenSotStorage( Name, STREAM_READ | STREAM_NOCREATE );
			}
			if( !xLibraryStor.Is() || xLibraryStor->GetError() != ERRCODE_NONE )
			{
				OSL_ENSURE( 0, "### couln't open sub storage for library\n" );
				return;
			}
		}

		String aLibDirPath;
		if( pImplLib->maStorageURL.getLength() )
		{
			aLibDirPath = pImplLib->maStorageURL;
		}
		else if( !bStorage )
		{
			String aBasicPath( maLibraryPath );
			INetURLObject aLibInetObj( aBasicPath.GetToken(1) );
			aLibInetObj.insertName( Name, sal_True, INetURLObject::LAST_SEGMENT,
				sal_True, INetURLObject::ENCODE_ALL );
			aLibDirPath = aLibInetObj.GetMainURL();
		}

		Sequence< OUString > aNames = pImplLib->getElementNames();
		sal_Int32 nNameCount = aNames.getLength();
		const OUString* pNames = aNames.getConstArray();
		for( sal_Int32 i = 0 ; i < nNameCount ; i++ )
		{
			OUString aElementName = pNames[ i ];

			OUString aFile;
			if( bStorage )
			{
				aFile = aElementName;
				aFile += String( RTL_CONSTASCII_USTRINGPARAM(".xml") );

				xElementStream = xLibraryStor->OpenSotStream( aFile, STREAM_READ );
				if( xElementStream->GetError() != ERRCODE_NONE )
				{
					// Check for EA2 document version with wrong extensions
					aFile = aElementName;
					aFile += String( RTL_CONSTASCII_USTRINGPARAM(".") );
					aFile += maLibElementFileExtension;
					xElementStream = xLibraryStor->OpenSotStream( aFile, STREAM_READ );
				}

				if( !xElementStream.Is() || xElementStream->GetError() != ERRCODE_NONE )
				{
					OSL_ENSURE( 0, "### couln't open library element stream\n" );
					return;
				}
			}
			else
			{
				INetURLObject aElementInetObj( aLibDirPath );
				aElementInetObj.insertName( aElementName, sal_False,
					INetURLObject::LAST_SEGMENT, sal_True, INetURLObject::ENCODE_ALL );
				aElementInetObj.setExtension( maLibElementFileExtension );
				aFile = aElementInetObj.GetMainURL();
			}

			Any aAny = importLibraryElement( aFile, xElementStream );
			if( pImplLib->hasByName( aElementName ) )
            {
                if( aAny.hasValue() )
				    pImplLib->replaceByName( aElementName, aAny );
            }
			else
            {
				pImplLib->insertByName( aElementName, aAny );
            }
		}
	}
}


// Methods XContainer
void SAL_CALL SfxLibraryContainer_Impl::addContainerListener( const Reference< XContainerListener >& xListener ) 
	throw (::com::sun::star::uno::RuntimeException)
{
	maNameContainer.setEventSource( static_cast< XInterface* >( (OWeakObject*)this ) );
	maNameContainer.addContainerListener( xListener );
}

void SAL_CALL SfxLibraryContainer_Impl::removeContainerListener( const Reference< XContainerListener >& xListener ) 
	throw (::com::sun::star::uno::RuntimeException)
{
	maNameContainer.removeContainerListener( xListener );
}


//============================================================================

// Implementation class SfxLibrary_Impl

// Ctor
SfxLibrary_Impl::SfxLibrary_Impl( Type aType )
	: OComponentHelper( m_mutex )
	, maNameContainer( aType )
	, mbLoaded( sal_True )
	, mbModified( sal_True )
	, mbReadOnly( sal_False )
{
}

SfxLibrary_Impl::SfxLibrary_Impl( Type aType, const ::rtl::OUString& aStorageURL, sal_Bool ReadOnly )
	: OComponentHelper( m_mutex )
	, maNameContainer( aType )
	, mbLoaded( sal_False )
	, mbModified( sal_True )
	, mbReadOnly( ReadOnly )
	, maStorageURL( aStorageURL )
{
}


// Methods XInterface
Any SAL_CALL SfxLibrary_Impl::queryInterface( const Type& rType )
	throw( RuntimeException )
{
	Any aRet;
	if( mbReadOnly )
	{
		aRet = Any( ::cppu::queryInterface( rType,
			static_cast< XContainer * >( this ),
			static_cast< XNameAccess * >( this ) ) );
	}
	else
	{
		aRet = Any( ::cppu::queryInterface( rType,
			static_cast< XContainer * >( this ),
			static_cast< XNameContainer * >( this ),
			static_cast< XNameAccess * >( this ) ) );
	}
	if( !aRet.hasValue() )
		aRet = OComponentHelper::queryInterface( rType );
	return aRet;
}

// Methods XElementAccess
Type SfxLibrary_Impl::getElementType()
	throw(RuntimeException)
{
	return maNameContainer.getElementType();
}

sal_Bool SfxLibrary_Impl::hasElements()
	throw(RuntimeException)
{
	sal_Bool bRet = maNameContainer.hasElements();
	return bRet;
}

// Methods XNameAccess
Any SfxLibrary_Impl::getByName( const OUString& aName )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	Any aRetAny = maNameContainer.getByName( aName ) ;
	return aRetAny;
}

Sequence< OUString > SfxLibrary_Impl::getElementNames()
	throw(RuntimeException)
{
	return maNameContainer.getElementNames();
}

sal_Bool SfxLibrary_Impl::hasByName( const OUString& aName )
	throw(RuntimeException)
{
	sal_Bool bRet = maNameContainer.hasByName( aName );
	return bRet;
}

// Methods XNameReplace
void SfxLibrary_Impl::replaceByName( const OUString& aName, const Any& aElement )
	throw(IllegalArgumentException, NoSuchElementException, WrappedTargetException, RuntimeException)
{
	if( !mbReadOnly )
	{
		maNameContainer.replaceByName( aName, aElement );
		mbModified = sal_True;
	}
}


// Methods XNameContainer
void SfxLibrary_Impl::insertByName( const OUString& aName, const Any& aElement )
	throw(IllegalArgumentException, ElementExistException, WrappedTargetException, RuntimeException)
{
	if( !mbReadOnly )
	{
		maNameContainer.insertByName( aName, aElement );
		mbModified = sal_True;
	}
}

void SfxLibrary_Impl::removeByName( const OUString& Name )
	throw(NoSuchElementException, WrappedTargetException, RuntimeException)
{
	if( !mbReadOnly )
		maNameContainer.removeByName( Name );

    // TODO: Remove Lib File!
}

// XTypeProvider
Sequence< Type > SfxLibrary_Impl::getTypes()
	throw( RuntimeException )
{
	static OTypeCollection * s_pTypes_NameContainer = 0;
	static OTypeCollection * s_pTypes_NameAccess = 0;
	if( mbReadOnly )
	{
		if( !s_pTypes_NameAccess )
		{
			MutexGuard aGuard( Mutex::getGlobalMutex() );
			if( !s_pTypes_NameAccess )
			{
				static OTypeCollection s_aTypes_NameAccess(
					::getCppuType( (const Reference< XNameAccess > *)0 ),
					::getCppuType( (const Reference< XContainer > *)0 ),
					OComponentHelper::getTypes() );
				s_pTypes_NameAccess = &s_aTypes_NameAccess;
			}
		}
		return s_pTypes_NameAccess->getTypes();
	}
	else
	{
		if( !s_pTypes_NameContainer )
		{
			MutexGuard aGuard( Mutex::getGlobalMutex() );
			if( !s_pTypes_NameContainer )
			{
				static OTypeCollection s_aTypes_NameContainer(
					::getCppuType( (const Reference< XNameContainer > *)0 ),
					::getCppuType( (const Reference< XContainer > *)0 ),
					OComponentHelper::getTypes() );
				s_pTypes_NameContainer = &s_aTypes_NameContainer;
			}
		}
		return s_pTypes_NameContainer->getTypes();
	}
}


Sequence< sal_Int8 > SfxLibrary_Impl::getImplementationId()
	throw( RuntimeException )
{
	static OImplementationId * s_pId_NameContainer = 0;
	static OImplementationId * s_pId_NameAccess = 0;
	if( mbReadOnly )
	{
		if( !s_pId_NameAccess )
		{
			MutexGuard aGuard( Mutex::getGlobalMutex() );
			if( !s_pId_NameAccess )
			{
				static OImplementationId s_aId_NameAccess;
				s_pId_NameAccess = &s_aId_NameAccess;
			}
		}
		return s_pId_NameAccess->getImplementationId();
	}
	else
	{
		if( !s_pId_NameContainer )
		{
			MutexGuard aGuard( Mutex::getGlobalMutex() );
			if( !s_pId_NameContainer )
			{
				static OImplementationId s_aId_NameContainer;
				s_pId_NameContainer = &s_aId_NameContainer;
			}
		}
		return s_pId_NameContainer->getImplementationId();
	}
}

// Methods XContainer
void SAL_CALL SfxLibrary_Impl::addContainerListener( const Reference< XContainerListener >& xListener ) 
	throw (::com::sun::star::uno::RuntimeException)
{
	maNameContainer.setEventSource( static_cast< XInterface* >( (OWeakObject*)this ) );
	maNameContainer.addContainerListener( xListener );
}

void SAL_CALL SfxLibrary_Impl::removeContainerListener( const Reference< XContainerListener >& xListener ) 
	throw (::com::sun::star::uno::RuntimeException)
{
	maNameContainer.removeContainerListener( xListener );
}

//============================================================================
