/*************************************************************************
 *
 *  $RCSfile: scriptcont.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: ab $ $Date: 2001/06/25 11:07:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XPARSER_HPP_
#include <com/sun/star/xml/sax/XParser.hpp>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_INPUTSOURCE_HPP_
#include <com/sun/star/xml/sax/InputSource.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XOUTPUTSTREAM_HPP_
#include <com/sun/star/io/XOutputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XINPUTSTREAM_HPP_
#include <com/sun/star/io/XInputStream.hpp>
#endif
#ifndef _COM_SUN_STAR_IO_XACTIVEDATASOURCE_HPP_
#include <com/sun/star/io/XActiveDataSource.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XSIMPLEFILEACCESS_HPP_
#include <com/sun/star/ucb/XSimpleFileAccess.hpp>
#endif

#include <basmgr.hxx>
#include <com/sun/star/script/XStarBasicAccess.hpp>
#include <com/sun/star/script/XStarBasicModuleInfo.hpp>
#include <com/sun/star/script/XStarBasicLibraryInfo.hpp>


#include "scriptcont.hxx"

#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif
#ifndef _UTL_STREAM_WRAPPER_HXX_
#include <unotools/streamwrap.hxx>
#endif

#include <svtools/pathoptions.hxx>
#include <xmlscript/xmlmod_imexp.hxx>


using namespace com::sun::star::container;
using namespace com::sun::star::io;
using namespace com::sun::star::uno;
using namespace com::sun::star::ucb;
using namespace com::sun::star::lang;
using namespace com::sun::star::script;
using namespace com::sun::star::xml::sax;
using namespace com::sun::star;
using namespace cppu;
using namespace rtl;


//============================================================================
// Implementation class SfxScriptLibraryContainer

SfxScriptLibraryContainer::	SfxScriptLibraryContainer
	( const ::rtl::OUString& aScriptLanguage, BasicManager* pBasMgr, SotStorage* pStor )
	: maScriptLanguage( aScriptLanguage )
	, mpBasMgr( pBasMgr )
	, SfxLibraryContainer_Impl( 
		OUString ( RTL_CONSTASCII_USTRINGPARAM("script") ),
		OUString ( RTL_CONSTASCII_USTRINGPARAM("xba") ),
		SvtPathOptions().GetBasicPath(),
		OUString ( RTL_CONSTASCII_USTRINGPARAM("Basic") ) )
{
	sal_Bool bInit = init( pStor );
	if( mpBasMgr )
	{
		StarBASIC* pStdLib = mpBasMgr->GetStdLib();
		if( pStdLib )
		{
			// Not modified after loading
			pStdLib->SetModified( FALSE );
		}
	}
}

// Methods to get library instances of the correct type
SfxLibrary_Impl* SfxScriptLibraryContainer::implCreateLibrary( void )
{
	SfxLibrary_Impl* pRet = (SfxLibrary_Impl*) new SfxScriptLibrary();
	return pRet;
}

SfxLibrary_Impl* SfxScriptLibraryContainer::implCreateLibraryLink
	( const OUString& StorageURL, sal_Bool ReadOnly )
{
	SfxLibrary_Impl* pRet = 
		(SfxLibrary_Impl*) new SfxScriptLibrary( StorageURL, ReadOnly );
	return pRet;
}

Any SAL_CALL SfxScriptLibraryContainer::createEmptyLibraryElement( void )
{
	OUString aMod;
	Any aRetAny;
	aRetAny <<= aMod;
	return aRetAny;
}

sal_Bool SAL_CALL SfxScriptLibraryContainer::isLibraryElementValid( Any aElement )
{
	OUString aMod;
	aElement >>= aMod;
	sal_Bool bRet = (aMod.getLength() > 0);
	return bRet;
}

void SAL_CALL SfxScriptLibraryContainer::writeLibraryElement
( 
	Any aElement,
	const OUString& aElementName, 
	Reference< XOutputStream > xOutput 
)
	throw(Exception)
{
	// TODO: Member because later it will be a component
	Reference< XMultiServiceFactory > xMSF( comphelper::getProcessServiceFactory() );
	if( !xMSF.is() )
	{
		OSL_ENSURE( 0, "### couln't get ProcessServiceFactory\n" );
		return;
	}

	// Create sax writer
	Reference< XExtendedDocumentHandler > xHandler(
		xMSF->createInstance(
			OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.xml.sax.Writer") ) ), UNO_QUERY );
	if( !xHandler.is() )
	{
		OSL_ENSURE( 0, "### couln't create sax-writer component\n" );
		return;
	}

	Reference< XActiveDataSource > xSource( xHandler, UNO_QUERY );
	xSource->setOutputStream( xOutput );

	xmlscript::ModuleDescriptor aMod;
	aMod.aName = aElementName;
	aMod.aLanguage = maScriptLanguage;
	aElement >>= aMod.aCode;
	xmlscript::exportScriptModule( xHandler, aMod );
}


Any SAL_CALL SfxScriptLibraryContainer::importLibraryElement
	( const OUString& aFile, SotStorageStreamRef xElementStream )
{
	Any aRetAny;

	// TODO: Member because later it will be a component
	Reference< XMultiServiceFactory > xMSF( comphelper::getProcessServiceFactory() );
	if( !xMSF.is() )
	{
		OSL_ENSURE( 0, "### couln't get ProcessServiceFactory\n" );
		return aRetAny;
	}

	Reference< XParser > xParser( xMSF->createInstance(
		OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.xml.sax.Parser") ) ), UNO_QUERY );
	if( !xParser.is() )
	{
		OSL_ENSURE( 0, "### couln't create sax parser component\n" );
		return aRetAny;
	}


	// Read from storage?
	sal_Bool bStorage = xElementStream.Is();
	Reference< XInputStream > xInput;

	if( bStorage )
	{
		xInput = new utl::OInputStreamWrapper( *xElementStream );
	}
	else
	{
		Reference< XSimpleFileAccess > xSFI( xMSF->createInstance
			( OUString::createFromAscii( "com.sun.star.ucb.SimpleFileAccess" ) ), UNO_QUERY );
		if( !xSFI.is() )
		{
			OSL_ENSURE( 0, "### couln't create SimpleFileAccess component\n" );
			return aRetAny;
		}

		try
		{
			xInput = xSFI->openFileRead( aFile );
		}
		catch( Exception& )
		//catch( Exception& e )
		{
			// TODO:
			//throw WrappedTargetException( e );
		}
	}
	if( !xInput.is() )
		return aRetAny;

	InputSource source;
	source.aInputStream = xInput;
	source.sSystemId 	= aFile;
	
	// start parsing 
	xmlscript::ModuleDescriptor aMod;
	xParser->setDocumentHandler( ::xmlscript::importScriptModule( aMod ) );
	xParser->parseStream( source );
	aRetAny <<= aMod.aCode;

	// TODO: Check language
	// aMod.aLanguage
	// aMod.aName ignored

	return aRetAny;
}


//============================================================================

void SAL_CALL SfxScriptLibraryContainer::storeLibraries( sal_Bool bComplete )
{
	SfxLibraryContainer_Impl::storeLibraries( bComplete );
}

void SAL_CALL SfxScriptLibraryContainer::storeLibrariesToStorage( SotStorageRef xStorage )
{
	SfxLibraryContainer_Impl::storeLibrariesToStorage( xStorage );
}



//============================================================================
// Implementation class SfxScriptLibrary

// Ctor
SfxScriptLibrary::SfxScriptLibrary( void )
	: SfxLibrary_Impl( getCppuType( (const OUString *)0 ) )
{
}

SfxScriptLibrary::SfxScriptLibrary( const ::rtl::OUString& aStorageURL, sal_Bool ReadOnly )
	: SfxLibrary_Impl( getCppuType( (const OUString *)0 ),
						aStorageURL, ReadOnly)
{
}

//============================================================================

