/*************************************************************************
 *
 *  $RCSfile: filedlg.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: thb $ $Date: 2001/06/28 14:37:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef  _CPPUHELPER_IMPLBASE1_HXX_
#include <cppuhelper/implbase1.hxx>
#endif

#ifndef  _COM_SUN_STAR_LANG_XINITIALIZATION_HPP_
#include <com/sun/star/lang/XInitialization.hpp>
#endif

#ifndef  _COM_SUN_STAR_UI_DIALOGS_COMMONFILEPICKERELEMENTIDS_HPP_
#include <com/sun/star/ui/dialogs/CommonFilePickerElementIds.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_EXECUTABLEDIALOGRESULTS_HPP_
#include <com/sun/star/ui/dialogs/ExecutableDialogResults.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_EXTENDEDFILEPICKERELEMENTIDS_HPP_
#include <com/sun/star/ui/dialogs/ExtendedFilePickerElementIds.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_FILEPREVIEWIMAGEFORMATS_HPP_
#include <com/sun/star/ui/dialogs/FilePreviewImageFormats.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_LISTBOXCONTROLACTIONS_HPP_
#include <com/sun/star/ui/dialogs/ListboxControlActions.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_TEMPLATEDESCRIPTION_HPP_
#include <com/sun/star/ui/dialogs/TemplateDescription.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_XFILEPICKERCONTROLACCESS_HPP_
#include <com/sun/star/ui/dialogs/XFilePickerControlAccess.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_XFILEPICKER_HPP_
#include <com/sun/star/ui/dialogs/XFilePicker.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_XFILEPICKERLISTENER_HPP_
#include <com/sun/star/ui/dialogs/XFilePickerListener.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_XFILEPICKERNOTIFIER_HPP_
#include <com/sun/star/ui/dialogs/XFilePickerNotifier.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_XFILEPREVIEW_HPP_
#include <com/sun/star/ui/dialogs/XFilePreview.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_XFILTERMANAGER_HPP_
#include <com/sun/star/ui/dialogs/XFilterManager.hpp>
#endif

#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif

#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif

#include <strings.hrc>
#include "sdresid.hxx"
#include "filedlg.hxx"

//-----------------------------------------------------------------------------

using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::ui::dialogs;
using namespace ::com::sun::star::uno;
using namespace ::rtl;
using namespace ::cppu;

//-----------------------------------------------------------------------------

class SIPFileDialog_Impl : public WeakImplHelper1< XFilePickerListener >
{
	friend class SIPFileDialog;

	Reference < XFilePicker >	mxFileDlg;

    OUString                maPath;
    OUString                maCurFilter;
	ErrCode				    mnError;

private:
	void					dispose();

public:
	// XFilePickerListener methods
    virtual void SAL_CALL	    fileSelectionChanged( const FilePickerEvent& aEvent ) throw ( RuntimeException );
    virtual void SAL_CALL	    directoryChanged( const FilePickerEvent& aEvent ) throw ( RuntimeException );
    virtual OUString SAL_CALL   helpRequested( const FilePickerEvent& aEvent ) throw ( RuntimeException );
    virtual void SAL_CALL   	controlStateChanged( const FilePickerEvent& aEvent ) throw ( RuntimeException );
    virtual void SAL_CALL	    dialogSizeChanged() throw ( RuntimeException );

    // XEventListener methods
    virtual void SAL_CALL  		disposing( const EventObject& Source ) throw ( RuntimeException );

	// Own methods
								SIPFileDialog_Impl();
						   		~SIPFileDialog_Impl();

	ErrCode						execute();

    void                    	setPath( const OUString& rPath ) { maPath = rPath; }
    OUString                	getPath() const { return maPath; }
};

// ------------------------------------------------------------------------
// XFilePickerListener Methods
// ------------------------------------------------------------------------
void SAL_CALL SIPFileDialog_Impl::fileSelectionChanged( const FilePickerEvent& aEvent ) throw ( RuntimeException )
{
}

// ------------------------------------------------------------------------
void SAL_CALL SIPFileDialog_Impl::directoryChanged( const FilePickerEvent& aEvent ) throw ( RuntimeException )
{}

// ------------------------------------------------------------------------
OUString SAL_CALL SIPFileDialog_Impl::helpRequested( const FilePickerEvent& aEvent ) throw ( RuntimeException )
{
	return OUString();
}

// ------------------------------------------------------------------------
void SAL_CALL SIPFileDialog_Impl::controlStateChanged( const FilePickerEvent& aEvent ) throw ( RuntimeException )
{
}

// ------------------------------------------------------------------------
void SAL_CALL SIPFileDialog_Impl::dialogSizeChanged( ) throw ( RuntimeException )
{
}

// ------------------------------------------------------------------------
// XEventListener Methods
// ------------------------------------------------------------------------
void SAL_CALL SIPFileDialog_Impl::disposing( const EventObject& Source ) throw ( RuntimeException )
{
	dispose();
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void SIPFileDialog_Impl::dispose()
{
	if ( mxFileDlg.is() )
	{
		// remove the event listener
		Reference< XFilePickerNotifier > xNotifier( mxFileDlg, UNO_QUERY );
		if ( xNotifier.is() )
			xNotifier->removeFilePickerListener( this );
		mxFileDlg.clear();
	}
}

// ------------------------------------------------------------------------
// -----------		FileDialogHelper_Impl		---------------------------
// ------------------------------------------------------------------------

SIPFileDialog_Impl::SIPFileDialog_Impl()
{
	// create the file open dialog
	mnError			= ERRCODE_NONE;

	OUString aService( RTL_CONSTASCII_USTRINGPARAM( FILE_OPEN_SERVICE_NAME ) );
	Reference< XMultiServiceFactory > xFactory( ::comphelper::getProcessServiceFactory() );

	mxFileDlg = Reference < XFilePicker > ( xFactory->createInstance( aService ), UNO_QUERY );

	Reference< XFilePickerNotifier > xNotifier( mxFileDlg, UNO_QUERY );
	Reference< XInitialization > xInit( mxFileDlg, UNO_QUERY );

	
	if ( ! mxFileDlg.is() || ! xNotifier.is() )
	{
		mnError = ERRCODE_ABORT;
		return;
	}

	Sequence < Any > aServiceName(1);

	aServiceName[0] <<= TemplateDescription::FILEOPEN_SIMPLE;

	if ( xInit.is() )
		xInit->initialize( aServiceName );
	
	// add the event listener
	xNotifier->addFilePickerListener( this );

	// set the filters
	Reference< XFilterManager > xFltMgr( mxFileDlg, UNO_QUERY );

	xFltMgr->appendFilter( String( SdResId( STR_ALL_FORMATS ) ), String::CreateFromAscii( "*.sdd;*.sda;*.sdp;*.sxi;*.sxd" ) ); 
	xFltMgr->appendFilter( String( SdResId( STR_IMPRESS ) ), String::CreateFromAscii( "*.sdd;*.sxi" ) ); 
	xFltMgr->appendFilter( String( SdResId( STR_DRAW ) ), String::CreateFromAscii( "*.sda;*.sxd" ) ); 
	xFltMgr->appendFilter( String( SdResId( STR_IMPRESS_PACKED_FORMAT ) ), String::CreateFromAscii( "*.sdp" ) ); 
}

// ------------------------------------------------------------------------
SIPFileDialog_Impl::~SIPFileDialog_Impl()
{
}

// ------------------------------------------------------------------------
ErrCode SIPFileDialog_Impl::execute()
{
	Reference< XFilterManager > xFltMgr( mxFileDlg, UNO_QUERY );

    if ( ! mxFileDlg.is() || !xFltMgr.is() )
		return ERRCODE_ABORT;

    if ( maPath.getLength() )
    {
		INetURLObject aObj( maPath, INET_PROT_FILE );
		OUString aTitle( aObj.getName( INetURLObject::LAST_SEGMENT, true,
						 INetURLObject::DECODE_UNAMBIGUOUS ) );
		aObj.removeSegment();
		mxFileDlg->setDisplayDirectory( aObj.GetMainURL(INetURLObject::DECODE_UNAMBIGUOUS) );
		mxFileDlg->setDefaultName( aTitle );
    }

    if ( maCurFilter.getLength() )
        xFltMgr->setCurrentFilter( maCurFilter );
    
	// show the dialog
	sal_Int16 nRet = mxFileDlg->execute();

    maPath = mxFileDlg->getDisplayDirectory();
    maCurFilter = xFltMgr->getCurrentFilter();
    
    if ( nRet == ExecutableDialogResults::CANCEL )
		return ERRCODE_ABORT;
	else
    {
		return ERRCODE_NONE;
    }
}

SIPFileDialog::SIPFileDialog()
{
	mpImp = new SIPFileDialog_Impl();
	mxImp = mpImp;
}

// ------------------------------------------------------------------------
SIPFileDialog::~SIPFileDialog()
{
	mpImp->dispose();
	mxImp.clear();
}

// ------------------------------------------------------------------------
ErrCode SIPFileDialog::Execute()
{
	return mpImp->execute();
}

String SIPFileDialog::GetPath() const
{
	if ( mpImp->mxFileDlg.is() )
	{
		Sequence < OUString > aPathSeq = mpImp->mxFileDlg->getFiles();

		if ( aPathSeq.getLength() == 1 )
			return String( aPathSeq[0] );
	}

	return String();
}

// ------------------------------------------------------------------------
String SIPFileDialog::GetDisplayDirectory() const
{
	return mpImp->getPath();
}

// ------------------------------------------------------------------------
void SIPFileDialog::SetDisplayDirectory( const String& rPath )
{
	mpImp->setPath( rPath );
}

