/*************************************************************************
 *
 *  $RCSfile: centraldlg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: thb $ $Date: 2001/05/25 14:27:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SIP_CENTRAL_
#define _SIP_CENTRAL_

#ifndef _SV_TABCTRL_HXX //autogen wg. TabControl
#include <vcl/tabctrl.hxx>
#endif

#ifndef _SV_TABDLG_HXX //autogen wg. TabDialog
#include <vcl/tabdlg.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen wg. RadioButton
#include <vcl/button.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen wg. TimeField
#include <vcl/field.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen wg. FixedText
#include <vcl/fixed.hxx>
#endif

#ifndef _URLOBJ_HXX //autogen wg. INetURLObject
#include <tools/urlobj.hxx>
#endif

#include "options.hxx"


class SipCentralDlg : public ModalDialog
{
private:
	FixedText			m_aFtFile;
	Edit				m_aEdtFile;
	PushButton			m_aBtnBrowse;
	OKButton			m_aBtnOk;	
	CancelButton		m_aBtnCancel;	
	PushButton			m_aBtnMore;

	FixedLine			m_aFlPageChg;
	RadioButton			m_aRbtChgDoc;
	RadioButton			m_aRbtChgManual;
	RadioButton			m_aRbtChgSemi;
	RadioButton			m_aRbtChgAuto;
	FixedText			m_aFtSlide;
	TimeField			m_aTmfSlide;	  
	CheckBox			m_aCbxEndless;
	FixedText			m_aFtPause;
	TimeField			m_aTmfPause;	  
	CheckBox			m_aCbxAutologo;

	FixedLine			m_aFlOptions;
	CheckBox			m_aCbxWindowed;
	CheckBox			m_aCbxPointer;
	CheckBox			m_aCbxPen;
	CheckBox			m_aCbxAnimAllowed;
	CheckBox			m_aCbxChangePage;
	CheckBox			m_aCbxAlwaysOnTop;

	PushButton			m_aBtnAbout;

	sal_Bool			m_bMoreShown;
	
	Options				m_aOptions;

	DECL_LINK( BrowseHdl, PushButton * );
	DECL_LINK( FinishHdl, OKButton * );
	DECL_LINK( MoreHdl, PushButton * );
	DECL_LINK( AboutHdl, PushButton * );
	DECL_LINK( PresChgHdl, RadioButton* );

	void				SetMoreButtonText();

public:
			SipCentralDlg(  Window* pParent, const String& aDefaultURL );
			virtual				~SipCentralDlg();

			const Options&		GetOptions() const { return m_aOptions; }
			void				SetPathURL(const String&);
			String				GetPathURL() const;
};

#endif // _SIP_CENTRAL_

