/*************************************************************************
 *
 *  $RCSfile: ddedummy.cxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: mh $ $Date: 2000/09/29 12:38:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVDDE_HXX
#include <svdde.hxx>
#endif

long DdeConnection::GetError()
{
  return 0L;
}

DdeData& DdeData::operator = ( const DdeData& a)
{
  return (DdeData&)a;
}

DdeData::operator long() const
{
  return 0;
}

DdeData::operator const  char*() const
{
  return "";
}

DdeConnection::DdeConnection( const String&, const String& )
{
}

DdeConnection::~DdeConnection( void )
{
}

DdeTransaction::DdeTransaction( DdeConnection& rConnection, const String&, long ) :
     rDde( rConnection )
{
}

DdeTransaction::DdeTransaction( const DdeTransaction& rTransaction ) :
     rDde( rTransaction.rDde )
{
}

void DdeTransaction::Execute(void)
{
}

void DdeTransaction::Done( void )
{
}

void DdeTransaction::Data( const DdeData* )
{
}

DdeTransaction::~DdeTransaction(void)
{
}

DdeRequest::DdeRequest(DdeConnection& rConnection, const String& rString, long lLong ) :
     DdeTransaction( rConnection, rString, lLong )
{
}

DdeExecute::DdeExecute( DdeConnection& rConnection, const String& rString, long lLong ) :
     DdeTransaction( rConnection, rString, lLong )
{
}

DdeData::DdeData( const String& )
{
}

DdeData::DdeData( void )
{
}

DdeData::DdeData(const char *, long, unsigned long)
{
}

DdePoke::DdePoke( DdeConnection& rConnection, const String& rString, const DdeData&, long lLong ) :
     DdeTransaction( rConnection, rString, lLong )
{
}

DdeData::~DdeData( void )
{
}

struct DdeImp
{
    long    nStatus;
};

// --- DdeConnection::IsConnected() --------------------------------

BOOL DdeConnection::IsConnected()
{
 	return TRUE;
}

// --- DdeConnection::GetServiceName() -----------------------------

const String& DdeConnection::GetServiceName()
{
    return (const String&)*pService;
}

// --- DdeConnection::GetTopicName() -------------------------------

const String& DdeConnection::GetTopicName()
{
    return (const String&)*pTopic;
}

// --- DdeConnection::GetConvId() ----------------------------------

long DdeConnection::GetConvId()
{
    return (long)0;
}

// --- DdeTransaction::GetName() -----------------------------------

// --- DdeTransaction::GetName() -----------------------------------

const String& DdeTransaction::GetName() const
{
    return (const String&)*pName;
}

// --- DdeLink::DdeLink() ------------------------------------------

DdeLink::DdeLink( DdeConnection& d, const String& aItemName, long n ) :
            DdeTransaction (d, aItemName, n)
{
}

// --- DdeLink::~DdeLink() -----------------------------------------

DdeLink::~DdeLink()
{
    nTime = 0;
}

// --- DdeLink::Notify() -----------------------------------------

void __EXPORT DdeLink::Notify()
{
    aNotify.Call( NULL );
}

// --- DdeWarmLink::DdeWarmLink() ----------------------------------

DdeWarmLink::DdeWarmLink( DdeConnection& d, const String& i, long n ) :
                DdeLink( d, i, n )
{
    nType = 0;
}

// --- DdeHotLink::DdeHotLink() ------------------------------------

DdeHotLink::DdeHotLink( DdeConnection& d, const String& i, long n ) :
                DdeLink( d, i, n )
{
    nType = 0;
}

// --- DdePoke::DdePoke() ------------------------------------------

DdePoke::DdePoke( DdeConnection& d, const String& i, const char* p,
                  long l, ULONG f, long n ) :
            DdeTransaction( d, i, n )
{
    nType = 0;
}

// --- DdePoke::DdePoke() ------------------------------------------

DdePoke::DdePoke( DdeConnection& d, const String& i, const String& rData,
                  long n ) :
            DdeTransaction( d, i, n )
{
    nType = 0;
}

// --- DdeGetPutItem::DdeGetPutItem() -----------------------------

DdeGetPutItem::DdeGetPutItem( const char* p )
	: DdeItem( p )
{
	nType = 0;
}

// --- DdeGetPutItem::DdeGetPutItem() -----------------------------

DdeGetPutItem::DdeGetPutItem( const String& rStr )
	: DdeItem( rStr )
{
	nType = 0;
}

// --- DdeGetPutItem::DdeGetPutItem() -----------------------------

DdeGetPutItem::DdeGetPutItem( const DdeItem& rItem )
	: DdeItem( rItem )
{
	nType = 0;
}

// --- DdeGetPutItem::AdviseLoop() -----------------------------

void DdeGetPutItem::AdviseLoop( BOOL )
{
}

// --- DdeTopic::InsertItem() -----------------------------------------

void DdeTopic::InsertItem( DdeItem* pNew )
{
}

// --- DdeTopic::NotifyClient() ------------------------------------

void DdeTopic::NotifyClient( const String& rItem )
{
}

// --- DdeTopic::~DdeTopic() -----------------------------------------

DdeTopic::~DdeTopic()
{
}

// --- DdeItem::~DdeItem() -----------------------------------------

DdeItem::~DdeItem()
{
}

// --- DdeTopic::RemoveItem() --------------------------------------

void DdeTopic::RemoveItem( const DdeItem& r )
{
}

// --- DdeService::~DdeService() -----------------------------------

DdeService::~DdeService()
{
	nStatus		= 0;
}

// --- DdeService::GetServices() -----------------------------------

DdeServices& DdeService::GetServices()
{
	DdeServices a;
	
	return a;
}

// --- DdeData::GetFormat() ----------------------------------------

ULONG DdeData::GetFormat() const
{
    return 0L;
}

// --- DdeData::SetFormat() ----------------------------------------

void  DdeData::SetFormat( ULONG )
{
}

// --- DdeItem::DdeItem() ------------------------------------------

DdeItem::DdeItem( const char* p )
{
}

// --- DdeItem::DdeItem() ------------------------------------------

DdeItem::DdeItem( const String& r)
{
}

// --- DdeItem::DdeItem() ------------------------------------------

DdeItem::DdeItem( const DdeItem& r)
{
}

BOOL	DdeGetPutItem::Put( const DdeData* )
{
	return TRUE;
}

DdeData* DdeGetPutItem::Get( ULONG )
{
	DdeData* a=0L;
	return a;
}

// --- DdeItem::NotifyClient() ------------------------------------------

void DdeItem::NotifyClient()
{
}

void DdeService::AddFormat(unsigned long)
{	;
}

DdeService::DdeService(const String &)
{
	pName		= NULL;
	pSysTopic	= NULL;
	pConv		= NULL;
	nStatus		= 0;
}

DdeTopic::DdeTopic(const String &)
{
}

void DdeService::RemoveTopic(const DdeTopic &)
{	;
}

void DdeService::AddTopic(const DdeTopic &)
{	;
}

String DdeService::GetHelp()
{	
	String a ="";
	 return a;
}

BOOL DdeService::IsBusy()
{	return FALSE;
}

BOOL DdeService::MakeTopic(const String &)
{	return FALSE;
}

BOOL DdeTopic::StartAdviseLoop()
{	return FALSE;
}

BOOL DdeTopic::StopAdviseLoop()
{	return FALSE;
}

DdeItem*  DdeTopic::AddItem(const DdeItem &)
{
	 return (DdeItem *)0;
}

void DdeTopic::Disconnect(long)
{	;
}

void DdeTopic::Connect(long)
{	;
}

BOOL DdeTopic::MakeItem( const String& rItem )
{	return FALSE;
}

BOOL DdeTopic::Execute(const String *)
{	return FALSE;
}

BOOL DdeTopic::Put( const DdeData* )
{	return FALSE;
}

DdeData* DdeTopic::Get(unsigned long)
{	return (DdeData*)0L;
}

String DdeService::Topics()
{	
	String a ="";
	 return a;
}

String DdeService::Formats()
{	
	String a ="";
	 return a;
}

String DdeService::SysItems()
{	
	String a ="";
	 return a;
}

String DdeService::Status()
{	
	String a ="";
	 return a;
}

String DdeService::SysTopicGet( const String& rein)
{	
	String a ="";
	 return a;
}

BOOL DdeService::SysTopicExecute( const String* rein)
{	
	 return FALSE;
}


// --- DdeService::GetName() ---------------------------------------

const String& DdeService::GetName() const
{
    return (const String&)*pName;
}

// --- DdeTopic::GetName() -----------------------------------------

const String& DdeTopic::GetName() const
{
    return (const String&)*pName;
}
