/*************************************************************************
 *
 *  $RCSfile: iodlg.cxx,v $
 *
 *  $Revision: 1.13 $
 *
 *  last change: $Author: dv $ $Date: 2001/07/26 07:21:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes --------------------------------------------------------------

#ifndef _STREAM_HXX
#include <tools/stream.hxx>
#endif
#ifndef _URLOBJ_HXX //autogen
#include <tools/urlobj.hxx>
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_TIMER_HXX
#include <vcl/timer.hxx>
#endif

#ifndef _UNOTOOLS_UCBHELPER_HXX
#include <unotools/ucbhelper.hxx>
#endif

#include "ehdl.hxx"
#include "urihelper.hxx"
#include "pathoptions.hxx"
#include "viewoptions.hxx"
#include "fileview.hxx"

#ifndef _SVTOOLS_INETOPTIONS_HXX_
#include <inetoptions.hxx>
#endif
#ifndef _SFXECODE_HXX
#include "sfxecode.hxx"
#endif
#ifndef _SVARRAY_HXX
#include "svarray.hxx"
#endif
#ifndef _SVTABBX_HXX
#include "svtabbx.hxx"
#endif

#define _SVSTDARR_USHORTS
#define _SVSTDARR_STRINGSDTOR
#include "svstdarr.hxx"

#include <toolkit/helper/vclunohelper.hxx>
#include <unotools/localfilehelper.hxx>

#include "iodlg.hxx"
#include "svtools.hrc"
#include "iodlg.hrc"

#include "iodlgimp.hxx"
#include "inettbc.hxx"
#include "svtuno.hxx"
#include "svtdata.hxx"

#ifndef  _RTL_USTRING_HXX
#include <rtl/ustring.hxx>
#endif

#ifndef  _COM_SUN_STAR_UI_DIALOGS_COMMONFILEPICKERELEMENTIDS_HPP_
#include <com/sun/star/ui/dialogs/CommonFilePickerElementIds.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_EXTENDEDFILEPICKERELEMENTIDS_HPP_
#include <com/sun/star/ui/dialogs/ExtendedFilePickerElementIds.hpp>
#endif
#ifndef  _COM_SUN_STAR_UI_DIALOGS_LISTBOXCONTROLACTIONS_HPP_
#include <com/sun/star/ui/dialogs/ListboxControlActions.hpp>
#endif

#ifndef  _COM_SUN_STAR_UTIL_URL_HPP_
#include <com/sun/star/util/URL.hpp>
#endif
#ifndef  _COM_SUN_STAR_UTIL_XURLTRANSFORMER_HPP_
#include <com/sun/star/util/XURLTransformer.hpp>
#endif

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <comphelper/processfactory.hxx>
#endif

using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::frame;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::ui::dialogs;
using namespace ::com::sun::star::util;
using namespace ::rtl;
using namespace ::utl;

#define IODLG_CONFIGNAME		String(DEFINE_CONST_UNICODE("FileDialog"))
#define IMPGRF_CONFIGNAME		String(DEFINE_CONST_UNICODE("ImportGraphicDialog"))

#define GET_DECODED_NAME(aObj) \
	aObj.getName( INetURLObject::LAST_SEGMENT, true, INetURLObject::DECODE_WITH_CHARSET )

// Zeit die beim Traveln in der Filterbox gewartet wird,
// bis in der Browsebox gefiltert wird ( in ms ).
#define TRAVELFILTER_TIMEOUT	750
// delay time to reset the cursor position after open a folder with a doubleclick
#define RESETCURSOR_TIMEOUT		100

// functions -------------------------------------------------------------

String GetCurrentFilter_Impl( SvtExpFileDlg_Impl* pImpl )
{
	DBG_ASSERT( pImpl, "invalid impl pointer" );
	SvtFileDialogFilter_Impl* pFilter = pImpl->_pUserFilter;

	if ( !pFilter )
		pFilter = pImpl->_pCurFilter;

	// Filtern.
	if ( !pFilter )
		return String();

	return pFilter->GetType();
}

//-----------------------------------------------------------------------------
String GetFsysExtension_Impl( const String& rFile )
{
	const sal_Unicode* p0 = rFile.GetBuffer();
	const sal_Unicode* p1 = p0 + rFile.Len() - 1;
	while ( p1 >= p0 && *p1 != sal_Unicode( '.' ) )
		p1--;
	if ( p1 >= p0 )
		return String( rFile.Copy( p1 - p0 + 1 ) );
	return String();
}

//-----------------------------------------------------------------------------
void SetFsysExtension_Impl( String& rFile, const String& rExtension )
{
	const sal_Unicode* p0 = rFile.GetBuffer();
	const sal_Unicode* p1 = p0 + rFile.Len() - 1;
	while ( p1 >= p0 && *p1 != sal_Unicode( '.' ) )
		p1--;
	if ( p1 >= p0 )
		// remove old extension
		rFile.Erase( p1 - p0 + 1 - ( rExtension.Len() > 0 ? 0 : 1 ) );
	else if ( rExtension.Len() )
		// no old extension
		rFile += sal_Unicode( '.' );
	rFile += rExtension;
}

//-----------------------------------------------------------------------------
sal_Bool IsFileURL( const String& rURL )
{
	return ( INetURLObject::CompareProtocolScheme( rURL ) == INET_PROT_FILE );
}

//*****************************************************************************
// SvtFileDialog_Impl
//*****************************************************************************

SvtFileDialog_Impl* SvtFileDialog_Impl::_pActiveDlg = NULL;

//*****************************************************************************

SvtFileDialog_Impl::SvtFileDialog_Impl
(
	ULONG nBits,
	ULONG nExtraBits
) :
	VclFileDialog( NULL, SvtResId( DLG_SVT_EXPLORERFILE ) ),

	_pFileView( NULL ),
	_pCbReadOnly( NULL ),
	_pCbLinkBox( NULL),
    _pCbPreviewBox( NULL ),
    _pCbSelection( NULL ),
    _pPbPlay( NULL ),
    _pPrevWin( NULL ),
    _pPrevBmp( NULL ),
	_pImp( new SvtExpFileDlg_Impl( nBits ) ),
	_pFileNotifier( NULL ),
    _nExtraBits( nExtraBits ),
    _bIsInExecute( FALSE )
{
	Init_Impl( nBits, nExtraBits );
}

//*****************************************************************************

SvtFileDialog_Impl::SvtFileDialog_Impl ( ULONG nBits )
    : VclFileDialog( NULL, SvtResId( DLG_SVT_EXPLORERFILE ) ),
	_pFileView( NULL ),
	_pCbReadOnly( NULL ),
	_pCbLinkBox( NULL),
    _pCbPreviewBox( NULL ),
    _pCbSelection( NULL ),
    _pPbPlay( NULL ),
    _pPrevWin( NULL ),
    _pPrevBmp( NULL ),
	_pImp( new SvtExpFileDlg_Impl( nBits ) ),
	_pFileNotifier( NULL ),
    _nExtraBits( 0L ),
    _bIsInExecute( FALSE )
{
	Init_Impl( nBits, 0L );
}

//*****************************************************************************

SvtFileDialog_Impl::~SvtFileDialog_Impl()
{
	if ( _pImp->_aIniKey.Len() )
	{
		SvtViewOptions aDlgOpt( E_DIALOG, _pImp->_aIniKey );
        Size aSize = _pImp->_aDlgSize;

	    if ( _pPrevWin &&
             _pPrevWin->GetPosPixel().X() > _pFileView->GetPosPixel().X() )
	    {
    	    long nWinDeltaW = _pPrevWin->GetOutputSizePixel().Width() + _pImp->_a6Size.Width();
            aSize.Width() -= nWinDeltaW;
	    }

        aDlgOpt.SetSize( aSize.Width(), aSize.Height() );
	}

	_pFileView->SetSelectHdl( Link() );

	delete _pImp;
	delete _pFileView;

	delete _pCbReadOnly;
	delete _pCbLinkBox;
    delete _pCbPreviewBox;
    delete _pCbSelection;
    delete _pPbPlay;
    delete _pPrevWin;
    delete _pPrevBmp;
}

//*****************************************************************************

void SvtFileDialog_Impl::Init_Impl
(
	ULONG nStyle, ULONG nExtraStyle
)
{
	_pImp->_nStyle = nStyle;
	_pImp->_a6Size = LogicToPixel( Size( 6, 6 ), MAP_APPFONT );
	_pImp->_eMode = ( nStyle & WB_SAVEAS ) ? FILEDLG_MODE_SAVE : FILEDLG_MODE_OPEN;
	_pImp->_eDlgType = FILEDLG_TYPE_FILEDLG;

	if ( ( nStyle & SFXWB_PATHDIALOG ) == SFXWB_PATHDIALOG )
		_pImp->_eDlgType = FILEDLG_TYPE_PATHDLG;

	// Set the directory for the "back to the default dir" button
	INetURLObject aStdDirObj( SvtPathOptions().GetWorkPath() );
	SetStandardDir( aStdDirObj.GetMainURL( INetURLObject::NO_DECODE ) );

	// Reichweite bestimmen.
	if ( !( nStyle & SFXWB_NOREMOTE ) )
	{
		_pImp->_nState |= FILEDLG_STATE_REMOTE;
	}

	// Kontrollelement erzeugen, wobei die Reihenfolge die Tab-Steuerung
	// bestimmt.
	_pImp->_pFtFileName = new FixedText( this, SvtResId( FT_EXPLORERFILE_FILENAME ) );

    SvtURLBox* pURLBox = (SvtURLBox*)( _pImp->_pEdFileName = new SvtURLBox( this ) );
    Edit aDummy( this, SvtResId( ED_EXPLORERFILE_FILENAME ) );
    _pImp->_pEdFileName->SetPosSizePixel( aDummy.GetPosPixel(), aDummy.GetSizePixel() );
    _pImp->_pEdFileName->Show();
    pURLBox->SetSelectHdl( LINK( this, SvtFileDialog_Impl, EntrySelectHdl_Impl ) );
    pURLBox->SetOpenHdl( STATIC_LINK( this, SvtFileDialog_Impl, OpenHdl_Impl ) );
    // bei SaveAs oder im PfadDialog nur Verzeichnisse automatisch erg"anzen
    BOOL bOnlyDir = ( _pImp->_eMode != FILEDLG_MODE_OPEN ||
                        _pImp->_eDlgType == FILEDLG_TYPE_PATHDLG );
    pURLBox->SetOnlyDirectories( bOnlyDir );
    _pImp->_pEdFileName->SetHelpId( HID_FILEDLG_AUTOCOMPLETEBOX );

	_pImp->_pFtFileVersion = new FixedText(	this, SvtResId( FT_EXPLORERFILE_FILEVERSION ) );
    _pImp->_pFtFileVersion->SetText( SvtResId( STR_SVT_FILEPICKER_VERSION ) );
	_pImp->_pLbFileVersion = new ListBox( this, SvtResId( LB_EXPLORERFILE_FILEVERSION ) );

    _pImp->_pFtFileType = new FixedText( this, SvtResId( FT_EXPLORERFILE_FILETYPE ) );
	_pImp->_pLbFilter = new ListBox( this, SvtResId( LB_EXPLORERFILE_FILETYPE ) );

	// move the filter listbox to the space occupied by the version listbox
    // if that box isn't needed
    if ( !( nExtraStyle & SFX_EXTRA_SHOWVERSIONS ) &&
         !( nExtraStyle & SFX_EXTRA_TEMPLATES ) &&
         !( nExtraStyle & SFX_EXTRA_IMAGE_TEMPLATE ) )
	{
		_pImp->_pFtFileType->SetPosPixel( _pImp->_pFtFileVersion->GetPosPixel() );
		_pImp->_pLbFilter->SetPosPixel( _pImp->_pLbFileVersion->GetPosPixel() );
	}

	_pImp->_pFtCurrentPath = new FixedText( this, SvtResId( FT_EXPLORERFILE_CURRENTPATH ) );
    WinBits nTmpStyle = _pImp->_pFtCurrentPath->GetStyle();
    nTmpStyle |= WB_PATHELLIPSIS;
    _pImp->_pFtCurrentPath->SetStyle( nTmpStyle );

    _pImp->_pBtnFileOpen = new PushButton( this, SvtResId( BTN_EXPLORERFILE_OPEN ) );
	_pImp->_pBtnCancel = new CancelButton( this, SvtResId( BTN_EXPLORERFILE_CANCEL ) );
	_pImp->_pBtnHelp = new HelpButton( this, SvtResId( BTN_EXPLORERFILE_HELP ) );
	_pImp->_pBtnLocal = new PushButton( this, SvtResId( BTN_EXPLORERFILE_LOCAL ) );
	_pImp->_pBtnLocal->SetImage( SvtResId( IMG_FILEDLG_BTN_LOCAL ) );

	if ( IsFileURL( GetStandardDir() ) )
		_pImp->_pBtnLocal->Hide();
	else
	{
		_pImp->_pBtnLocal->SetClickHdl( LINK( this, SvtFileDialog_Impl, LocalFileSystemHdl_Impl ) );
	}

	_pImp->_pBtnUp = new SvtUpButton_Impl( this, SvtResId( BTN_EXPLORERFILE_UP ) );
	_pImp->_pBtnNewFolder = new ImageButton( this, SvtResId( BTN_EXPLORERFILE_NEWFOLDER ) );
	_pImp->_pBtnNewFolder->SetStyle( _pImp->_pBtnNewFolder->GetStyle() | WB_NOPOINTERFOCUS );
	_pImp->_pBtnStandard = new SvtTravelButton_Impl( this, SvtResId( BTN_EXPLORERFILE_STANDARD ) );

	if ( ( nStyle & SFXWB_MULTISELECTION ) == SFXWB_MULTISELECTION )
		_pImp->_bMultiSelection = TRUE;

	_pFileView = new SvtFileView( this, SvtResId( CTL_EXPLORERFILE_FILELIST ),
									   FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType,
									   _pImp->_bMultiSelection );
	_pFileView->EnableAutoResize();

	USHORT nHelpId = HID_FILEDLG_STANDARD;
	_pFileView->SetHelpId( nHelpId );
	_pFileView->SetStyle( _pFileView->GetStyle() | WB_TABSTOP );

	// Positionen und Groessen der Knoepfe bestimmen.
	Image aNewFolderImg( SvtResId( IMG_FILEDLG_CREATEFOLDER ) );
	_pImp->_pBtnNewFolder->SetImage( aNewFolderImg );
	Size aSize( aNewFolderImg.GetSizePixel() );
	aSize.Width() += FILEDIALOG_DEF_IMAGEBORDER;
	aSize.Height() += FILEDIALOG_DEF_IMAGEBORDER;
	_pImp->_pBtnNewFolder->SetSizePixel( aSize );
	_pImp->_pBtnLocal->SetSizePixel( aSize );
	_pImp->_pBtnUp->SetSizePixel( aSize );
	_pImp->_pBtnStandard->SetSizePixel( aSize );

	Point aPos( _pImp->_pBtnLocal->GetPosPixel() );
	Size aDlgSize = GetOutputSizePixel();
	aPos.X() = aDlgSize.Width();
	long n6AppFontInPixel =
			LogicToPixel( Size( 6, 0 ), MAP_APPFONT ).Width();
	long n3AppFontInPixel =
			LogicToPixel( Size( 3, 0 ), MAP_APPFONT ).Width();
	aPos.X() -= n6AppFontInPixel;
	USHORT nBtnCount = 4;
	long nDelta = nBtnCount;
	nDelta *= aSize.Width();
	aPos.X() -= nDelta;
	aPos.X() -= n3AppFontInPixel;
	_pImp->_pBtnLocal->SetPosPixel( aPos );
	nDelta = aPos.X();
	nDelta -= ( n6AppFontInPixel * 2 );
	Size aCurPathSize( _pImp->_pFtCurrentPath->GetOutputSizePixel() );
	aCurPathSize.Width() = nDelta;
	_pImp->_pFtCurrentPath->SetOutputSizePixel( aCurPathSize );
	aPos.X() += aSize.Width();
	aPos.X() += n3AppFontInPixel;
	_pImp->_pBtnUp->SetPosPixel( aPos );
	aPos.X() += aSize.Width();
	aPos.X() += n3AppFontInPixel;
	_pImp->_pBtnNewFolder->SetPosPixel( aPos );
	aPos.X() += aSize.Width();
	aPos.X() += ( n3AppFontInPixel / 2 );
	_pImp->_pBtnStandard->SetPosPixel( aPos );
	nDelta = aSize.Height();
	nDelta -= aCurPathSize.Height();
	nDelta /= 2;
	Point aCurPathPos = _pImp->_pFtCurrentPath->GetPosPixel();
	aCurPathPos.Y() += nDelta;
	_pImp->_pFtCurrentPath->SetPosPixel( aCurPathPos );

	// Zahl der Pixel bestimmen, um die die anderen Elemente in der Position
	// Angepasst werden muessen.
	aPos.Y() += aSize.Height();
	aPos.Y() += LogicToPixel( Size( 0, 6 ), MAP_APPFONT ).Height();
	long nYOffset = aPos.Y();
	aPos = _pFileView->GetPosPixel();
	nYOffset -= aPos.Y();

	// Positionen der uebrigen Elemente anpassen.
	aPos.Y() += nYOffset;
	_pFileView->SetPosPixel( aPos );
	aPos = _pImp->_pFtFileName->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pFtFileName->SetPosPixel( aPos );
	aPos = _pImp->_pEdFileName->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pEdFileName->SetPosPixel( aPos );
	aPos = _pImp->_pFtFileVersion->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pFtFileVersion->SetPosPixel( aPos );
	aPos = _pImp->_pLbFileVersion->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pLbFileVersion->SetPosPixel( aPos );
	aPos = _pImp->_pFtFileType->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pFtFileType->SetPosPixel( aPos );
	aPos = _pImp->_pLbFilter->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pLbFilter->SetPosPixel( aPos );
	aPos = _pImp->_pBtnFileOpen->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pBtnFileOpen->SetPosPixel( aPos );
	aPos = _pImp->_pBtnCancel->GetPosPixel();
	aPos.Y() += nYOffset;
	_pImp->_pBtnCancel->SetPosPixel( aPos );
	aPos = _pImp->_pBtnHelp->GetPosPixel();
	aPos.Y() += nYOffset + 3; // a little more spacing between Cancel- and HelpButton
	_pImp->_pBtnHelp->SetPosPixel( aPos );

	// Groesse des Dialoges anpassen.
	aSize = GetSizePixel();
	aSize.Height() += nYOffset;
	SetSizePixel( aSize );

	if ( nStyle & SFXWB_READONLY )
	{
		_pCbReadOnly = new CheckBox( this, SvtResId( CB_EXPLORERFILE_READONLY ) );
        _pCbReadOnly->SetText( SvtResId( STR_SVT_FILEPICKER_READONLY ) );
		AddControl( _pCbReadOnly );
		ReleaseOwnerShip( _pCbReadOnly );
		_pCbReadOnly->SetClickHdl( LINK( this, SvtFileDialog_Impl, ClickHdl_Impl ) );
	}

    if ( nStyle & SFXWB_PASSWORD )
	{
		_pImp->_pCbPassword = new CheckBox( this, SvtResId( CB_EXPLORERFILE_PASSWORD ) );
	    _pImp->_pCbPassword->SetText( SvtResId( STR_SVT_FILEPICKER_PASSWORD ) );
		AddControl( _pImp->_pCbPassword );
		ReleaseOwnerShip( _pImp->_pCbPassword );
		_pImp->_pCbPassword->SetClickHdl( LINK( this, SvtFileDialog_Impl, ClickHdl_Impl ) );
	}

    // set the ini file for extracting the size
   	_pImp->_aIniKey = IODLG_CONFIGNAME;

    AddControls_Impl( nExtraStyle );

	// Beschriftungen dem Modus anpassen.
	USHORT nResId = STR_EXPLORERFILE_OPEN;
	USHORT nButtonResId = 0;

	if ( nStyle & WB_SAVEAS )
	{
		nResId = STR_EXPLORERFILE_SAVE;
		nButtonResId = STR_EXPLORERFILE_BUTTONSAVE;
	}

	if ( ( nStyle & SFXWB_PATHDIALOG ) == SFXWB_PATHDIALOG )
	{
		_pImp->_pFtFileName->SetText( SvtResId( STR_PATHNAME ) );
		nResId = STR_PATHSELECT;
		nButtonResId = STR_BUTTONSELECT;
	}

	SetText( SvtResId( nResId ) );

	if ( nButtonResId )
		_pImp->_pBtnFileOpen->SetText( SvtResId( nButtonResId ) );

	if ( FILEDLG_TYPE_FILEDLG != _pImp->_eDlgType )
	{
		_pImp->_pFtFileType->Hide();
		_pImp->_pLbFilter->Hide();
	}
    if ( !( nExtraStyle & SFX_EXTRA_SHOWVERSIONS ) &&
         !( nExtraStyle & SFX_EXTRA_TEMPLATES ) &&
         !( nExtraStyle & SFX_EXTRA_IMAGE_TEMPLATE ) )
	{
		_pImp->_pFtFileVersion->Hide();
		_pImp->_pLbFileVersion->Hide();
	}

	// Einstellungen der Steuerelemente vornehmen.
	_pImp->_pBtnNewFolder->SetClickHdl( STATIC_LINK( this, SvtFileDialog_Impl, NewFolderHdl_Impl ) );
	_pImp->_pBtnFileOpen->SetClickHdl( STATIC_LINK( this, SvtFileDialog_Impl, OpenHdl_Impl ) );
	_pImp->_pLbFilter->SetSelectHdl( STATIC_LINK( this, SvtFileDialog_Impl, FilterSelectHdl_Impl ) );
	_pImp->_pEdFileName->SetGetFocusHdl( STATIC_LINK( this, SvtFileDialog_Impl, FileNameGetFocusHdl_Impl ) );
	_pImp->_pEdFileName->SetModifyHdl( STATIC_LINK( this, SvtFileDialog_Impl, FileNameModifiedHdl_Impl ) );
	_pFileView->SetSelectHdl( LINK( this, SvtFileDialog_Impl, SelectHdl_Impl ) );
	_pFileView->SetDoubleClickHdl( LINK( this, SvtFileDialog_Impl, DblClickHdl_Impl ) );
	_pFileView->SetOpenDoneHdl( LINK( this, SvtFileDialog_Impl, OpenDoneHdl_Impl ) );

	// Resourcen freigeben.
	FreeResource();

	// Timer fuer Filterbox Travel setzen
	_pImp->_aFilterTimer.SetTimeout( TRAVELFILTER_TIMEOUT );
	_pImp->_aFilterTimer.SetTimeoutHdl( STATIC_LINK( this, SvtFileDialog_Impl, FilterSelectHdl_Impl ) );

	_pImp->_aResetCursorTimer.SetTimeout( RESETCURSOR_TIMEOUT );
	_pImp->_aResetCursorTimer.SetTimeoutHdl( LINK( this, SvtFileDialog_Impl, ResetCursorHdl_Impl ) );

	// Anzahl der bisher erzeugten Child Windows ermitteln
	// um spaeter in Execute die Anzahl der dynamisch erzeugten
	// Child Windows zu ermitteln. #49066#
	_pImp->_nUserControls = GetChildCount();
}

//*****************************************************************************

IMPL_STATIC_LINK( SvtFileDialog_Impl, NewFolderHdl_Impl, PushButton*, pBtn )
{
	INetURLObject aObj( pThis->_pFileView->GetViewURL() );
    svtools::QueryFolderNameDialog aDlg( aObj.getName(), String( SvtResId( STR_SVT_NEW_FOLDER ) ) );

	if ( aDlg.Execute() == RET_OK )
		pThis->_pFileView->CreateNewFolder( aDlg.GetName() );

	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SvtFileDialog_Impl, ViewHdl_Impl, ImageButton*, pBtn )
{
	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SvtFileDialog_Impl, OpenHdl_Impl, void*, pVoid )
{
	if ( pThis->_pImp->_bMultiSelection && pThis->_pFileView->GetSelectionCount() > 1 )
	{
		// bei Multiselektion spezielles Open
		pThis->OpenMultiSelection_Impl();
		return 0;
	}

	String aFileName;
    String aOldPath( pThis->_pFileView->GetViewURL() );
	if ( pThis->_pImp->_bDoubleClick || pThis->_pFileView->HasChildPathFocus() )
		// Selection done by doubleclicking in the view, get filename from the view
		aFileName = pThis->_pFileView->GetCurrentURL();

	if ( !aFileName.Len() )
	{
		if ( pThis->_pImp->_eMode == FILEDLG_MODE_OPEN && pThis->_pImp->_pEdFileName->IsTravelSelect() )
			// OpenHdl called from URLBox; travelling through the list of URLs should not cause an opening
			return 0;		            // MBA->PB: seems to be called never ?!

		// get the URL from from the edit field ( if not empty )
		if ( pThis->_pImp->_pEdFileName->GetText().Len() )
		{
			String aText = pThis->_pImp->_pEdFileName->GetText();
			// we reach the root?
			if ( !INetURLObject( aOldPath ).getSegmentCount() )
			{
				if ( ( aText.Len() == 2 && aText.EqualsAscii( ".." ) ) ||
					 ( aText.Len() == 3 && ( aText.EqualsAscii( "..\\" ) || aText.EqualsAscii( "../" ) ) ) )
					// don't go higher than the root
					return 0;
			}
			// get url from autocomplete edit
        	aFileName = pThis->_pImp->_pEdFileName->GetURL();
		}
		else if ( pVoid == pThis->_pImp->_pBtnFileOpen )
			// OpenHdl was called for the "Open" Button; if edit field is empty, use selected element in the view
			aFileName = pThis->_pFileView->GetCurrentURL();
	}

	// MBA->PB: ?!
	if ( !aFileName.Len() && pVoid == pThis->_pImp->_pEdFileName && pThis->_pImp->_pUserFilter )
	{
		DELETEZ( pThis->_pImp->_pUserFilter );
		return 0;
	}

	USHORT nLen = aFileName.Len();
	if ( !nLen )
	{
		// if the dialog was opened to select a folder, the last selected folder should be selected
		if( pThis->_pImp->_eDlgType == FILEDLG_TYPE_PATHDLG )
		{
			aFileName =	pThis->_pImp->_pFtCurrentPath->GetText();
			nLen = aFileName.Len();
		}
		else
			// no file selected !
			return 0;
	}

	// mark input as selected
	pThis->_pImp->_pEdFileName->SetSelection( Selection( 0, nLen ) );

	// if a path with wildcards is given, divide the string into path and wildcards
	String aFilter;
	String aEmpty;
	if ( !pThis->IsolateFilterFromPath_Impl( aFileName, aFilter ) )
		return 0;

	// if a filter was retrieved, there were wildcards !
	BOOL bWildCard = ( aFilter.Len() != 0 );
	BOOL bFilterChanged = bWildCard;
	BOOL bWildCardOnly = bWildCard && ( pThis->_pImp->_pEdFileName->GetText().Len() == 0 );
	if ( bFilterChanged )
	{
		// search for a corresponding filter
		BOOL bFilterFound = pThis->FindFilter_Impl( aFilter, FALSE, bFilterChanged );
		if ( !bFilterFound )
			bFilterFound = pThis->FindFilter_Impl( aFilter, TRUE, bFilterChanged );

		if ( !bFilterFound )
		{
			// no filter found : use it as user defined filter
			delete pThis->_pImp->_pUserFilter;
			pThis->_pImp->_pUserFilter = new SvtFileDialogFilter_Impl( aFilter, aFilter, aEmpty, 0 );

			// save the extension
			if ( aFilter.EqualsAscii(FILEDIALOG_FILTER_ALL) )
				pThis->_aDefExt.Erase();
			else
				pThis->_aDefExt = aFilter.Copy( 2 );
		}

		// cut off all text before wildcard in edit and select wildcard
		pThis->_pImp->_pEdFileName->SetText( aFilter );
		pThis->_pImp->_pEdFileName->SetSelection( Selection( 0, aFilter.Len() ) );
	}

	INetURLObject aFileObject( aFileName );

	// Protokoll pruefen.
	INetProtocol eProt = aFileObject.GetProtocol();
	if ( !bWildCardOnly &&
		 ( eProt != INET_PROT_FILE && !( pThis->_pImp->_nState & FILEDLG_STATE_REMOTE ) ) )
	{
		// MBA->PB : ?!
		ErrorHandler::HandleError( ERRCODE_SFX_INVALIDSYNTAX );
		return 0;
	}

	// Pr"ufen, ob es sich um einen Ordner handelt.
    BOOL bFolder = FALSE;
    
    if ( aFileName.Len() )
        bFolder = UCBContentHelper::IsFolder( aFileName );

#if 0   // This should be handled by the ftp content provider itself.
        // The ftp content provider should display an error box, too if
        // there is no support for access via proxy

    // Pr"ufen, ob der Ordner als Textdarstellung angezeigt werden soll.
    if ( bFolder && INET_PROT_FTP == eProt )
    {
    	SvtInetOptions aInetOptions;
        if ( aInetOptions.ShouldUseFtpProxy( aFileName ) )
            bFolder = FALSE;
    }
#endif

    // wenn SpeichernUnter
	// und kein existierender Folder
	// und AutoExtensions an ist
	// und es eine Default-Extension gibt, die ungleich "*" ist
	if ( !bFolder && pThis->_pImp->_pCbAutoExtension &&
		 pThis->_pImp->_pCbAutoExtension->IsChecked() &&
		 pThis->_aDefExt.Len() && pThis->_aDefExt != '*' )
	{
		// und diese nicht eh schon dran haengt
		String aExt = DEFINE_CONST_UNICODE("*.");
		INetURLObject aTemp( aFileName );
		aExt += aTemp.GetExtension().ToLowerAscii();
		const String& rType = pThis->_pImp->_pCurFilter->GetType();
		String aType = rType;
		aType.ToLowerAscii();

		if ( ! aType.EqualsAscii(FILEDIALOG_FILTER_ALL) )
		{
			USHORT nWildCard = aType.GetTokenCount( FILEDIALOG_DEF_EXTSEP );
			USHORT nIndex, nPos = 0;

			for ( nIndex = 0; nIndex < nWildCard; nIndex++ )
			{
				if ( aExt == aType.GetToken( 0, FILEDIALOG_DEF_EXTSEP, nPos ) )
					break;
			}

			if ( nIndex >= nWildCard )
			{
				aFileName += '.';
				aFileName += pThis->_aDefExt;
			}
		}
	}

	BOOL bOpenFolder = ( FILEDLG_TYPE_PATHDLG == pThis->_pImp->_eDlgType ) &&
					   !pThis->_pImp->_bDoubleClick && pVoid != pThis->_pImp->_pEdFileName;
	if ( bFolder )
	{
		if ( aFileObject.GetMainURL( INetURLObject::NO_DECODE ) != pThis->_pFileView->GetViewURL() )
		{
			pThis->_pFileView->Initialize( aFileName, GetCurrentFilter_Impl( pThis->_pImp ) );
			if ( pThis->_pImp->_bDoubleClick )
				pThis->_pImp->_bFolderHasOpened = sal_True;
			pThis->_pImp->_aViewURL = aFileName;
			pThis->_aPath = aFileName;

            pThis->UpdateControls( aFileName );
		}
		else if ( bFilterChanged )
			pThis->_pFileView->ExecuteFilter( GetCurrentFilter_Impl( pThis->_pImp ) );

		if ( bOpenFolder )
		{
			pThis->_pImp->_aViewURL = aFileName;
			pThis->_aPath = aFileName;
		}
		else
			return 0;
	}
    else if ( !bWildCard )
	{
		if ( FILEDLG_TYPE_PATHDLG == pThis->_pImp->_eDlgType )
		{
			// MBA->PB : ?!
			// only fsysfolder allowed
            INetContentType eType = CONTENT_TYPE_UNKNOWN;
			FASTBOOL bShowError = FALSE;

			if ( eType != CONTENT_TYPE_X_CNT_FSYSBOX &&
				 eType != CONTENT_TYPE_X_CNT_FSYSFOLDER &&
				 eType != CONTENT_TYPE_X_CNT_REMOVEABLE_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_FIXED_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_REMOTE_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_RAM_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_CDROM_VOLUME &&
				 eType != CONTENT_TYPE_X_CNT_DISK_35 &&
				 eType != CONTENT_TYPE_X_CNT_DISK_525 &&
				 eType != CONTENT_TYPE_X_CNT_TAPEDRIVE &&
				 eType != CONTENT_TYPE_X_CNT_FSYSSPECIALFOLDER )
			{
				BOOL bClassPath = ( ( pThis->_pImp->_nStyle & SFXWB_CLASSPATH ) == SFXWB_CLASSPATH );

				if ( bShowError && pThis->_pImp->_pPathTypes->Count() )
				{
					for ( USHORT i = 0; i < pThis->_pImp->_pPathTypes->Count(); ++i )
					{
						if ( eType == (INetContentType)pThis->_pImp->_pPathTypes->GetObject(i) )
						{
							bShowError = FALSE;
							break;
						}
					}
				}

				if ( bShowError )
				{
					// overload another error context
			    	SfxErrorContext aCtx( ERRCTX_ERROR );
					ErrorHandler::HandleError( ERRCODE_IO_INVALIDDEVICE );
					return 0;
				}
			}
		}
		// Ggf. URL speichern.
        pThis->_aPath = aFileName;
	}
	else
	{
		// Ggf. neu filtern.
		if ( bFilterChanged )
			pThis->ExecuteFilter();
		return 0;
	}

    INetURLObject aFileObj( aFileName );
    if ( aFileObj.HasError() )
    {
        ErrorHandler::HandleError( ERRCODE_IO_GENERAL );
        return 0;
    }

    if ( pThis->_pImp->_eMode == FILEDLG_MODE_SAVE )
    {
		if ( ::utl::UCBContentHelper::Exists( aFileObj.GetMainURL( INetURLObject::NO_DECODE ) ) )
        {
            QueryBox aBox( pThis, WB_YES_NO, SvtResId( STR_SVT_ALREADYEXISTOVERWRITE ) );
            if ( aBox.Execute() != RET_YES )
                return 0;
        }
        else
        {
            String aCurPath;
            if ( ::utl::LocalFileHelper::ConvertURLToSystemPath( aFileName, aCurPath ) )
            {
                // if content does not exist: at least its path must exist
                INetURLObject aPathObj = aFileObj;
                aPathObj.removeSegment();
                BOOL bFolder = UCBContentHelper::IsFolder( aPathObj.GetMainURL( INetURLObject::NO_DECODE ) );
                if ( !bFolder )
                {
                    ErrorHandler::HandleError( ERRCODE_IO_NOTEXISTSPATH );
                    return 0;
                }
            }
        }
    }

	// Interessenten benachrichtigen.
	long nRet;

	if ( pThis->_aOKHdl.IsSet() )
		nRet = pThis->_aOKHdl.Call( pThis );
	else
		nRet = pThis->OK();

	if ( nRet )
	{
		pThis->UpdateHistory_Impl();
		pThis->EndDialog( TRUE );
	}

	return nRet;
}

//*****************************************************************************

IMPL_STATIC_LINK( SvtFileDialog_Impl, FilterSelectHdl_Impl, ListBox*, pBox )
{
	DBG_ASSERT( pBox, "SvtFileDialog_Impl:keine Instanz" );

	// wurde der Handler vom Travel-Timer gefeuert?
	if ( pBox == (ListBox*)&pThis->_pImp->_aFilterTimer )
	{
		// Anzeige erneut filtern.
		pThis->ExecuteFilter();

        // Interessenten benachrichtigen.
		pThis->FilterSelect();
		return 0;
	}

	// Filter suchen.
	XubString aFilter;
	// Es gibt "gecachte" Filter, die stehen in der List oben. Deren Namen
	// sind mit '<','>' "dekoriert". Sie haben als EntryData einen Zeiger auf
	// den String mit dem undekorierten Filternamen
	USHORT nSelectedEntry = pBox->GetSelectEntryPos();
	XubString* pEntryData = (XubString*)pBox->GetEntryData ( nSelectedEntry );
	if ( pEntryData )
		aFilter = *pEntryData;
	else
		aFilter = pBox->GetSelectEntry();

	SvtFileDialogFilterList_Impl* pList = pThis->_pImp->_pFilter;
	USHORT nPos = pList->Count();

	while ( nPos-- )
	{
		SvtFileDialogFilter_Impl* pFilter = pList->GetObject( nPos );

		if ( pFilter->GetName() == aFilter )
		{
			if ( pFilter != pThis->_pImp->_pCurFilter || pThis->_pImp->_pUserFilter )
			{
				// Ggf. Filter des Benutzers entfernen.
				DELETEZ( pThis->_pImp->_pUserFilter );
				pThis->_pImp->_pCurFilter = pFilter;

				// Ggf. Endung anzeigen.
				const String& rType = pFilter->GetType();
				pThis->_aDefExt = rType.Copy( 2 );
				USHORT nSepPos = pThis->_aDefExt.Search( FILEDIALOG_DEF_EXTSEP );

				if ( nSepPos != STRING_NOTFOUND )
					pThis->_aDefExt.Erase( nSepPos );

				// beim Speichern
				// und automatischer Dateinamenserweiterung...
				if ( pThis->_pImp->_pCbAutoExtension &&
					 pThis->_pImp->_pCbAutoExtension->IsChecked())
				{
					// Dateiextension beim Filterwechsel anpassen
					String aNewFile = pThis->_pImp->_pEdFileName->GetText();
					String aExt = GetFsysExtension_Impl( aNewFile );

					// aber nur wenn bereits eine Endung vorhanden ist
					if ( aExt.Len() )
					{
						SetFsysExtension_Impl( aNewFile, pThis->_aDefExt );
						pThis->_pImp->_pEdFileName->SetText( aNewFile );
					}
				}

				// wenn der Benutzer schnell durch die Filterbox
				// travelt, nicht sofort Filtern
				if ( pBox->IsTravelSelect() )
				{
					// FilterSelectHdl_Impl soll in
					// TRAVELFILTER_TIMEOUT ms neu gefeuert werden
					pThis->_pImp->_aFilterTimer.Start();
				}
				else
				{
					// Anzeige erneut filtern.
					pThis->ExecuteFilter();

					// evtl. vorher gestarteten Timer stoppen
					pThis->_pImp->_aFilterTimer.Stop();

				    // Interessenten benachrichtigen.
				    pThis->FilterSelect();
				}
			}
			break;
		}
	}

	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SvtFileDialog_Impl, FileNameGetFocusHdl_Impl, void*, EMPTYARG )
{
	pThis->_pFileView->SetNoSelection();
	pThis->_pFileView->Update();
	return 0;
}

//*****************************************************************************

IMPL_STATIC_LINK( SvtFileDialog_Impl, FileNameModifiedHdl_Impl, void*, EMPTYARG )
{
	FileNameGetFocusHdl_Impl( pThis, NULL );
	return 0;
}

//*****************************************************************************

BOOL SvtFileDialog_Impl::FindFilter_Impl
(
	const String& rFilter,
	BOOL bMultiExt, /* TRUE - auch Filter mit mehreren Endungen
					   beruecksichtigen
					   FALSE - keine ... */
	BOOL& rbFilterChanged
)

/*	[Beschreibung]

	Die Methode sucht in den eingef"ugten Filtern nach der
	spezifizierten Endung.
*/

{
	BOOL bFilterFound = FALSE;
	SvtFileDialogFilterList_Impl* pList = _pImp->_pFilter;
	USHORT nFilter = pList->Count();
	const USHORT nFilterCount = nFilter;

	while ( nFilter-- )
	{
		SvtFileDialogFilter_Impl* pFilter = pList->GetObject( nFilter );
		const String& rType = pFilter->GetType();
		String aSingleType = rType;
		USHORT nWildCard = rType.GetTokenCount(	FILEDIALOG_DEF_EXTSEP );

		if ( bMultiExt )
		{
			USHORT nIdx = 0;
			while ( !bFilterFound && nIdx != STRING_NOTFOUND )
			{
				aSingleType = rType.GetToken( 0, FILEDIALOG_DEF_EXTSEP, nIdx );
#ifdef UNX
				if ( aSingleType.CompareTo( rFilter ) == COMPARE_EQUAL )
#else
				if ( aSingleType.CompareIgnoreCaseToAscii( rFilter ) == COMPARE_EQUAL )
#endif
					bFilterFound = TRUE;
			}
		}
#ifdef UNX
		else if ( rType.CompareTo( rFilter ) == COMPARE_EQUAL )
#else
		else if ( rType.CompareIgnoreCaseToAscii( rFilter ) == COMPARE_EQUAL )
#endif
			bFilterFound = TRUE;

		if ( bFilterFound )
		{
			// Filter aktivieren.
			rbFilterChanged = _pImp->_pUserFilter || _pImp->_pCurFilter != pFilter;
			_pImp->_pUserFilter = new SvtFileDialogFilter_Impl( rFilter, rFilter, String(), 0 );
			_aDefExt = aSingleType.Copy( 2 );
			break;
		}
	}
	return bFilterFound;
}

//*****************************************************************************

void SvtFileDialog_Impl::ExecuteFilter()
{
	String aFileName = _pImp->_pEdFileName->GetText();
	_pFileView->ExecuteFilter( GetCurrentFilter_Impl( _pImp ) );
	_pFileView->SetNoSelection();
	_pImp->_pEdFileName->SetText( aFileName );
}

//*****************************************************************************

void SvtFileDialog_Impl::UpdateHistory_Impl()

/*	[Desription]

	This method forwards the update of the folder history
	to the favorites button.
*/

{
//!	_pImp->_pBtnStandard->UpdateHistory();
}

//*****************************************************************************

void SvtFileDialog_Impl::OpenMultiSelection_Impl()

/*	[Beschreibung]

	OpenHandler f"ur MultiSelektion
*/

{
	String aPath;
	ULONG nCount = _pFileView->GetSelectionCount();
	SvLBoxEntry* pEntry = nCount ? _pFileView->FirstSelected() : NULL;

	if ( nCount && pEntry )
		_aPath = _pFileView->GetURL( pEntry );

	// Interessenten benachrichtigen.
	long nRet;

	if ( _aOKHdl.IsSet() )
		nRet = _aOKHdl.Call( this );
	else
		nRet = OK();

	if ( nRet )
	{
		delete _pImp->_pPathList;
		_pImp->_pPathList = new SvStringsDtor;

		while ( pEntry )
		{
			String* pURL = new String( _pFileView->GetURL( pEntry ) );
			_pImp->_pPathList->Insert( pURL, _pImp->_pPathList->Count() );
            pEntry = _pFileView->NextSelected( pEntry );
		}
		UpdateHistory_Impl();
		EndDialog( TRUE );
	}
}

//*****************************************************************************

void SvtFileDialog_Impl::UpdateControls( const String& rURL )
{
   	( (SvtURLBox*)_pImp->_pEdFileName )->SetBaseURL( rURL );

	String aText;
	INetURLObject aObj( rURL );
    DBG_ASSERT( aObj.GetProtocol() != INET_PROT_NOT_VALID, "Invalid URL!" );

    if ( aObj.getSegmentCount() )
    {
        ::utl::LocalFileHelper::ConvertURLToSystemPath( rURL, aText );
        if ( aText.Len() )
        {
            // no Fsys path for server file system ( only UCB has mountpoints! )
            if ( aObj.GetProtocol() != INET_PROT_FILE )
                aText = rURL.Copy( INetURLObject::GetScheme( aObj.GetProtocol() ).Len() );
        }

        if ( !aText.Len() && aObj.getSegmentCount() )
            aText = rURL;
    }

	_pImp->_pFtCurrentPath->SetText( aText );

    if ( aObj.GetProtocol() == INET_PROT_FILE )
    {
        _pImp->_aToggleURLLocal = rURL;
        _pImp->_pBtnLocal->SetPressed( TRUE );
    }
    else
    {
        _pImp->_aToggleURLRemote = rURL;
        _pImp->_pBtnLocal->SetPressed( FALSE );
    }

	// path mode -> set new path in the edit field
	if ( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType )
		_pImp->_pEdFileName->SetText( aText );

    _aPath = rURL;

    if ( _pFileNotifier )
		_pFileNotifier->Notify( DIRECTORY_CHANGED, 0 );
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, SelectHdl_Impl, SvTabListBox*, pBox )
{
	if ( _pImp->_bFolderHasOpened )
		return 0;

	SvLBoxEntry* pEntry = pBox->FirstSelected();
	DBG_ASSERT( pEntry, "SelectHandler without selected entry" );
	SvtContentEntry* pUserData = (SvtContentEntry*)pEntry->GetUserData();

	if ( pUserData )
	{
		INetURLObject aObj( pUserData->maURL );
		if ( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType )
		{
			if ( aObj.GetProtocol() == INET_PROT_FILE )
			{
				if ( !pUserData->mbIsFolder )
					aObj.removeSegment();
				String aName = aObj.getFSysPath( INetURLObject::FSYS_DETECT );
				_pImp->_pEdFileName->SetText( aName );
				_pImp->_pEdFileName->SetSelection( Selection( 0, aName.Len() ) );
				_aPath = pUserData->maURL;
			}
			else if ( !pUserData->mbIsFolder )
			{
				_pImp->_pEdFileName->SetText( pUserData->maURL );
				_pImp->_pEdFileName->SetSelection( Selection( 0, pUserData->maURL.Len() ) );
				_aPath = pUserData->maURL;
			}
			else
				_pImp->_pEdFileName->SetText( UniString() );
			_pImp->_aViewURL = pUserData->maURL;
		}
		else
		{
			if ( !pUserData->mbIsFolder )
			{
				String aName = pBox->GetEntryText( pEntry, 0 );
				_pImp->_pEdFileName->SetText( aName );
				_pImp->_pEdFileName->SetSelection( Selection( 0, aName.Len() ) );
				_aPath = pUserData->maURL;
			}
		}
	}

	if ( _pImp->_bMultiSelection && _pFileView->GetSelectionCount() > 1 )
	{
		// bei Multiselektion den Datei-Edit leeren
		_pImp->_pEdFileName->SetText( String() );
	}

	FileSelect();

	return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, DblClickHdl_Impl, SvTabListBox*, EMPTYARG )
{
	_pImp->_bDoubleClick = TRUE;
	OpenHdl_Impl( this, NULL );
	_pImp->_bDoubleClick = FALSE;

	if ( _pImp->_bFolderHasOpened )
		_pImp->_aResetCursorTimer.Start();

	return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, EntrySelectHdl_Impl, ComboBox*, EMPTYARG )
{
	FileSelect();

    return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, OpenDoneHdl_Impl, SvtFileView*, pView )
{
	_pImp->_aCWD = pView->GetViewURL();
	_pImp->_pBtnUp->Enable( ::utl::UCBContentHelper::HasParentFolder( _pImp->_aCWD ) );
	_pImp->_pBtnNewFolder->Enable( ::utl::UCBContentHelper::CanMakeFolder( _pImp->_aCWD ) );

	return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, ResetCursorHdl_Impl, Timer*, EMPTYARG )
{
	_pFileView->ResetCursor();
	_pImp->_bFolderHasOpened = sal_False;
	return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, LocalFileSystemHdl_Impl, PushButton*, EMPTYARG )
{
	// pressed status of the button
	BOOL bPressed = _pImp->_pBtnLocal->IsPressed();

    String aURL = _pFileView->GetViewURL();
    if ( INetURLObject( aURL ).GetProtocol() == INET_PROT_FILE )
        OpenURL_Impl( _pImp->_aToggleURLRemote );
    else
        OpenURL_Impl( _pImp->_aToggleURLLocal );

	// pressed status of the button toggles
	_pImp->_pBtnLocal->SetPressed( !bPressed );
	return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, AutoExtensionHdl_Impl, CheckBox*, EMPTYARG )
{
	if ( _pFileNotifier )
		_pFileNotifier->Notify( CTRL_STATE_CHANGED,
                                ExtendedFilePickerElementIds::CHECKBOX_AUTOEXTENSION );

	if ( _pImp->_pCbAutoExtension && _pImp->_pCbAutoExtension->IsChecked() )
	{
		// update extension
		String aNewFile = _pImp->_pEdFileName->GetText();
		String aExt = GetFsysExtension_Impl( aNewFile );

		// only when an extension exists
		if ( aExt.Len() )
		{
			SetFsysExtension_Impl( aNewFile, _aDefExt );
			_pImp->_pEdFileName->SetText( aNewFile );
		}
	}

    return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, ClickHdl_Impl, CheckBox*, pCheckBox )
{
    if ( ! _pFileNotifier )
        return 0;

    sal_Int16 nId = -1;

    if ( pCheckBox == _pImp->_pCbOptions )
        nId = ExtendedFilePickerElementIds::CHECKBOX_FILTEROPTIONS;
    else if ( pCheckBox == _pCbSelection )
        nId = ExtendedFilePickerElementIds::CHECKBOX_SELECTION;
    else if ( pCheckBox == _pCbReadOnly )
        nId = ExtendedFilePickerElementIds::CHECKBOX_READONLY;
    else if ( pCheckBox == _pImp->_pCbPassword )
        nId = ExtendedFilePickerElementIds::CHECKBOX_PASSWORD;
    else if ( pCheckBox == _pCbLinkBox )
        nId = ExtendedFilePickerElementIds::CHECKBOX_LINK;
    else if ( pCheckBox == _pCbPreviewBox )
        nId = ExtendedFilePickerElementIds::CHECKBOX_PREVIEW;

	if ( nId != -1 )
        _pFileNotifier->Notify( CTRL_STATE_CHANGED, nId );

    return 0;
}

//*****************************************************************************

IMPL_LINK( SvtFileDialog_Impl, PlayButtonHdl_Impl, PushButton*, EMPTYARG )
{
    if ( _pFileNotifier )
        _pFileNotifier->Notify( CTRL_STATE_CHANGED,
                                ExtendedFilePickerElementIds::PUSHBUTTON_PLAY );

    return 0;
}

//*****************************************************************************

long SvtFileDialog_Impl::Notify( NotifyEvent& rNEvt )

/*	[Beschreibung]

	Die Methode wird gerufen, <BACKSPACE> abzufangen.
*/

{
	USHORT nType = rNEvt.GetType();
	long nRet = 0;

	if ( EVENT_KEYINPUT == nType && rNEvt.GetKeyEvent() )
	{
		const KeyCode& rKeyCode = rNEvt.GetKeyEvent()->GetKeyCode();
		USHORT nCode = rKeyCode.GetCode();

		if ( !rKeyCode.GetModifier() &&
			 KEY_BACKSPACE == nCode && !_pImp->_pEdFileName->HasChildPathFocus() )
		{
			nRet = 0; //! (long)_pFileView->DoBeamerKeyInput( *rNEvt.GetKeyEvent() );

			if ( !nRet && _pImp->_pBtnUp->IsEnabled() )
			{
				PrevLevel_Impl();
				nRet = 1;
			}
		}
		else if ( KEY_TAB == nCode )
		{
			if ( ( rKeyCode.IsShift() && _pImp->_pEdFileName->HasChildPathFocus() ) ||
				 ( !rKeyCode.GetModifier() && _pImp->_pBtnStandard->HasChildPathFocus() ) )
			{
				SetFocusInViewControl();
				nRet = 1;
			}
		}
		else if ( rKeyCode.IsMod1() && ( KEY_C == nCode || KEY_V == nCode || KEY_X == nCode ) )
		{
/* (mhu)
			String aVerb = KEY_C == nCode ? DEFINE_CONST_UNICODE(SVT_MENUPART_VERB_COPY) :
				( KEY_V == nCode ? DEFINE_CONST_UNICODE(SVT_MENUPART_VERB_PASTE) : DEFINE_CONST_UNICODE(SVT_MENUPART_VERB_CUT) );
//(dv)			if ( !CntPopupMenu::DoVerbCommand( aVerb, _pFileView->GetView() ) )
//(dv)				Sound::Beep();
*/
		}
	}
	return nRet ? nRet : VclFileDialog::Notify( rNEvt );
}

//*****************************************************************************

long SvtFileDialog_Impl::OK()
{
	return TRUE;
}

//*****************************************************************************

class SvtDefModalDialogParent_Impl
{
private:
	Window*	_pOld;

public:
	SvtDefModalDialogParent_Impl( Window *pNew ) :
		_pOld( Application::GetDefDialogParent() )
		{ Application::SetDefDialogParent( pNew ); }

	~SvtDefModalDialogParent_Impl() { Application::SetDefDialogParent( _pOld ); }
};

//*****************************************************************************

short SvtFileDialog_Impl::Execute()
{
	// #53016# evtl. nur ein Filename ohne Pfad?
	String aFileNameOnly;
	if( _aPath.Len() && (_pImp->_eMode == FILEDLG_MODE_SAVE)
					 && (_aPath.Search(':') == STRING_NOTFOUND)
					 && (_aPath.Search('\\') == STRING_NOTFOUND)
					 && (_aPath.Search('/') == STRING_NOTFOUND))
	{
		aFileNameOnly = _aPath;
		_aPath.Erase();
	}

	// im Pfaddialog nur File-Protokoll g"ultig
	if ( FILEDLG_TYPE_PATHDLG == _pImp->_eDlgType )
	{
		if ( _aPath.Len() )
		{
			INetURLObject aTemp;
			aTemp.SetSmartURL( _aPath );
			if ( aTemp.GetProtocol() != INET_PROT_FILE )
				_aPath.Erase();
		}

		if ( !_aPath.Len() && _pImp->_aPathURL.Len() )
			_aPath = _pImp->_aPathURL;
	}

	// kein Startpfad angegeben?
	if ( !_aPath.Len() )
	{
		// gemerkter Pfad vorhanden?
		String aLastURL( GetLastDir_Impl() );

		if ( aLastURL.Len() )
		{
			// falls lokales Verzeichnis testen...
			INetURLObject aLastObj( aLastURL );
			aLastObj.setFinalSlash();
			if ( aLastObj.GetProtocol() == INET_PROT_FILE )
			{
				// ob auch physikalisch vorhanden
				aLastURL = aLastObj.GetMainURL( INetURLObject::NO_DECODE );
				_aPath = aLastURL;
			}
			else
				_aPath = aLastURL;
		}

		// hat es nicht geklappt?
		if ( !_aPath.Len() )
		{
			// dann das Standard-Dir verwenden
			INetURLObject aWorkPathObj( _pImp->GetStandardDir(), INET_PROT_FILE );
			aWorkPathObj.setFinalSlash();
			String aWorkPathURL = aWorkPathObj.GetMainURL( INetURLObject::NO_DECODE );
			_aPath = aWorkPathURL;
		}

		// #53016# vorgegebener Dateiname an Pfad anh"angen
		if ( aFileNameOnly.Len() )
			_aPath += aFileNameOnly;
	}

	// convert input (_aPath) to url
	INetURLObject aTemp( GetStandardDir() );
    aTemp.setFinalSlash();
    bool bWasAbsolute = FALSE;
    aTemp = aTemp.smartRel2Abs( _aPath, bWasAbsolute );
	_aPath = aTemp.GetMainURL( INetURLObject::NO_DECODE );

	if ( UCBContentHelper::IsFolder( _aPath ) )
	{
		aTemp.setFinalSlash();
		_aPath = aTemp.GetMainURL( INetURLObject::NO_DECODE );
	}

	// Instanz als aktiv Dialog speichern,
	// vorher ggf. den alten aktiven Dialog merken.
	SvtFileDialog_Impl* pOldActiveDlg = _pActiveDlg;
	_pActiveDlg = this;

	// Ggf. Filter anzeigen.
	_pImp->_pLbFilter->Clear();
	USHORT nPos = _pImp->_pFilter->Count();
	while ( nPos-- )
	{
		SvtFileDialogFilter_Impl* pFilter = _pImp->_pFilter->GetObject( nPos );
		_pImp->_pLbFilter->InsertEntry( pFilter->GetName() );
	}

	// Initialen Filter einstellen.
	USHORT nFilterCount = GetFilterCount();
	String aAll( SvtResId( STR_FILTERNAME_ALL ) );
	BOOL bHasAll = _pImp->_pLbFilter->GetEntryPos( aAll ) != LISTBOX_ENTRY_NOTFOUND;
	if ( _pImp->_pCurFilter || nFilterCount == 1 || ( nFilterCount == 2 && bHasAll ) )
	{
		// Ggf. einzigen Filter als aktuellen Filter setzen oder den einzigen
		// Filter, der nicht auf alle Dateien verweist.
		if ( !_pImp->_pCurFilter )
		{
			nPos = 0;
			if ( 2 == nFilterCount && bHasAll )
			{
				nPos = nFilterCount;
				while ( nPos-- )
				{
					if ( GetFilterName( nPos ) != aAll )
						break;
				}
			}
			SetCurFilter( GetFilterName( nPos ) );
		}

		// Anzeige anpassen.
		_pImp->_pLbFilter->SelectEntry( _pImp->_pCurFilter->GetName() );
		String aType( _pImp->_pCurFilter->GetType() );
		_aDefExt = aType.Copy( 2 );
		USHORT nSepPos = _aDefExt.Search( FILEDIALOG_DEF_EXTSEP );
		if ( nSepPos != STRING_NOTFOUND )
			_aDefExt.Erase( nSepPos );
	}
	else
	{
		// Ggf. Filter fuer alle Dateien setzen bzw. erzeugen.
		if ( !bHasAll )
		{
			AddFilter( aAll, DEFINE_CONST_UNICODE(FILEDIALOG_FILTER_ALL) );
			SetCurFilter( aAll );
			_pImp->_pLbFilter->InsertEntry( aAll );
		}
		_pImp->_pLbFilter->SelectEntry( aAll );
	}

	_pImp->_pDefaultFilter = _pImp->_pCurFilter;

	// HACK #50065#
	// ggf. Filter isolieren.
	String aFilter;
	String aEmpty;

	if ( !IsolateFilterFromPath_Impl( _aPath, aFilter ) )
		return 0;

	if ( aFilter.Len() != 0 )
	{
		BOOL bFilterChanged = TRUE;

		// Nach einem korrespondierenden Filter suchen.
		BOOL bFilterFound = FindFilter_Impl( aFilter, FALSE, bFilterChanged );
		if ( !bFilterFound )
			bFilterFound = FindFilter_Impl( aFilter, TRUE, bFilterChanged );

		// Ggf. neuen Filter erzeugen.
		if ( !bFilterFound )
		{
			// Neuen Filter generieren.
			delete _pImp->_pUserFilter;
			_pImp->_pUserFilter = new SvtFileDialogFilter_Impl( aFilter, aFilter, aEmpty, 0 );

			// Anzeige anpassen.
			String aFilterDesc( aFilter );
			if ( aFilter.EqualsAscii(FILEDIALOG_FILTER_ALL) )
			{
				aFilterDesc = String( SvtResId( STR_FILTERNAME_ALL ) );
				_aDefExt.Erase();
			}
			else
				_aDefExt = aFilter.Copy( 2 );

			_pImp->_pEdFileName->SetText( aFilter );
			_pImp->_pLbFilter->SelectEntry( aFilterDesc );
		}
	}
	// HACK #50065#

	// Instanz fuer den gesetzten Pfad erzeugen und anzeigen.
	INetURLObject aFolderURL( _aPath );
	String aFileName( aFolderURL.getName( INetURLObject::LAST_SEGMENT, false ) );
	USHORT nFileNameLen = aFileName.Len();
	BOOL bFileToSelect;
	if ( ( bFileToSelect = nFileNameLen && aFileName.GetChar( nFileNameLen - 1 ) != INET_PATH_TOKEN ) )
	{
		_pImp->_pEdFileName->SetText( GET_DECODED_NAME( aFolderURL ) );
		aFolderURL.removeSegment();
	}

	INetURLObject aObj = aFolderURL;
	if ( aObj.GetProtocol() == INET_PROT_FILE )
	{
		// Ordner als aktuelles Verzeichnis setzen.
		aObj.setFinalSlash();
		_pImp->_aCWD = aObj.GetMainURL( INetURLObject::NO_DECODE );
	}

    _pImp->_aToggleURLRemote = GetStandardDir();
    _pImp->_aToggleURLLocal = DEFINE_CONST_UNICODE("file:///");

	UpdateControls( aObj.GetMainURL( INetURLObject::NO_DECODE ) );

    // Somebody might want to enable some controls acording to the current filter
    FilterSelect();

	// Zustand der Steuerelemente anpassen.
//	EndListeningAll();

    ViewHdl_Impl( this, NULL );
	_pFileView->Initialize( aObj.GetMainURL( INetURLObject::NO_DECODE ), GetCurrentFilter_Impl( _pImp ) );
	_pFileView->Show();
	SvtDefModalDialogParent_Impl aDefParent( this );

	// ggf. Gr"osse aus Ini lesen und setzen
	InitSize();

	// Start des Dialogs.
    _bIsInExecute = TRUE;
	short nResult = VclFileDialog::Execute();
    _bIsInExecute = FALSE;

	// letztes Verzeichnis merken
	if ( RET_OK == nResult )
	{
		INetURLObject aURL( _aPath );
		if ( aURL.GetProtocol() == INET_PROT_FILE )
		{
			// nur bei File-URL's und nicht bei virtuelle Folder
			// das ausgew"ahlte Verzeichnis merken
			sal_Int32 nLevel = aURL.getSegmentCount();
			sal_Bool bDir = UCBContentHelper::IsFolder( aURL.GetMainURL( INetURLObject::NO_DECODE ) );
			BOOL bClassPath = ( ( _pImp->_nStyle & SFXWB_CLASSPATH ) == SFXWB_CLASSPATH );
			if ( nLevel > 1 && ( FILEDLG_TYPE_FILEDLG == _pImp->_eDlgType || !bDir ) )
				aURL.removeSegment();
            SetLastDir_Impl( aURL.GetMainURL( INetURLObject::NO_DECODE ) );
		}

		// benutzen Filter cachen (UserFilter, DefaultFilter und <Alle> nicht, nur im
		// FileOpen-Mode)
		String aAll( SvtResId( STR_FILTERNAME_ALL ) );
		if( !_pImp->_pUserFilter
			&& aAll.CompareTo(_pImp->_pCurFilter->GetName()) != COMPARE_EQUAL
			&& _pImp->_eMode == FILEDLG_MODE_OPEN
			&& _pImp->_pDefaultFilter != _pImp->_pCurFilter )
			_pImp->CacheFilter_Impl(_pImp->_pCurFilter->GetName());
	}

	if(_pImp->_eMode == FILEDLG_MODE_OPEN)
		_pImp->SaveFilterCache_Impl();

	// Markierung als aktive Instanz aufheben
	_pActiveDlg = pOldActiveDlg;

    return nResult;
}

//*****************************************************************************

void SvtFileDialog_Impl::FileSelect()
{
	if ( _pFileNotifier )
		_pFileNotifier->Notify( FILE_SELECTION_CHANGED, 0 );
}

//*****************************************************************************

void SvtFileDialog_Impl::FilterSelect()
{
	if ( _pFileNotifier )
		_pFileNotifier->Notify( CTRL_STATE_CHANGED,
                                CommonFilePickerElementIds::LISTBOX_FILTER );
}

//*****************************************************************************

void SvtFileDialog_Impl::SetStandardDir( const String& rStdDir )

/*	[Beschreibung]

	Die Methode setzt den Pfad f"ur den Standardknopf.
*/

{
    INetURLObject aObj( rStdDir );
    DBG_ASSERT( aObj.GetProtocol() != INET_PROT_NOT_VALID, "Invalid protocol!" );
	aObj.setFinalSlash();
	_pImp->SetStandardDir( aObj.GetMainURL( INetURLObject::NO_DECODE ) );
}

//*****************************************************************************

const String& SvtFileDialog_Impl::GetStandardDir() const

/*	[Beschreibung]

	Diese Methode gibt den eingestellten Standardpfad zur"uck.
*/

{
	return _pImp->GetStandardDir();
}

//*****************************************************************************

const String& SvtFileDialog_Impl::GetViewURL() const

/*	[Beschreibung]

	Diese Methode gibt die ausgew"ahlte ViewURL zur"uck.
*/

{
	return _pImp->GetViewURL();
}

//*****************************************************************************

void SvtFileDialog_Impl::PrevLevel_Impl()
{
	String aNewURL;
	if ( _pFileView->PreviousLevel( aNewURL ) )
	{
		UpdateControls( aNewURL );
	}
}

//*****************************************************************************

void SvtFileDialog_Impl::OpenURL_Impl( const String& rURL )
{
	_pFileView->Initialize( rURL, GetCurrentFilter_Impl( _pImp ) );
	UpdateControls( rURL );
}

//*****************************************************************************

void SvtFileDialog_Impl::AddFilter( const String& rFilter, const String& rType, ULONG nFlags )
{
	AddFilter( rFilter, rType, String(), nFlags );
}

//*****************************************************************************

void SvtFileDialog_Impl::AddFilter( const String& rFilter, const String& rType,
							   const String& rSysType,ULONG nFlags )
{
	DBG_ASSERT( !IsInExecute(), "SvtFileDialog_Impl:aktiv" );

	SvtFileDialogFilter_Impl* pFilter =	new SvtFileDialogFilter_Impl( rFilter, rType, rSysType, nFlags );
	_pImp->_pFilter->C40_INSERT( SvtFileDialogFilter_Impl, pFilter, (USHORT) 0 );

    if ( ! _pImp->_pCurFilter )
		_pImp->_pCurFilter = pFilter;
}

//*****************************************************************************

void SvtFileDialog_Impl::RemoveFilter( const String& rFilter )
{}

//*****************************************************************************

void SvtFileDialog_Impl::RemoveAllFilter()
{}

//*****************************************************************************

void SvtFileDialog_Impl::SetCurFilter( const String& rFilter )
{
	DBG_ASSERT( !IsInExecute(), "SvtFileDialog_Impl:aktiv" );

	// Entsprechenden Filter suchen.
	USHORT nPos = _pImp->_pFilter->Count();

    while ( nPos-- )
	{
		SvtFileDialogFilter_Impl* pFilter = _pImp->_pFilter->GetObject( nPos );
		if ( pFilter->GetName() == rFilter )
		{
			_pImp->_pCurFilter = pFilter;
			break;
		}
	}
}

//*****************************************************************************

String SvtFileDialog_Impl::GetCurFilter() const
{
	String aFilter;

    if ( _pImp->_pCurFilter )
		aFilter = _pImp->_pCurFilter->GetName();

    return aFilter;
}

//*****************************************************************************

USHORT SvtFileDialog_Impl::GetFilterCount() const
{
	return _pImp->_pFilter->Count();
}

//*****************************************************************************

const String& SvtFileDialog_Impl::GetFilterName( USHORT nPos ) const
{
	DBG_ASSERT( nPos < GetFilterCount(), "invalid index" );
	return _pImp->_pFilter->GetObject( nPos )->GetName();
}

//*****************************************************************************

const String& SvtFileDialog_Impl::GetFilterType( USHORT nPos ) const
{
	DBG_ASSERT( nPos < GetFilterCount(), "invalid index" );
	return _pImp->_pFilter->GetObject( nPos )->GetType();
}

//*****************************************************************************

ULONG SvtFileDialog_Impl::GetFilterFlags( USHORT nPos ) const
{
	DBG_ASSERT( nPos < GetFilterCount(), "invalid index" );
	return _pImp->_pFilter->GetObject( nPos )->GetFlags();
}

//*****************************************************************************

void SvtFileDialog_Impl::SetDefaultButtonText( const XubString& rText, ULONG nHelpId )
{
	if ( _pImp && _pImp->_pBtnFileOpen )
	{
		_pImp->_pBtnFileOpen->SetText( rText );
		if ( nHelpId )
			_pImp->_pBtnFileOpen->SetHelpId( nHelpId );
	}
}

//*****************************************************************************

void SvtFileDialog_Impl::InitSize()
{
	if ( ! _pImp->_aIniKey.Len() )
        return;

	Size aDlgSize = GetResizeOutputSizePixel();
	SetMinOutputSizePixel( aDlgSize );

	if ( !_pImp->_nFixDeltaHeight )
	{
		// Fixgr"ossen errechnen und merken
		Point aPnt = _pFileView->GetPosPixel();
		long nBoxH = _pFileView->GetSizePixel().Height();
		long nH = GetSizePixel().Height();
		_pImp->_nFixDeltaHeight = nH - nBoxH;
	}

	// initialize from config
	SvtViewOptions aDlgOpt( E_DIALOG, _pImp->_aIniKey );

	if ( aDlgOpt.Exists() )
	{
		Size aNewSize;
		aDlgOpt.GetSize( aNewSize.Width(), aNewSize.Height() );
		if ( aNewSize.Width() < aDlgSize.Width() || aNewSize.Height() < aDlgSize.Height() )
			aNewSize = aDlgSize;
		SetOutputSizePixel( aNewSize );
	}
}

//*****************************************************************************

SvStringsDtor* SvtFileDialog_Impl::GetPathList() const
{
	SvStringsDtor*	pList = new SvStringsDtor;
	ULONG			nCount = _pFileView->GetSelectionCount();
	SvLBoxEntry*	pEntry = nCount ? _pFileView->FirstSelected() : NULL;

	if ( ! pEntry )
	{
		String* pURL;

        if ( _pImp->_pEdFileName->GetText().Len() && _bIsInExecute )
            pURL = new String( _pImp->_pEdFileName->GetURL() );
        else
            pURL = new String( _aPath );

        pList->Insert( pURL, pList->Count() );
	}
	else
	{
		while ( pEntry )
		{
			String* pURL = new String( _pFileView->GetURL( pEntry ) );
			pList->Insert( pURL, pList->Count() );
			pEntry = _pFileView->NextSelected( pEntry );
		}
	}

	return pList;
}

//*****************************************************************************

BOOL SvtFileDialog_Impl::IsolateFilterFromPath_Impl( String& rPath, String& rFilter )
{
	String aEmpty;
	String aReversePath( rPath );
	aReversePath.Reverse();
	USHORT nQuestionMarkPos = rPath.Search( '?' );

	if ( nQuestionMarkPos != STRING_NOTFOUND )
	{
		// Fragezeichen als Wildcard nur bei Files
		INetProtocol eProt = INetURLObject::CompareProtocolScheme( rPath );

		if ( INET_PROT_NOT_VALID != eProt && INET_PROT_FILE != eProt )
			nQuestionMarkPos = STRING_NOTFOUND;
	}
	USHORT nWildCardPos = Min( rPath.Search( FILEDIALOG_DEF_WILDCARD ), nQuestionMarkPos );
	rFilter = aEmpty;

	if ( nWildCardPos != STRING_NOTFOUND )
	{
		USHORT nPathTokenPos = aReversePath.Search( INET_PATH_TOKEN );

		if ( nPathTokenPos == STRING_NOTFOUND )
		{
			String aDelim(
#ifdef WNT
					'\\'
#elif MAC
					':'
#else
					'/'
#endif
			);

			nPathTokenPos = aReversePath.Search( aDelim );
#if !defined( UNX ) && !defined( MAC )
			if ( nPathTokenPos == STRING_NOTFOUND )
			{
				nPathTokenPos = aReversePath.Search( ':' );
			}
#endif
		}

		// Syntax pr"ufen.
		if ( nPathTokenPos != STRING_NOTFOUND )
		{
			if ( nPathTokenPos < (rPath.Len() - nWildCardPos - 1) )
			{
				ErrorHandler::HandleError( ERRCODE_SFX_INVALIDSYNTAX );
				return FALSE;
			}

			// Filter abschneiden.
			rFilter = aReversePath;
			rFilter.Erase( nPathTokenPos );
			rFilter.Reverse();

			// Ordner bestimmen.
			rPath = aReversePath;
			rPath.Erase( 0, nPathTokenPos );
			rPath.Reverse();
		}
		else
		{
			rFilter = rPath;
			rPath = aEmpty;
		}
	}

	return TRUE;
}

//*****************************************************************************

void SvtFileDialog_Impl::Resize()
{
	if ( IsRollUp() )
		return;

	Size aDlgSize = GetResizeOutputSizePixel();
	Size aOldSize = _pImp->_aDlgSize;
	_pImp->_aDlgSize = aDlgSize;
	long nWinDeltaW = 0;

	if ( _pPrevWin &&
         _pPrevWin->GetPosPixel().X() > _pFileView->GetPosPixel().X() )
	{
		nWinDeltaW = _pPrevWin->GetOutputSizePixel().Width() + _pImp->_a6Size.Width();
	}
/*	if ( _pImp->_pExtControls )
	{
		for ( USHORT i = 0; i < _pImp->_pExtControls->Count(); ++i )
		{
			Window* pWin = (Window*)_pImp->_pExtControls->GetObject(i);

			if ( pWin && pWin->GetType() == WINDOW_WINDOW &&
				 pWin->GetPosPixel().X() > _pFileView->GetPosPixel().X() )
				nWinDeltaW = pWin->GetOutputSizePixel().Width() + _pImp->_a6Size.Width();
		}
	}
*/
	Size aNewSize = _pFileView->GetSizePixel();
	Point aBoxPos( _pFileView->GetPosPixel() );
	long nDelta = aNewSize.Height();
	long nDeltaX = aNewSize.Width();
	aNewSize.Height() = aDlgSize.Height() - _pImp->_nFixDeltaHeight;
	aNewSize.Width() = aDlgSize.Width() - aBoxPos.X() - _pImp->_a6Size.Width() - nWinDeltaW;
	if ( aOldSize.Height() )
		nDelta = _pImp->_aDlgSize.Height() - aOldSize.Height();
	else
		nDelta = aNewSize.Height() - nDelta;
	nDeltaX = aNewSize.Width() - nDeltaX;

	if ( nWinDeltaW )
		nWinDeltaW = nDeltaX * 2 / 3;
	aNewSize.Width() -= nWinDeltaW;
	nDeltaX -= nWinDeltaW;

	_pFileView->SetSizePixel( aNewSize );

	if ( !nDelta && !nDeltaX )
		// Dieses Resize wurde nur zum Ein - oder Ausblenden des Indicators aufgerufen
		return;

	Point aNewPos = _pImp->_pFtFileName->GetPosPixel();
	aNewPos.Y() += nDelta;
	long nMaxYPos = aNewPos.Y();
	_pImp->_pFtFileName->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pEdFileName->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pEdFileName->SetPosPixel( aNewPos );
	aNewSize = _pImp->_pEdFileName->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pEdFileName->SetSizePixel( aNewSize );
	aNewPos = _pImp->_pFtFileVersion->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pFtFileVersion->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pLbFileVersion->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pLbFileVersion->SetPosPixel( aNewPos );
	aNewSize = _pImp->_pLbFileVersion->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pLbFileVersion->SetSizePixel( aNewSize );
	aNewPos = _pImp->_pFtFileType->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pFtFileType->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pLbFilter->GetPosPixel();
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pLbFilter->SetPosPixel( aNewPos );
	aNewSize = _pImp->_pLbFilter->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pLbFilter->SetSizePixel( aNewSize );
	aNewPos = _pImp->_pBtnFileOpen->GetPosPixel();
	aNewPos.X() += nDeltaX;
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pBtnFileOpen->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnCancel->GetPosPixel();
	aNewPos.X() += nDeltaX;
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pBtnCancel->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnHelp->GetPosPixel();
	aNewPos.X() += nDeltaX;
	aNewPos.Y() += nDelta;
	if ( aNewPos.Y() > nMaxYPos )
		nMaxYPos = aNewPos.Y();
	_pImp->_pBtnHelp->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnLocal->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnLocal->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnUp->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnUp->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnNewFolder->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnNewFolder->SetPosPixel( aNewPos );
	aNewPos = _pImp->_pBtnStandard->GetPosPixel();
	aNewPos.X() += nDeltaX;
	_pImp->_pBtnStandard->SetPosPixel( aNewPos );

    aNewSize = _pImp->_pFtCurrentPath->GetSizePixel();
	aNewSize.Width() += nDeltaX;
	_pImp->_pFtCurrentPath->SetSizePixel( aNewSize );

	if ( _pCbReadOnly )
	{
		aNewPos = _pCbReadOnly->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pCbReadOnly->SetPosPixel( aNewPos );
	}

    if ( _pCbLinkBox )
	{
		aNewPos = _pCbLinkBox->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pCbLinkBox->SetPosPixel( aNewPos );
	}

    if ( _pCbPreviewBox )
	{
		aNewPos = _pCbPreviewBox->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pCbPreviewBox->SetPosPixel( aNewPos );
	}

    if ( _pPbPlay )
	{
		aNewPos = _pPbPlay->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pPbPlay->SetPosPixel( aNewPos );
	}

	if ( _pImp->_pCbPassword )
	{
		aNewPos = _pImp->_pCbPassword->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pImp->_pCbPassword->SetPosPixel( aNewPos );
	}

	if ( _pImp->_pCbAutoExtension )
	{
		aNewPos = _pImp->_pCbAutoExtension->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pImp->_pCbAutoExtension->SetPosPixel( aNewPos );
	}

	if ( _pImp->_pCbOptions )
	{
		aNewPos = _pImp->_pCbOptions->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pImp->_pCbOptions->SetPosPixel( aNewPos );
	}

	if ( _pCbSelection )
	{
		aNewPos = _pCbSelection->GetPosPixel();
		aNewPos.Y() += nDelta;
		if ( aNewPos.Y() > nMaxYPos )
			nMaxYPos = aNewPos.Y();
		_pCbSelection->SetPosPixel( aNewPos );
	}

	// zus"atzliche Controls ausrichten
	if ( _pPrevWin &&
         _pPrevWin->GetPosPixel().X() > _pFileView->GetPosPixel().X() )
	{
		// Controls vom Typ Window speziell ausrichten
		// auch die Gr"osse anpassen
		aNewPos = _pPrevWin->GetPosPixel();
		aNewPos.X() += nDeltaX;
		_pPrevWin->SetPosPixel( aNewPos );
        _pPrevBmp->SetPosPixel( aNewPos );
		aNewSize = _pPrevWin->GetOutputSizePixel();
		aNewSize.Width() += nWinDeltaW;
		aNewSize.Height() += nDelta;
		if ( !aOldSize.Height() )
			aNewSize.Height() -= ( _pImp->_a6Size.Height() / 2 );
		_pPrevWin->SetOutputSizePixel( aNewSize );
		_pPrevBmp->SetOutputSizePixel( aNewSize );
        _pPrevBmp->Invalidate();
	}

    if ( _pFileNotifier )
		_pFileNotifier->Notify( DIALOG_SIZE_CHANGED, 0 );
}

//*****************************************************************************

void SvtFileDialog_Impl::SetFocusInViewControl()
{
	_pFileView->SetFocusInView();
}

//*****************************************************************************

void SvtFileDialog_Impl::SetPathURL( const XubString& rPathURL )

/*	[Beschreibung]

*/

{
	_pImp->_aPathURL = rPathURL;
}

//*****************************************************************************

Image* SvtFileDialog_Impl::GetFolderImage() const
{
	return _pImp->_pFolderImage;
}

//-----------------------------------------------------------------------------
void SvtFileDialog_Impl::SetValue( sal_Int16 nId,
                                   sal_Int16 nCtrlAction,
                                   const Any &rValue )
{
    switch ( nId )
	{
	case ExtendedFilePickerElementIds::CHECKBOX_AUTOEXTENSION :
		if ( _pImp->_pCbAutoExtension )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pImp->_pCbAutoExtension->Check( bChecked );
        }
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PASSWORD :
		if ( _pImp->_pCbPassword )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pImp->_pCbPassword->Check( bChecked );
        }
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_FILTEROPTIONS :
		if ( _pImp->_pCbOptions )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pImp->_pCbOptions->Check( bChecked );
        }
        break;
    case ExtendedFilePickerElementIds::CHECKBOX_READONLY :
		if ( _pCbReadOnly )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pCbReadOnly->Check( bChecked );
		}
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_LINK :
		if ( _pCbLinkBox )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pCbLinkBox->Check( bChecked );
		}
        break;
    case ExtendedFilePickerElementIds::CHECKBOX_PREVIEW :
		if ( _pCbPreviewBox )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pCbPreviewBox->Check( bChecked );
		}
        break;
    case ExtendedFilePickerElementIds::CHECKBOX_SELECTION :
		if ( _pCbSelection )
        {
			sal_Bool bChecked = sal_False;
			if ( rValue >>= bChecked )
                _pCbSelection->Check( bChecked );
		}
        break;

    case CommonFilePickerElementIds::PUSHBUTTON_OK :
        break;
	case CommonFilePickerElementIds::PUSHBUTTON_CANCEL :
        break;
	case ExtendedFilePickerElementIds::PUSHBUTTON_PLAY :
        break;

    case CommonFilePickerElementIds::LISTBOX_FILTER :
		{
            DBG_ERRORFILE( "Use the XFilterManager to access the filter listbox" );
		}
        break;
    case ExtendedFilePickerElementIds::LISTBOX_VERSION :
		if ( _pImp->_pLbFileVersion )
        {
			SetListboxValue( _pImp->_pLbFileVersion, nCtrlAction, rValue );
		}
        break;
	case ExtendedFilePickerElementIds::LISTBOX_TEMPLATE :
		// the version Box will be reused here
        if ( _pImp->_pLbFileVersion )
        {
			SetListboxValue( _pImp->_pLbFileVersion, nCtrlAction, rValue );
		}
        break;
	case ExtendedFilePickerElementIds::LISTBOX_IMAGE_TEMPLATE :
		// the version Box will be reused here
        if ( _pImp->_pLbFileVersion )
        {
			SetListboxValue( _pImp->_pLbFileVersion, nCtrlAction, rValue );
		}
        break;
    default:
        DBG_ERRORFILE( "SvtFileDialog_Impl::SetValue(): Unknown ID" );
    }
}

//-----------------------------------------------------------------------------
Any SvtFileDialog_Impl::GetValue( sal_Int16 nId,
                                  sal_Int16 nCtrlAction ) const
{
	Any aRet;

    switch ( nId )
	{
	case ExtendedFilePickerElementIds::CHECKBOX_AUTOEXTENSION :
		if ( _pImp->_pCbAutoExtension )
        {
			sal_Bool bChecked = _pImp->_pCbAutoExtension->IsChecked();
			aRet <<= bChecked;
        }
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PASSWORD :
		if ( _pImp->_pCbPassword )
        {
			sal_Bool bChecked = _pImp->_pCbPassword->IsChecked();
			aRet <<= bChecked;
        }
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_FILTEROPTIONS :
		if ( _pImp->_pCbOptions )
        {
			sal_Bool bChecked = _pImp->_pCbOptions->IsChecked();
			aRet <<= bChecked;
        }
        break;
    case ExtendedFilePickerElementIds::CHECKBOX_READONLY :
		if ( _pCbReadOnly )
        {
			sal_Bool bChecked = _pCbReadOnly->IsChecked();
			aRet <<= bChecked;
		}
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_LINK :
		if ( _pCbLinkBox )
        {
			sal_Bool bChecked = _pCbLinkBox->IsChecked();
			aRet <<= bChecked;
		}
        break;
    case ExtendedFilePickerElementIds::CHECKBOX_PREVIEW :
		if ( _pCbPreviewBox )
        {
			sal_Bool bChecked = _pCbPreviewBox->IsChecked();
			aRet <<= bChecked;
		}
        break;
    case ExtendedFilePickerElementIds::CHECKBOX_SELECTION :
		if ( _pCbSelection )
        {
			sal_Bool bChecked = _pCbSelection->IsChecked();
			aRet <<= bChecked;
		}
        break;

	case CommonFilePickerElementIds::PUSHBUTTON_OK :
        break;
	case CommonFilePickerElementIds::PUSHBUTTON_CANCEL :
        break;
	case ExtendedFilePickerElementIds::PUSHBUTTON_PLAY :
        break;

	case CommonFilePickerElementIds::LISTBOX_FILTER :
		{
            if( nCtrlAction == ListboxControlActions::GET_ITEMS )
            {
                DBG_ERRORFILE( "Use the XFilterManager to access the filter listbox" );
            }
            else if ( nCtrlAction == ListboxControlActions::GET_SELECTED_ITEM )
            {
                OUString aFilter = GetCurFilter();
                aRet <<= aFilter;
            }
        }
        break;
    case ExtendedFilePickerElementIds::LISTBOX_VERSION :
        if ( _pImp->_pLbFileVersion )
        {
            aRet = GetListboxValue( _pImp->_pLbFileVersion, nCtrlAction );
        }
        break;
    case ExtendedFilePickerElementIds::LISTBOX_TEMPLATE :
		// the vesion Box will be reused here
        if ( _pImp->_pLbFileVersion )
        {
            aRet = GetListboxValue( _pImp->_pLbFileVersion, nCtrlAction );
        }
        break;
    case ExtendedFilePickerElementIds::LISTBOX_IMAGE_TEMPLATE :
		// the version Box will be reused here
        if ( _pImp->_pLbFileVersion )
        {
            aRet = GetListboxValue( _pImp->_pLbFileVersion, nCtrlAction );
		}
        break;
    default:
        DBG_ERRORFILE( "SvtFileDialog_Impl::GetValue(): Unknown ID" );
    }

    return aRet;
}

//-----------------------------------------------------------------------------
void SvtFileDialog_Impl::SetLabel( sal_Int16 nId, const OUString &rLabel )
{
    switch ( nId )
	{
	case ExtendedFilePickerElementIds::CHECKBOX_AUTOEXTENSION :
		if ( _pImp->_pCbAutoExtension )
            _pImp->_pCbAutoExtension->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PASSWORD :
		if ( _pImp->_pCbPassword )
            _pImp->_pCbPassword->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_FILTEROPTIONS :
		if ( _pImp->_pCbOptions )
            _pImp->_pCbOptions->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_READONLY :
        if ( _pCbReadOnly )
            _pCbReadOnly->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_LINK :
		if ( _pCbLinkBox )
            _pCbLinkBox->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PREVIEW :
		if ( _pCbPreviewBox )
            _pCbPreviewBox->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_SELECTION :
		if ( _pCbSelection )
            _pCbSelection->SetText( rLabel );
        break;

    case CommonFilePickerElementIds::PUSHBUTTON_OK :
		if ( _pImp->_pBtnFileOpen )
            _pImp->_pBtnFileOpen->SetText( rLabel );
        break;
	case CommonFilePickerElementIds::PUSHBUTTON_CANCEL :
		if ( _pImp->_pBtnCancel )
            _pImp->_pBtnCancel->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::PUSHBUTTON_PLAY :
		if ( _pPbPlay )
            _pPbPlay->SetText( rLabel );
        break;

    case CommonFilePickerElementIds::LISTBOX_FILTER :
		if ( _pImp->_pFtFileType )
            _pImp->_pFtFileType->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::LISTBOX_VERSION :
		if ( _pImp->_pFtFileVersion )
            _pImp->_pFtFileVersion->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::LISTBOX_TEMPLATE :
		if ( _pImp->_pFtFileVersion )
            _pImp->_pFtFileVersion->SetText( rLabel );
        break;
	case ExtendedFilePickerElementIds::LISTBOX_IMAGE_TEMPLATE :
		if ( _pImp->_pFtFileVersion )
            _pImp->_pFtFileVersion->SetText( rLabel );
        break;
    default:
        DBG_ERRORFILE( "SvtFileDialog_Impl::SetLabel(): Unknown ID" );
	}
}

//-----------------------------------------------------------------------------
OUString SvtFileDialog_Impl::GetLabel( sal_Int16 nId ) const
{
    OUString aLabel;

    switch ( nId )
	{
	case ExtendedFilePickerElementIds::CHECKBOX_AUTOEXTENSION :
		if ( _pImp->_pCbAutoExtension )
            aLabel = _pImp->_pCbAutoExtension->GetText();
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PASSWORD :
		if ( _pImp->_pCbPassword )
            aLabel = _pImp->_pCbPassword->GetText();
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_FILTEROPTIONS :
		if ( _pImp->_pCbOptions )
            aLabel = _pImp->_pCbOptions->GetText();
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_READONLY :
		if ( _pCbReadOnly )
            aLabel = _pCbReadOnly->GetText();
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_LINK :
		if ( _pCbLinkBox )
            aLabel = _pCbLinkBox->GetText();
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PREVIEW :
		if ( _pCbPreviewBox )
            aLabel = _pCbPreviewBox->GetText();
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_SELECTION :
		if ( _pCbSelection )
            aLabel = _pCbSelection->GetText();
        break;

	case CommonFilePickerElementIds::PUSHBUTTON_OK :
		if ( _pImp->_pBtnFileOpen )
            aLabel = _pImp->_pBtnFileOpen->GetText();
        break;
	case CommonFilePickerElementIds::PUSHBUTTON_CANCEL :
		if ( _pImp->_pBtnCancel )
            aLabel = _pImp->_pBtnCancel->GetText();
        break;
	case ExtendedFilePickerElementIds::PUSHBUTTON_PLAY :
		if ( _pPbPlay )
            aLabel = _pPbPlay->GetText();
        break;

    case CommonFilePickerElementIds::LISTBOX_FILTER :
		if ( _pImp->_pFtFileType )
            aLabel = _pImp->_pFtFileType->GetText();
        break;
	case ExtendedFilePickerElementIds::LISTBOX_VERSION :
		if ( _pImp->_pFtFileVersion )
            aLabel = _pImp->_pFtFileVersion->GetText();
        break;
    case ExtendedFilePickerElementIds::LISTBOX_TEMPLATE :
		if ( _pImp->_pFtFileVersion )
            aLabel = _pImp->_pFtFileVersion->GetText();
        break;
    case ExtendedFilePickerElementIds::LISTBOX_IMAGE_TEMPLATE :
		if ( _pImp->_pFtFileVersion )
            aLabel = _pImp->_pFtFileVersion->GetText();
        break;
    default:
        DBG_ERRORFILE( "SvtFileDialog_Impl::GetLabel(): Unknown ID" );
	}

    return aLabel;
}

//-----------------------------------------------------------------------------
void SvtFileDialog_Impl::EnableControl( sal_Int16 nId, sal_Bool bEnable )
{
    switch ( nId )
	{
	case ExtendedFilePickerElementIds::CHECKBOX_AUTOEXTENSION :
		if ( _pImp->_pCbAutoExtension )
            _pImp->_pCbAutoExtension->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PASSWORD :
		if ( _pImp->_pCbPassword )
            _pImp->_pCbPassword->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_FILTEROPTIONS :
		if ( _pImp->_pCbOptions )
            _pImp->_pCbOptions->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_READONLY :
		if ( _pCbReadOnly )
            _pCbReadOnly->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_LINK :
		if ( _pCbLinkBox )
             _pCbLinkBox->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_PREVIEW :
		if ( _pCbPreviewBox )
            _pCbPreviewBox->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::CHECKBOX_SELECTION :
		if ( _pCbSelection )
            _pCbSelection->Enable( bEnable );
        break;

	case CommonFilePickerElementIds::PUSHBUTTON_OK :
		if ( _pImp->_pBtnFileOpen )
            _pImp->_pBtnFileOpen->Enable( bEnable );
        break;
	case CommonFilePickerElementIds::PUSHBUTTON_CANCEL :
		if ( _pImp->_pBtnCancel )
            _pImp->_pBtnCancel->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::PUSHBUTTON_PLAY :
		if ( _pPbPlay )
            _pPbPlay->Enable( bEnable );
        break;

    case CommonFilePickerElementIds::LISTBOX_FILTER :
		if ( _pImp->_pFtFileType )
            _pImp->_pFtFileType->Enable( bEnable );
		if ( _pImp->_pLbFilter )
            _pImp->_pLbFilter->Enable( bEnable );
        break;
	case ExtendedFilePickerElementIds::LISTBOX_VERSION :
		if ( _pImp->_pFtFileVersion )
            _pImp->_pFtFileVersion->Enable( bEnable );
		if ( _pImp->_pLbFileVersion )
            _pImp->_pLbFileVersion->Enable( bEnable );
        break;
    case ExtendedFilePickerElementIds::LISTBOX_TEMPLATE :
		if ( _pImp->_pFtFileVersion )
            _pImp->_pFtFileVersion->Enable( bEnable );
		if ( _pImp->_pLbFileVersion )
            _pImp->_pLbFileVersion->Enable( bEnable );
        break;
    case ExtendedFilePickerElementIds::LISTBOX_IMAGE_TEMPLATE :
		if ( _pImp->_pFtFileVersion )
            _pImp->_pFtFileVersion->Enable( bEnable );
		if ( _pImp->_pLbFileVersion )
            _pImp->_pLbFileVersion->Enable( bEnable );
        break;
    default:
        DBG_ERRORFILE( "SvtFileDialog_Impl::GetLabel(): Unknown ID" );
	}
}

// -----------------------------------------------------------------------
void SvtFileDialog_Impl::AddControls_Impl( ULONG nExtra )
{
	// create the "insert as link" checkbox, if needed
    if ( nExtra & SFX_EXTRA_INSERTASLINK )
	{
		_pCbLinkBox = new CheckBox( this );
        _pCbLinkBox ->SetText( SvtResId( STR_SVT_FILEPICKER_INSERT_AS_LINK ) );
		_pCbLinkBox ->SetHelpId( HID_FILEDLG_LINK_CB );
		AddControl( _pCbLinkBox  );
		ReleaseOwnerShip( _pCbLinkBox );
		_pCbLinkBox->SetClickHdl( LINK( this, SvtFileDialog_Impl, ClickHdl_Impl ) );
	}

	// create the "show preview" checkbox ( and the preview window, too ), if needed
	if ( nExtra & SFX_EXTRA_SHOWPREVIEW  )
    {
    	_pImp->_aIniKey = IMPGRF_CONFIGNAME;

        // "Vorschau"
	    _pCbPreviewBox = new CheckBox( this );
	    _pCbPreviewBox->SetText( SvtResId( STR_SVT_FILEPICKER_SHOW_PREVIEW ) );
	    _pCbPreviewBox->SetHelpId( HID_FILEDLG_PREVIEW_CB );
	    AddControl( _pCbPreviewBox );
		ReleaseOwnerShip( _pCbPreviewBox );
		_pCbPreviewBox->SetClickHdl( LINK( this, SvtFileDialog_Impl, ClickHdl_Impl ) );

	    // Preview-Fenster erst hier erzeugen
	    _pPrevWin = new Window( this, WinBits( WB_BORDER ) );
	    AddControl( _pPrevWin );
		ReleaseOwnerShip( _pPrevWin );
        _pPrevWin->Hide();

        _pPrevBmp = new FixedBitmap( this, WinBits( WB_BORDER ) );
	    _pPrevBmp->SetBackground( Wallpaper( Color( COL_WHITE ) ) );
        _pPrevBmp->Show();
    }

    if ( nExtra & SFX_EXTRA_AUTOEXTENSION )
    {
		_pImp->_pCbAutoExtension = new CheckBox( this, SvtResId( CB_AUTO_EXTENSION ) );
	    _pImp->_pCbAutoExtension->SetText( SvtResId( STR_SVT_FILEPICKER_AUTO_EXTENSION ) );
		_pImp->_pCbAutoExtension->Check( TRUE );
		AddControl( _pImp->_pCbAutoExtension );
		ReleaseOwnerShip( _pImp->_pCbAutoExtension );
		_pImp->_pCbAutoExtension->SetClickHdl( LINK( this, SvtFileDialog_Impl, AutoExtensionHdl_Impl ) );
    }

    if ( nExtra & SFX_EXTRA_FILTEROPTIONS )
	{
		_pImp->_pCbOptions = new CheckBox( this, SvtResId( CB_OPTIONS ) );
	    _pImp->_pCbOptions->SetText( SvtResId( STR_SVT_FILEPICKER_FILTER_OPTIONS ) );
		AddControl( _pImp->_pCbOptions );
		ReleaseOwnerShip( _pImp->_pCbOptions );
		_pImp->_pCbOptions->SetClickHdl( LINK( this, SvtFileDialog_Impl, ClickHdl_Impl ) );
	}

    if ( nExtra & SFX_EXTRA_SELECTION )
	{
        _pCbSelection = new CheckBox( this, SvtResId( CB_OPTIONS ) );
	    _pCbSelection->SetText( SvtResId( STR_SVT_FILEPICKER_SELECTION ) );
		AddControl( _pCbSelection );
		ReleaseOwnerShip( _pCbSelection );
		_pCbSelection->SetClickHdl( LINK( this, SvtFileDialog_Impl, ClickHdl_Impl ) );
	}

    if ( nExtra & SFX_EXTRA_PLAYBUTTON )
	{
		_pPbPlay = new PushButton( this );
	    _pPbPlay->SetText( SvtResId( STR_SVT_FILEPICKER_PLAY ) );
		AddControl( _pPbPlay );
		ReleaseOwnerShip( _pPbPlay );
		_pPbPlay->SetClickHdl( LINK( this, SvtFileDialog_Impl, PlayButtonHdl_Impl ) );
	}

    if ( nExtra & SFX_EXTRA_TEMPLATES )
	{
		_pImp->_pFtFileVersion->SetText( SvtResId( STR_SVT_FILEPICKER_TEMPLATES ) );
	}
    else if ( nExtra & SFX_EXTRA_IMAGE_TEMPLATE )
	{
		_pImp->_pFtFileVersion->SetText( SvtResId( STR_SVT_FILEPICKER_IMAGE_TEMPLATE ) );
	}
}

// -----------------------------------------------------------------------
void SvtFileDialog_Impl::SetListboxValue( ListBox* pListbox,
                                          sal_Int16 nCtrlAction,
                                          const Any& rValue )
{
    switch ( nCtrlAction ) {
    case ListboxControlActions::ADD_ITEM:
        {
            OUString aEntry;
            rValue >>= aEntry;
            if ( aEntry.getLength() )
                pListbox->InsertEntry( aEntry );
        }
        break;
    case ListboxControlActions::ADD_ITEMS:
        {
			Sequence < OUString > aTemplateList;
			rValue >>= aTemplateList;

			if ( aTemplateList.getLength() )
			{
				for ( long i=0; i < aTemplateList.getLength(); i++ )
					pListbox->InsertEntry( aTemplateList[i] );
			}
        }
        break;
    case ListboxControlActions::DELETE_ITEM:
        {
            sal_Int32 nPos;
            if ( rValue >>= nPos )
                pListbox->RemoveEntry( (USHORT) nPos );
        }
        break;
    case ListboxControlActions::DELETE_ITEMS:
		pListbox->Clear();
        break;
    case ListboxControlActions::SET_SELECT_ITEM:
        {
            sal_Int32 nPos;
            if ( rValue >>= nPos )
                pListbox->SelectEntryPos( (USHORT) nPos );
        }
        break;
    default:
        DBG_ERRORFILE( "Wrong ControlAction for SetListboxValue()" );
    }
}

// -----------------------------------------------------------------------
Any SvtFileDialog_Impl::GetListboxValue( ListBox* pListbox,
                                         sal_Int16 nCtrlAction ) const
{
    Any aRet;

    switch ( nCtrlAction ) {
    case ListboxControlActions::GET_ITEMS:
        {
            USHORT nCount = pListbox->GetEntryCount();
            Sequence < OUString > aList( nCount );

            for ( USHORT i=0; i<nCount; i++ )
            {
                aList[i] = pListbox->GetEntry( i );
            }

            aRet <<= aList;
        }
        break;
    case ListboxControlActions::GET_SELECTED_ITEM:
        {
            USHORT nPos = pListbox->GetSelectEntryPos();
            if ( nPos != LISTBOX_ENTRY_NOTFOUND )
            {
                OUString aEntry = pListbox->GetEntry( nPos );
                aRet <<= aEntry;
            }
        }
        break;
    default:
        DBG_ERRORFILE( "Wrong ControlAction for GetListboxValue()" );
    }

    return aRet;
}

// -----------------------------------------------------------------------
sal_Int32 SvtFileDialog_Impl::getTargetColorDepth()
{
    if ( _pPrevBmp )
        return _pPrevBmp->GetBitCount();
    else
        return 0;
}

// -----------------------------------------------------------------------
sal_Int32 SvtFileDialog_Impl::getAvailableWidth()
{
    if ( _pPrevBmp )
        return _pPrevBmp->GetOutputSizePixel().Width();
    else
        return 0;
}

// -----------------------------------------------------------------------
sal_Int32 SvtFileDialog_Impl::getAvailableHeight()
{
    if ( _pPrevBmp )
        return _pPrevBmp->GetOutputSizePixel().Height();
    else
        return 0;
}

// -----------------------------------------------------------------------
void SvtFileDialog_Impl::setImage( sal_Int16 aImageFormat,
                                   const Any& rImage )
{
    if ( ! _pPrevBmp || ! _pPrevBmp->IsVisible() )
        return;

    Sequence < sal_Int8 > aBmpSequence;

    if ( rImage >>= aBmpSequence )
    {
        Bitmap          aBmp;
        SvMemoryStream  aData( aBmpSequence.getArray(),
                               aBmpSequence.getLength(),
                               STREAM_READ );
        aData >> aBmp;

        _pPrevBmp->SetBitmap( aBmp );
    }
    else
    {
        Bitmap aEmpty;
        _pPrevBmp->SetBitmap( aEmpty );
    }
}

// -----------------------------------------------------------------------
sal_Bool SvtFileDialog_Impl::setShowState( sal_Bool bShowState )
{
    if ( _pPrevBmp )
    {
        _pPrevBmp->Show( bShowState );
        return sal_True;
    }
    else
        return sal_False;
}

// -----------------------------------------------------------------------
sal_Bool SvtFileDialog_Impl::getShowState()
{
    if ( _pPrevBmp )
        return _pPrevBmp->IsVisible();
    else
        return sal_False;
}

// -----------------------------------------------------------------------
OUString SvtFileDialog_Impl::GetLastDir_Impl() const
{
    OUString aLastDir;

//    DBG_ERRORFILE( "Not implemented yet!" );

    return aLastDir;
}

// -----------------------------------------------------------------------
void SvtFileDialog_Impl::SetLastDir_Impl( const OUString& rLastDir )
{
//    DBG_ERRORFILE( "Not implemented yet!" );
}

// QueryFolderNameDialog -------------------------------------------------------

namespace svtools {

QueryFolderNameDialog::QueryFolderNameDialog
(
	const String& rTitle,
	const String& rDefaultText,
	String* pGroupName
) :
	ModalDialog( GetpApp()->GetDefModalDialogParent(), SvtResId( DLG_SVT_QUERYFOLDERNAME ) ),

	aNameText	( this, SvtResId( FT_SVT_QUERYFOLDERNAME_DLG_NAME ) ),
	aNameEdit	( this, SvtResId( ED_SVT_QUERYFOLDERNAME_DLG_NAME ) ),
	aNameLine	( this, SvtResId( FL_SVT_QUERYFOLDERNAME_DLG_NAME ) ),
	aOKBtn		( this, SvtResId( BT_SVT_QUERYFOLDERNAME_DLG_OK ) ),
	aCancelBtn	( this, SvtResId( BT_SVT_QUERYFOLDERNAME_DLG_CANCEL ) )
{
	FreeResource();
	SetText( rTitle );
	aNameEdit.SetText( rDefaultText );
	aNameEdit.SetSelection( Selection( 0, rDefaultText.Len() ) );
	aOKBtn.SetClickHdl( LINK( this, QueryFolderNameDialog, OKHdl ) );
	aNameEdit.SetModifyHdl( LINK( this, QueryFolderNameDialog, NameHdl ) );

	if ( pGroupName )
		aNameLine.SetText( *pGroupName );
};

// -----------------------------------------------------------------------
IMPL_LINK( QueryFolderNameDialog, OKHdl, Button *, EMPTYARG )
{
	// trim the strings
	aNameEdit.SetText( aNameEdit.GetText().EraseLeadingChars().EraseTrailingChars() );
	EndDialog( RET_OK );
	return 1;
}

// -----------------------------------------------------------------------
IMPL_LINK( QueryFolderNameDialog, NameHdl, Edit *, EMPTYARG )
{
	// trim the strings
	String aName = aNameEdit.GetText();
	aName.EraseLeadingChars().EraseTrailingChars();
	if ( aName.Len() )
	{
		if ( !aOKBtn.IsEnabled() )
			aOKBtn.Enable( TRUE );
	}
	else
	{
		if ( aOKBtn.IsEnabled() )
			aOKBtn.Enable( FALSE );
	}

	return 0;
}

}
