/*************************************************************************
 *
 *  $RCSfile: iodlg.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: dv $ $Date: 2001/07/17 12:56:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _IODLGIMPL_HXX
#define _IODLGIMPL_HXX

#ifndef  _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif

#ifndef _VCL_FILEDLG_HXX
#include <vcl/filedlg.hxx>
#endif
#ifndef _SV_BUTTON_HXX
#include <vcl/button.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX
#include <vcl/combobox.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _INETTYPE_HXX
#include "inettype.hxx"
#endif

//*****************************************************************************

class SvTabListBox;
class SvStringsDtor;
class SvtFileView;

//*****************************************************************************

#define SFXWB_INSERT			( 0x04000000L | WB_OPEN )
#define SFXWB_PASSWORD			WB_PASSWORD
#define SFXWB_READONLY			WB_READONLY
#define SFXWB_PATHDIALOG		WB_PATH
#define SFXWB_CLASSPATH			( 0x08000000L | SFXWB_PATHDIALOG )
#define SFXWB_SHOWALLFOLDER		0x10000000L		// alle Ordner auch Mail/News/...
#define SFXWB_MULTISELECTION	0x20000000L		// Multiselection an
#define SFXWB_NOREMOTE          0x40000000L
#define SFXWB_SHOWVERSIONS		0x80000000L  	// Versionsauswahl anzeigen

#define SFX_EXTRA_AUTOEXTENSION     0x00000001L
#define SFX_EXTRA_FILTEROPTIONS     0x00000002L
#define SFX_EXTRA_SHOWVERSIONS      0x00000004L
#define SFX_EXTRA_INSERTASLINK      0x00000008L
#define SFX_EXTRA_SHOWPREVIEW       0x00000010L
#define SFX_EXTRA_TEMPLATES         0x00000020L
#define SFX_EXTRA_PLAYBUTTON        0x00000040L
#define SFX_EXTRA_SELECTION         0x00000080L
#define SFX_EXTRA_IMAGE_TEMPLATE    0x00000100L

#define RET_MANAGER				100

#define FILEDIALOG_FILTER_ALL	"*.*"


//*****************************************************************************
// SvtFileDialog
//*****************************************************************************

class FileNotifyHelper_Impl;
class SvtExpFileDlg_Impl;

class SvtFileDialog_Impl : public VclFileDialog
{
private:
	CheckBox*					_pCbReadOnly;
	CheckBox*                   _pCbLinkBox;
	CheckBox*                   _pCbPreviewBox;
	CheckBox*                   _pCbSelection;
    PushButton*                 _pPbPlay;
	Window*                     _pPrevWin;
	FixedBitmap*                _pPrevBmp;
	SvtFileView*				_pFileView;
	FileNotifyHelper_Impl*		_pFileNotifier;
	SvtExpFileDlg_Impl*			_pImp;
    ULONG                       _nExtraBits;
    BOOL                        _bIsInExecute;

	static SvtFileDialog_Impl*	_pActiveDlg;

	DECL_STATIC_LINK( SvtFileDialog_Impl, FilterSelectHdl_Impl, ListBox* );
	DECL_STATIC_LINK( SvtFileDialog_Impl, NewFolderHdl_Impl, PushButton* );
	DECL_STATIC_LINK( SvtFileDialog_Impl, ViewHdl_Impl, ImageButton* );
	DECL_STATIC_LINK( SvtFileDialog_Impl, OpenHdl_Impl, void* );
	DECL_STATIC_LINK( SvtFileDialog_Impl, FileNameGetFocusHdl_Impl, void* );
	DECL_STATIC_LINK( SvtFileDialog_Impl, FileNameModifiedHdl_Impl, void* );

	void						Init_Impl( ULONG nBits, ULONG nExtraBits );
	BOOL						FindFilter_Impl( const String& rFilter,
												 BOOL bMultiExt,
												 BOOL& rbFilterChanged );
	void						ExecuteFilter();
	void						UpdateHistory_Impl();
	void						OpenMultiSelection_Impl();
	void						UpdateHistory();
	void						UpdateControls( const String& rURL );
    void                        AddControls_Impl( ULONG nEnable );
    rtl::OUString               GetLastDir_Impl() const;
    void                        SetLastDir_Impl( const rtl::OUString& rURL );

    void                        SetListboxValue( ListBox* pListbox,
                                                 sal_Int16 nCtrlAction,
                                                 const ::com::sun::star::uno::Any& rValue );
    ::com::sun::star::uno::Any  GetListboxValue( ListBox* pListbox,
                                                 sal_Int16 nCtrlAction ) const;

	DECL_LINK( SelectHdl_Impl, SvTabListBox* );
	DECL_LINK( DblClickHdl_Impl, SvTabListBox* );
	DECL_LINK( EntrySelectHdl_Impl, ComboBox* );
	DECL_LINK( OpenDoneHdl_Impl, SvtFileView* );
	DECL_LINK( ResetCursorHdl_Impl, Timer* );
	DECL_LINK( LocalFileSystemHdl_Impl, PushButton* );
	DECL_LINK( AutoExtensionHdl_Impl, CheckBox* );
	DECL_LINK( ClickHdl_Impl, CheckBox* );
	DECL_LINK( PlayButtonHdl_Impl, PushButton* );

	// entfernt einen Filter mit Wildcards aus dem Path und gibt in zurck
	BOOL IsolateFilterFromPath_Impl( String& rPath, String& rFilter );

protected:
	virtual long				Notify( NotifyEvent& rNEvt );
	void						EnableInternet( BOOL bInternet );

public:
								SvtFileDialog_Impl( ULONG nBits,
									                ULONG nExtraBits );
								SvtFileDialog_Impl( ULONG nBits );
								~SvtFileDialog_Impl();

	virtual long				OK();
	virtual short				Execute();

	virtual void				FileSelect();
	virtual void				FilterSelect();

	void						SetStandardDir( const String& rStdDir );
	const String&				GetStandardDir() const;
	const String&				GetViewURL() const;
	SvStringsDtor*				GetPathList() const;		// bei MultiSelektion

	virtual void				AddFilter( const String& rFilter,
										   const String& rType, ULONG nFlags = 0 );
	virtual void				AddFilter( const String& rFilter,
										   const String& rType,
										   const String& rSysType, ULONG nFlags = 0 );

	virtual void				RemoveFilter( const String& rFilter );
	virtual void				RemoveAllFilter();
	virtual void				SetCurFilter( const String& rFilter );
	virtual String				GetCurFilter() const;
	virtual USHORT				GetFilterCount() const;
	virtual const String&		GetFilterName( USHORT nPos ) const;
	virtual const String&		GetFilterType( USHORT nPos ) const;
	virtual ULONG				GetFilterFlags( USHORT nPos ) const;
	virtual void				Resize();

	void						PrevLevel_Impl();
	void						OpenURL_Impl( const String& rURL );

	inline SvtFileView*			GetView() const;

	inline static SvtFileDialog_Impl* GetActive();

	void						SetDefaultButtonText( const XubString& rText, ULONG nHelpId = 0 );
	void						DisableSaveLastDirectory();
	void                        InitSize();
	void						SetFocusInViewControl();

	void						SetPathURL( const XubString& rPathURL );

	Image*						GetFolderImage() const;

	void						SetFileCallback( FileNotifyHelper_Impl *pNotifier ) { _pFileNotifier = pNotifier; }

    void						SetValue( sal_Int16 nId, sal_Int16 nCtrlAction, const ::com::sun::star::uno::Any &rValue );
	::com::sun::star::uno::Any  GetValue( sal_Int16 nId, sal_Int16 nCtrlAction ) const;

    void						SetLabel( sal_Int16 nId, const ::rtl::OUString &rValue );
    ::rtl::OUString             GetLabel( sal_Int16 nId ) const;

    void                        EnableControl( sal_Int16 nId, sal_Bool bEnable );

    sal_Int32                   getTargetColorDepth();
    sal_Int32                   getAvailableWidth();
    sal_Int32                   getAvailableHeight();
    void                        setImage( sal_Int16 aImageFormat, const ::com::sun::star::uno::Any& rImage );
    sal_Bool                    setShowState( sal_Bool bShowState );
    sal_Bool                    getShowState();
};

//*****************************************************************************

inline SvtFileDialog_Impl* SvtFileDialog_Impl::GetActive()
{
	return _pActiveDlg;
}

//*****************************************************************************

inline SvtFileView* SvtFileDialog_Impl::GetView() const
{
	return _pFileView;
}

//*****************************************************************************
//*****************************************************************************
//*****************************************************************************

class SvtFilePicker_Impl;

#define FILE_SELECTION_CHANGED	1
#define DIRECTORY_CHANGED		2
#define HELP_REQUESTED			3
#define CTRL_STATE_CHANGED		4
#define DIALOG_SIZE_CHANGED		5

class FileNotifyHelper_Impl
{
	SvtFilePicker_Impl* 	mpParent;

public:
				FileNotifyHelper_Impl( SvtFilePicker_Impl* pParent ) : mpParent( pParent ) {}
				~FileNotifyHelper_Impl() {};

	void		Notify( short nEventId, short nControlId );
};

//-------------------------------------------------------------------------
namespace svtools {

//-------------------------------------------------------------------------
// QueryFolderNameDialog
//-------------------------------------------------------------------------

class QueryFolderNameDialog : public ModalDialog
{
private:
	FixedText		aNameText;
	Edit			aNameEdit;
	FixedLine		aNameLine;
	OKButton		aOKBtn;
	CancelButton	aCancelBtn;

	DECL_LINK( OKHdl, Button * );
	DECL_LINK( NameHdl, Edit * );

public:
					QueryFolderNameDialog(	const String& rTitle,
											const String& rDefaultText,
											String* pGroupName = NULL );
	String			GetName() const { return aNameEdit.GetText(); }
};

}

#endif // #ifndef _IODLG_HXX
