#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.7 $
#
#   last change: $Author: obr $ $Date: 2001/07/23 09:00:26 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..$/..$/..

PRJNAME=sysui
TARGET=cdeint

# --- Settings -----------------------------------------------------

.INCLUDE :  settings.mk

# --- Files --------------------------------------------------------

.IF "$(OS)"=="SOLARIS" || "$(OS)"=="LINUX"

UNIXTEXT= \
	$(MISC)$/dtint.sh

CDEFILES= \
    group.dt \
    group.fp \
	control.dt \
    control.fp \
    datatype.dt \
	locales.tab
	
ZIPBASEFILES= \
	cdegroup \
    cdewriter \
    cdecalc \
    cdedraw \
    cdeimpress \
	cdeplayer
    
	
LANGFLAGFILES=$(foreach,i,$(alllangext) $(foreach,j,$(ZIPBASEFILES) $(BIN)$/$(j:b).$i)) 


# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk

ALLTAR : CDEZIPFILES

.IF "$(LANGFLAGFILES)"!=""
CDEZIPFILES : $(LANGFLAGFILES) 

$(LANGFLAGFILES): $(CDEFILES) cdeint writer.lng calc.lng group.lng impress.lng draw.lng
    +@$(PERL) cdeint $(subst,$(@:e),$(@:e:s/.//).zip $@) $(@:e:s/.//) $(rescharset_$(@:e:s/.//))
    
.ENDIF # "$(LANGZIPFILES)"!=""
.ELSE          # "$(OS)"=="SOLARIS" || "$(OS)"=="LINUX"

nothing_to_do :
    @+-echo nothing to do here
    
.ENDIF          # "$(OS)"=="SOLARIS" || "$(OS)"=="LINUX"

