*** orig/dmake/dbug/malloc/mlc_chn.c	Sat Sep  9 18:36:36 2000
--- modified/dmake/dbug/malloc/mlc_chn.c	Sat Sep  9 18:36:36 2000
***************
*** 4,54 ****
   * copyright statement is not removed.
   */
  #include <stdio.h>
  #include <fcntl.h>
  #include "malloc.h"
  
  /*
   * Function:	malloc_chain_check()
   *
   * Purpose:	to verify malloc chain is intact
   *
   * Arguments:	todo	- 0 - just check and return status
   *			  1 - call malloc_warn if error detected
   *
   * Returns:	0	- malloc chain intact & no overflows
   *		other	- problems detected in malloc chain
   *
   * Narrative:
   *
   * Notes:	If todo is non-zero the malloc_warn function, when called
   *		may not return (i.e. it may exit)
   *
   */
  #ifndef lint
  static
! char rcs_hdr[] = "$Id: mlc_chn.c,v 1.1.1.1 1997/07/15 16:02:26 dvadura Exp $";
  #endif
  
  
  int
  malloc_chain_check(todo)
  	int		  todo;
  {
  	char			* func = "malloc_chain_check";
  	int			  i;
  	extern char		* malloc_data_start;
  	extern char		* malloc_data_end;
  	extern struct mlist 	* malloc_end;
  	extern int		  malloc_errno;
  	extern struct mlist	  malloc_start;
  	struct mlist		* oldptr;
  	struct mlist		* ptr;
  	int			  rtn = 0;
  
  	oldptr = &malloc_start;
  	for(ptr = malloc_start.next; ; ptr = ptr->next)
  	{
  		/*
  		 * Since the malloc chain is a forward only chain, any
  		 * pointer that we get should always be positioned in 
  		 * memory following the previous pointer.  If this is not
--- 4,54 ----
   * copyright statement is not removed.
   */
  #include <stdio.h>
  #include <fcntl.h>
  #include "malloc.h"
  
  /*
   * Function:	malloc_chain_check()
   *
   * Purpose:	to verify malloc chain is intact
   *
   * Arguments:	todo	- 0 - just check and return status
   *			  1 - call malloc_warn if error detected
   *
   * Returns:	0	- malloc chain intact & no overflows
   *		other	- problems detected in malloc chain
   *
   * Narrative:
   *
   * Notes:	If todo is non-zero the malloc_warn function, when called
   *		may not return (i.e. it may exit)
   *
   */
  #ifndef lint
  static
! char rcs_hdr[] = "$Id: mlc_chn.c,v 1.1.1.1 1997/09/22 14:51:11 hjs Exp $";
  #endif
  
  
  int
  malloc_chain_check(todo)
  	int		  todo;
  {
  	char			* func = "malloc_chain_check";
  	int			  i;
  	extern char		* malloc_data_start;
  	extern char		* malloc_data_end;
  	extern struct mlist 	* malloc_end;
  	extern int		  malloc_errno;
  	extern struct mlist	  malloc_start;
  	struct mlist		* oldptr;
  	struct mlist		* ptr;
  	int			  rtn = 0;
  
  	oldptr = &malloc_start;
  	for(ptr = malloc_start.next; ; ptr = ptr->next)
  	{
  		/*
  		 * Since the malloc chain is a forward only chain, any
  		 * pointer that we get should always be positioned in 
  		 * memory following the previous pointer.  If this is not
