*** orig/dmake/mac/dirbrk.c	Sat Sep  9 18:36:36 2000
--- modified/dmake/mac/dirbrk.c	Sat Sep  9 18:36:36 2000
***************
*** 1,43 ****
! /* RCS  $Id: dirbrk.c,v 1.1.1.1 1997/07/15 16:02:26 dvadura Exp $
  --
  -- SYNOPSIS
  --      Define the directory separator string.
  -- 
  -- DESCRIPTION
  --  Define this string for any character that may appear in a path name
  --  and can be used as a directory separator.
  --
  -- AUTHOR
  --      Dennis Vadura, dvadura@dmake.wticorp.com
  --
  -- WWW
  --      http://dmake.wticorp.com/
  --
  -- COPYRIGHT
  --      Copyright (c) 1996,1997 by WTI Corp.  All rights reserved.
  -- 
  --      This program is NOT free software; you can redistribute it and/or
  --      modify it under the terms of the Software License Agreement Provided
  --      in the file <distribution-root>/readme/license.txt.
  --
  -- LOG
  --      Use cvs log to obtain detailed change logs.
  */
  
  #include "extern.h"
  
  /* mac only uses ':' */
  char*   DirBrkStr = ":";
  
  /*
  ** Return TRUE if the name is the full specification of a path name to a file
  ** starting at the root of the file system, otherwise return FALSE
  */
  PUBLIC int
  If_root_path(name)
  char *name;
  {
-    name = Unix2MacFName (name);
     return( (strchr(name, ':') != NIL(char)) &&
             (name[0] != ':') );
  }
--- 1,42 ----
! /* RCS  $Id: dirbrk.c,v 1.2 2000/02/15 12:32:22 mh Exp $
  --
  -- SYNOPSIS
  --      Define the directory separator string.
  -- 
  -- DESCRIPTION
  --  Define this string for any character that may appear in a path name
  --  and can be used as a directory separator.
  --
  -- AUTHOR
  --      Dennis Vadura, dvadura@dmake.wticorp.com
  --
  -- WWW
  --      http://dmake.wticorp.com/
  --
  -- COPYRIGHT
  --      Copyright (c) 1996,1997 by WTI Corp.  All rights reserved.
  -- 
  --      This program is NOT free software; you can redistribute it and/or
  --      modify it under the terms of the Software License Agreement Provided
  --      in the file <distribution-root>/readme/license.txt.
  --
  -- LOG
  --      Use cvs log to obtain detailed change logs.
  */
  
  #include "extern.h"
  
  /* mac only uses ':' */
  char*   DirBrkStr = ":";
  
  /*
  ** Return TRUE if the name is the full specification of a path name to a file
  ** starting at the root of the file system, otherwise return FALSE
  */
  PUBLIC int
  If_root_path(name)
  char *name;
  {
     return( (strchr(name, ':') != NIL(char)) &&
             (name[0] != ':') );
  }
