*** orig/zlib-1.1.3/zutil.c	Sat Aug 26 22:17:47 2000
--- modified/zlib-1.1.3/zutil.c	Sat Aug 26 22:17:47 2000
***************
*** 1,99 ****
  /* zutil.c -- target dependent utility functions for the compression library
!  * Copyright (C) 1995-1998 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
! /* @(#) $Id$ */
  
  #include "zutil.h"
  
  struct internal_state      {int dummy;}; /* for buggy compilers */
  
  #ifndef STDC
  extern void exit OF((int));
  #endif
  
  const char *z_errmsg[10] = {
  "need dictionary",     /* Z_NEED_DICT       2  */
  "stream end",          /* Z_STREAM_END      1  */
  "",                    /* Z_OK              0  */
  "file error",          /* Z_ERRNO         (-1) */
  "stream error",        /* Z_STREAM_ERROR  (-2) */
  "data error",          /* Z_DATA_ERROR    (-3) */
  "insufficient memory", /* Z_MEM_ERROR     (-4) */
  "buffer error",        /* Z_BUF_ERROR     (-5) */
  "incompatible version",/* Z_VERSION_ERROR (-6) */
  ""};
  
  
! const char * ZEXPORT zlibVersion()
  {
      return ZLIB_VERSION;
  }
  
  #ifdef DEBUG
- 
- #  ifndef verbose
- #    define verbose 0
- #  endif
- int z_verbose = verbose;
- 
  void z_error (m)
      char *m;
  {
      fprintf(stderr, "%s\n", m);
      exit(1);
  }
  #endif
  
- /* exported to allow conversion of error code to string for compress() and
-  * uncompress()
-  */
- const char * ZEXPORT zError(err)
-     int err;
- {
-     return ERR_MSG(err);
- }
- 
- 
  #ifndef HAVE_MEMCPY
  
  void zmemcpy(dest, source, len)
      Bytef* dest;
!     const Bytef* source;
      uInt  len;
  {
      if (len == 0) return;
      do {
          *dest++ = *source++; /* ??? to be unrolled */
      } while (--len != 0);
  }
  
  int zmemcmp(s1, s2, len)
!     const Bytef* s1;
!     const Bytef* s2;
      uInt  len;
  {
      uInt j;
  
      for (j = 0; j < len; j++) {
          if (s1[j] != s2[j]) return 2*(s1[j] > s2[j])-1;
      }
      return 0;
  }
  
  void zmemzero(dest, len)
      Bytef* dest;
      uInt  len;
  {
      if (len == 0) return;
      do {
          *dest++ = 0;  /* ??? to be unrolled */
      } while (--len != 0);
  }
  #endif
  
  #ifdef __TURBOC__
  #if (defined( __BORLANDC__) || !defined(SMALL_MEDIUM)) && !defined(__32BIT__)
  /* Small and medium model in Turbo C are for now limited to near allocation
   * with reduced MAX_WBITS and MAX_MEM_LEVEL
--- 1,85 ----
  /* zutil.c -- target dependent utility functions for the compression library
!  * Copyright (C) 1995-1996 Jean-loup Gailly.
   * For conditions of distribution and use, see copyright notice in zlib.h 
   */
  
! /* $Id: zutil.c,v 1.1 2000/06/28 17:43:47 sj Exp $ */
! 
! #include <stdio.h>
  
  #include "zutil.h"
  
  struct internal_state      {int dummy;}; /* for buggy compilers */
  
  #ifndef STDC
  extern void exit OF((int));
  #endif
  
  const char *z_errmsg[10] = {
  "need dictionary",     /* Z_NEED_DICT       2  */
  "stream end",          /* Z_STREAM_END      1  */
  "",                    /* Z_OK              0  */
  "file error",          /* Z_ERRNO         (-1) */
  "stream error",        /* Z_STREAM_ERROR  (-2) */
  "data error",          /* Z_DATA_ERROR    (-3) */
  "insufficient memory", /* Z_MEM_ERROR     (-4) */
  "buffer error",        /* Z_BUF_ERROR     (-5) */
  "incompatible version",/* Z_VERSION_ERROR (-6) */
  ""};
  
  
! const char *zlibVersion()
  {
      return ZLIB_VERSION;
  }
  
  #ifdef DEBUG
  void z_error (m)
      char *m;
  {
      fprintf(stderr, "%s\n", m);
      exit(1);
  }
  #endif
  
  #ifndef HAVE_MEMCPY
  
  void zmemcpy(dest, source, len)
      Bytef* dest;
!     Bytef* source;
      uInt  len;
  {
      if (len == 0) return;
      do {
          *dest++ = *source++; /* ??? to be unrolled */
      } while (--len != 0);
  }
  
  int zmemcmp(s1, s2, len)
!     Bytef* s1;
!     Bytef* s2;
      uInt  len;
  {
      uInt j;
  
      for (j = 0; j < len; j++) {
          if (s1[j] != s2[j]) return 2*(s1[j] > s2[j])-1;
      }
      return 0;
  }
  
  void zmemzero(dest, len)
      Bytef* dest;
      uInt  len;
  {
      if (len == 0) return;
      do {
          *dest++ = 0;  /* ??? to be unrolled */
      } while (--len != 0);
  }
  #endif
  
  #ifdef __TURBOC__
  #if (defined( __BORLANDC__) || !defined(SMALL_MEDIUM)) && !defined(__32BIT__)
  /* Small and medium model in Turbo C are for now limited to near allocation
   * with reduced MAX_WBITS and MAX_MEM_LEVEL
***************
*** 156,206 ****
          return;
      }
      /* Find the original pointer */
      for (n = 0; n < next_ptr; n++) {
          if (ptr != table[n].new_ptr) continue;
  
          farfree(table[n].org_ptr);
          while (++n < next_ptr) {
              table[n-1] = table[n];
          }
          next_ptr--;
          return;
      }
      ptr = opaque; /* just to make some compilers happy */
      Assert(0, "zcfree: ptr not found");
  }
  #endif
  #endif /* __TURBOC__ */
  
  
  #if defined(M_I86) && !defined(__32BIT__)
  /* Microsoft C in 16-bit mode */
  
  #  define MY_ZCALLOC
  
! #if (!defined(_MSC_VER) || (_MSC_VER <= 600))
  #  define _halloc  halloc
  #  define _hfree   hfree
  #endif
  
  voidpf zcalloc (voidpf opaque, unsigned items, unsigned size)
  {
      if (opaque) opaque = 0; /* to make compiler happy */
      return _halloc((long)items, size);
  }
  
  void  zcfree (voidpf opaque, voidpf ptr)
  {
      if (opaque) opaque = 0; /* to make compiler happy */
      _hfree(ptr);
  }
  
  #endif /* MSC */
  
  
  #ifndef MY_ZCALLOC /* Any system without a special alloc function */
  
  #ifndef STDC
  extern voidp  calloc OF((uInt items, uInt size));
  extern void   free   OF((voidpf ptr));
  #endif
--- 142,192 ----
          return;
      }
      /* Find the original pointer */
      for (n = 0; n < next_ptr; n++) {
          if (ptr != table[n].new_ptr) continue;
  
          farfree(table[n].org_ptr);
          while (++n < next_ptr) {
              table[n-1] = table[n];
          }
          next_ptr--;
          return;
      }
      ptr = opaque; /* just to make some compilers happy */
      Assert(0, "zcfree: ptr not found");
  }
  #endif
  #endif /* __TURBOC__ */
  
  
  #if defined(M_I86) && !defined(__32BIT__)
  /* Microsoft C in 16-bit mode */
  
  #  define MY_ZCALLOC
  
! #if (!defined(_MSC_VER) || (_MSC_VER < 600))
  #  define _halloc  halloc
  #  define _hfree   hfree
  #endif
  
  voidpf zcalloc (voidpf opaque, unsigned items, unsigned size)
  {
      if (opaque) opaque = 0; /* to make compiler happy */
      return _halloc((long)items, size);
  }
  
  void  zcfree (voidpf opaque, voidpf ptr)
  {
      if (opaque) opaque = 0; /* to make compiler happy */
      _hfree(ptr);
  }
  
  #endif /* MSC */
  
  
  #ifndef MY_ZCALLOC /* Any system without a special alloc function */
  
  #ifndef STDC
  extern voidp  calloc OF((uInt items, uInt size));
  extern void   free   OF((voidpf ptr));
  #endif
